import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/unsafeHead";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/unsafeTail";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_7 from "@tsplus/stdlib/prelude/HKT";
/**
 * @tsplus static Chunk.Ops depthFirstChainRec
 */

export function depthFirstChainRec_(init, f) {
  let todo = f(init);
  let result = tsplus_module_1.empty();

  while (tsplus_module_2.size(todo) > 0) {
    const either = tsplus_module_3.unsafeHead(todo);
    todo = tsplus_module_4.unsafeTail(todo);

    if (either._tag === "Left") {
      todo = tsplus_module_5.concat(todo)(f(either.left));
    } else {
      result = tsplus_module_6.append(either.right)(result);
    }
  }

  return result;
}
/**
 * @tsplus static Chunk.Aspects depthFirstChainRec
 */

const depthFirstChainRec_1 = f => init => depthFirstChainRec_(init, f);

export const depthFirstChainRec = depthFirstChainRec_1;
/**
 * @tsplus static Chunk.Ops DepthFirstChainRec
 */

export const DepthFirstChainRec = {
  chainRec: depthFirstChainRec_1
};
/**
 * @tsplus static Chunk.Ops breadthFirstChainRec
 */

export function breadthFirstChainRec_(init, f) {
  let todo = f(init);
  let result = tsplus_module_1.empty();

  while (tsplus_module_2.size(todo) > 0) {
    const either = tsplus_module_3.unsafeHead(todo);
    todo = tsplus_module_4.unsafeTail(todo);

    if (either._tag === "Left") {
      todo = tsplus_module_5.concat(f(either.left))(todo);
    } else {
      result = tsplus_module_6.append(either.right)(result);
    }
  }

  return result;
}
/**
 * @tsplus static Chunk.Aspects breadthFirstChainRec
 */

const breadthFirstChainRec_1 = f => init => breadthFirstChainRec_(init, f);

export const breadthFirstChainRec = breadthFirstChainRec_1;
/**
 * @tsplus static Chunk.Ops BreadthFirstChainRec
 */

export const BreadthFirstChainRec = {
  chainRec: breadthFirstChainRec_1
};
//# sourceMappingURL=ChainRec.mjs.map