import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/append";
export const collect = collect_1;
import { ArrTypeId, concreteChunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns a filtered, mapped subset of the elements of this chunk.
 *
 * @tsplus static Chunk.Aspects collect
 * @tsplus pipeable Chunk collect
 */

function collect_1(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case ArrTypeId:
        {
          const array = self._arrayLike();

          let dest = tsplus_module_1.empty();

          for (let i = 0; i < array.length; i++) {
            const rhs = f(array[i]);

            if (tsplus_module_2.isSome(rhs)) {
              dest = tsplus_module_3.append(rhs.value)(dest);
            }
          }

          return dest;
        }

      default:
        {
          return collect_1(f)(self._materialize());
        }
    }
  };
}
//# sourceMappingURL=collect.mjs.map