import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/single";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/fold";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/append";
export const collectWhile = collectWhile_1;
import { ArrTypeId, concreteChunk, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Transforms all elements of the chunk for as long as the specified partial
 * function is defined.
 *
 * @tsplus static Chunk.Aspects collectWhile
 * @tsplus pipeable Chunk collectWhile
 */

function collectWhile_1(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case SingletonTypeId:
        {
          return tsplus_module_3.fold(() => tsplus_module_1.empty(), tsplus_module_2.single)(f(self.a));
        }

      case ArrTypeId:
        {
          const array = self._arrayLike();

          let dest = tsplus_module_1.empty();

          for (let i = 0; i < array.length; i++) {
            const rhs = f(array[i]);

            if (tsplus_module_4.isSome(rhs)) {
              dest = tsplus_module_5.append(rhs.value)(dest);
            } else {
              return dest;
            }
          }

          return dest;
        }

      default:
        {
          return collectWhile_1(f)(self._materialize());
        }
    }
  };
}
//# sourceMappingURL=collectWhile.mjs.map