import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
/**
 * Test if a value is a member of an array. Takes a `Equivalence<A>` as a single
 * argument which returns the function to use to search for a value of type `A`
 * in an array of type `Chunk<A>`.
 *
 * @tsplus static Chunk.Aspects elem
 * @tsplus pipeable Chunk elem
 */

export function elem(E, value) {
  return self => {
    const predicate = element => E.equals(element, value);

    for (let i = 0; i < self.length; i++) {
      if (predicate(tsplus_module_1.unsafeGet(i)(self))) {
        return true;
      }
    }

    return false;
  };
}
//# sourceMappingURL=elem.mjs.map