import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
/**
 * Fills a chunk with the result of applying `f` `n` times.
 *
 * @tsplus static Chunk.Ops fill
 */

export function fill(n, f) {
  if (n <= 0) {
    return tsplus_module_1.empty();
  }

  let builder = tsplus_module_1.empty();

  for (let i = 0; i < n; i++) {
    builder = tsplus_module_2.append(f(i))(builder);
  }

  return builder;
}
//# sourceMappingURL=fill.mjs.map