import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { ArrTypeId, concreteChunk } from "@tsplus/stdlib/collections/Chunk/definition";
export function filter(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case ArrTypeId:
        {
          const arr = self._arrayLike();

          const len = arr.length;
          let i = 0;
          let builder = tsplus_module_1.empty();

          while (i < len) {
            const elem = arr[i];

            if (f(elem)) {
              builder = tsplus_module_2.append(elem)(builder);
            }

            i++;
          }

          return builder;
        }

      default:
        {
          const iterator = self._arrayLikeIterator();

          let next;
          let builder = tsplus_module_1.empty();

          while ((next = iterator.next()) && !next.done) {
            const array = next.value;
            const len = array.length;
            let i = 0;

            while (i < len) {
              const a = array[i];

              if (f(a)) {
                builder = tsplus_module_2.append(a)(builder);
              }

              i++;
            }
          }

          return builder;
        }
    }
  };
}
//# sourceMappingURL=filter.mjs.map