import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
export function findLast(f) {
  return self => {
    const iterator = self._reverseArrayLikeIterator();

    let next;

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let i = len - 1;

      while (i >= 0) {
        const a = array[i];

        if (f(a)) {
          return tsplus_module_1.some(a);
        }

        i--;
      }
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=findLast.mjs.map