import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import { concreteChunk, concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns the last index of the element that satisfies the predicate.
 *
 * @tsplus static Chunk.Aspects findLastIndex
 * @tsplus pipeable Chunk findLastIndex
 */

export function findLastIndex(f) {
  return self => {
    void 0;

    const iterator = self._reverseArrayLikeIterator();

    let next;
    let index = self.length - 1;

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let i = len - 1;

      while (i >= 0) {
        const a = array[i];

        if (f(a)) {
          return tsplus_module_1.some(index);
        }

        i--;
        index--;
      }
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=findLastIndex.mjs.map