import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import { concreteChunk, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns a chunk with the elements mapped by the specified function.
 *
 * @tsplus static Chunk.Aspects flatMap
 * @tsplus pipeable Chunk flatMap
 */

export function flatMap(f) {
  return self => {
    void 0;

    if (self._typeId === SingletonTypeId) {
      return f(self.a);
    }

    let r = tsplus_module_1.empty();

    for (const k of self) {
      r = tsplus_module_2.concat(f(k))(r);
    }

    return r;
  };
}
//# sourceMappingURL=flatMap.mjs.map