import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Safely retrieve a value from a `Chunk`.
 *
 * @tsplus pipeable-index Chunk
 * @tsplus static Chunk.Aspects get
 * @tsplus pipeable Chunk get
 */

export function get(n) {
  return self => {
    return !Number.isInteger(n) || n < 0 || n >= self.length ? tsplus_module_1.none : tsplus_module_1.some(self._get(n));
  };
}
//# sourceMappingURL=get.mjs.map