import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/common";
import * as tsplus_module_3 from "@tsplus/stdlib/prelude/Ord/definition";
/**
 * @tsplus static Chunk.Ops getOrd
 */

export function getOrd(O) {
  return tsplus_module_3.Ord((x, y) => {
    const xLen = x.length;
    const yLen = y.length;
    const len = Math.min(xLen, yLen);

    for (let i = 0; i < len; i++) {
      const ordering = O.compare(tsplus_module_1.unsafeGet(i)(x), tsplus_module_1.unsafeGet(i)(y));

      if (ordering !== 0) {
        return ordering;
      }
    }

    return tsplus_module_2.number.compare(xLen, yLen);
  });
}
//# sourceMappingURL=getOrd.mjs.map