import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/size";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
/**
 * Groups elements in chunks of up to `n` elements.
 *
 * @tsplus static Chunk.Aspects grouped
 * @tsplus pipeable Chunk grouped
 */

export function grouped(n) {
  return self => {
    let gr = tsplus_module_1.empty();
    let current = tsplus_module_1.empty();
    tsplus_module_4.forEach(a => {
      current = tsplus_module_2.append(a)(current);

      if (tsplus_module_3.size(current) >= n) {
        gr = tsplus_module_2.append(current)(gr);
        current = tsplus_module_1.empty();
      }
    })(self);

    if (tsplus_module_3.size(current) > 0) {
      gr = tsplus_module_2.append(current)(gr);
    }

    return gr;
  };
}
//# sourceMappingURL=grouped.mjs.map