import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/elem";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/filter";
/**
 * Creates an array of unique values that are included in all given arrays using
 * an `Equivalence<A>` for equality comparisons. The order and references of
 * result values are determined by the first array.
 *
 * @tsplus static Chunk.Aspects intersection
 * @tsplus pipeable Chunk intersection
 */

export function intersection(E, that) {
  return self => tsplus_module_2.filter(a => tsplus_module_1.elem(E, a)(that))(self);
}
//# sourceMappingURL=intersection.mjs.map