import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
/**
 * Build a chunk from a sequence of values
 *
 * NOTE: different from Chunk#from this copies the elements 1 by 1
 * allowing for binary to be correctly stored in typed arrays
 *
 * @tsplus static Chunk.Ops __call
 * @tsplus static Chunk.Ops make
 */

export function make(...iter) {
  let builder = tsplus_module_1.empty();

  for (const x of iter) {
    builder = tsplus_module_2.append(x)(builder);
  }

  return builder;
}
//# sourceMappingURL=make.mjs.map