import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { concreteChunk, Singleton, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns a chunk with the elements mapped by the specified function.
 *
 * @tsplus static Chunk.Aspects map
 * @tsplus pipeable Chunk map
 */

export function map(f) {
  return self => {
    void 0;

    if (self._typeId === SingletonTypeId) {
      return new Singleton(f(self.a));
    }

    let r = tsplus_module_1.empty();

    for (const k of self) {
      r = tsplus_module_2.append(f(k))(r);
    }

    return r;
  };
}
//# sourceMappingURL=map.mjs.map