import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Statefully maps over the chunk, producing new elements of type `B`.
 *
 * @tsplus static Chunk.Aspects mapAccum
 * @tsplus pipeable Chunk mapAccum
 */

export function mapAccum(s, f) {
  return self => {
    const iterator = self._arrayLikeIterator();

    let next;
    let s1 = s;
    let builder = tsplus_module_1.empty();

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let i = 0;

      while (i < len) {
        const a = array[i];
        const x = f(s1, a);
        s1 = x[0];
        builder = tsplus_module_2.append(x[1])(builder);
        i++;
      }
    }

    return [s1, builder];
  };
}
//# sourceMappingURL=mapAccum.mjs.map