import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { concreteChunk, Singleton, SingletonTypeId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Returns a chunk with the elements mapped by the specified function.
 *
 * @tsplus static Chunk.Aspects mapWithIndex
 * @tsplus pipeable Chunk mapWithIndex
 */

export function mapWithIndex(f) {
  return self => {
    void 0;

    if (self._typeId === SingletonTypeId) {
      return new Singleton(f(0, self.a));
    }

    let r = tsplus_module_1.empty();
    let i = 0;

    for (const k of self) {
      r = tsplus_module_2.append(f(i, k))(r);
      i += 1;
    }

    return r;
  };
}
//# sourceMappingURL=mapWithIndex.mjs.map