import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Separate elements based on a map function that also exposes the index of the
 * element.
 *
 * @tsplus static Chunk.Aspects partitionMapWithIndex
 * @tsplus pipeable Chunk partitionMapWithIndex
 */

export function partitionMapWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.length; i++) {
      const e = f(i, tsplus_module_1.unsafeGet(i)(self));

      if (e._tag === "Left") {
        left.push(e.left);
      } else {
        right.push(e.right);
      }
    }

    return [tsplus_module_2.from(left), tsplus_module_2.from(right)];
  };
}
//# sourceMappingURL=partitionMapWithIndex.mjs.map