import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Separate elements based on a predicate that also exposes the index of the
 * element.
 *
 * @tsplus static Chunk.Aspects partitionWithIndex
 * @tsplus pipeable Chunk partitionWithIndex
 */

export function partitionWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.length; i++) {
      const a = tsplus_module_1.unsafeGet(i)(self);

      if (f(i, a)) {
        right.push(a);
      } else {
        left.push(a);
      }
    }

    return [tsplus_module_2.from(left), tsplus_module_2.from(right)];
  };
}
//# sourceMappingURL=partitionWithIndex.mjs.map