import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/forEach";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Splits this chunk into `n` equally sized chunks.
 *
 * @tsplus static Chunk.Aspects split
 * @tsplus pipeable Chunk split
 */

export function split(n) {
  return self => {
    const length = self.length;
    const k = Math.floor(n);
    const quotient = Math.floor(length / k);
    const remainder = length % k;
    let chunks = tsplus_module_1.empty();
    let i = 0;
    let chunk = tsplus_module_1.empty();
    tsplus_module_3.forEach(a => {
      chunk = tsplus_module_2.append(a)(chunk);

      if (i <= remainder && chunk.length > quotient || i > remainder && chunk.length >= quotient) {
        chunks = tsplus_module_2.append(chunk)(chunks);
        chunk = tsplus_module_1.empty();
      }

      i++;
    })(self);

    if (chunk.length > 0) {
      chunks = tsplus_module_2.append(chunk)(chunks);
    }

    return chunks;
  };
}
//# sourceMappingURL=split.mjs.map