import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/append";
/**
 * Constructs a `Chunk` by repeatedly applying the function `f` as long as it
 * returns `Some`.
 *
 * @tsplus static Chunk.Ops unfold
 */

export function unfold(s, f) {
  let builder = tsplus_module_1.empty();
  let cont = true;
  let s1 = s;

  while (cont) {
    const x = f(s1);

    if (tsplus_module_2.isSome(x)) {
      s1 = x[1];
      builder = tsplus_module_3.append(x[0])(builder);
    } else {
      cont = false;
    }
  }

  return builder;
}
//# sourceMappingURL=unfold.mjs.map