import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Chunk/operations/elem";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/append";
/**
 * Remove duplicates from an array, keeping the first occurrence of an element.
 *
 * @tsplus static Chunk.Aspects uniq
 * @tsplus pipeable Chunk uniq
 */

export function uniq(E) {
  return self => {
    let out = tsplus_module_1.empty();

    for (let i = 0; i < self.length; i++) {
      const a = tsplus_module_2.unsafeGet(i)(self);

      if (!tsplus_module_3.elem(E, a)(out)) {
        out = tsplus_module_4.append(a)(out);
      }
    }

    return self.length === out.length ? self : out;
  };
}
//# sourceMappingURL=uniq.mjs.map