import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/zipAllWith";
/**
 * Zips this chunk with the specified chunk to produce a new chunk with
 * pairs of elements from each chunk, filling in missing values from the
 * shorter chunk with `None`. The returned chunk will have the length of the
 * longer chunk.
 *
 * @tsplus static Chunk.Aspects zipAll
 * @tsplus pipeable Chunk zipAll
 */

export function zipAll(that) {
  return self => {
    return tsplus_module_2.zipAllWith(that, (a, b) => [tsplus_module_1.some(a), tsplus_module_1.some(b)], a => [tsplus_module_1.some(a), tsplus_module_1.none], b => [tsplus_module_1.none, tsplus_module_1.some(b)])(self);
  };
}
//# sourceMappingURL=zipAll.mjs.map