import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { concreteChunkId } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Zips this chunk with the index of every element, starting from the initial
 * index value.
 *
 * @tsplus static Chunk.Aspects zipWithIndexOffset
 * @tsplus pipeable Chunk zipWithIndexOffset
 */

export function zipWithIndexOffset(offset) {
  return self => {
    const iterator = self._arrayLikeIterator();

    let next;
    let i = offset;
    let builder = tsplus_module_1.empty();

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let j = 0;

      while (j < len) {
        const a = array[j];
        builder = tsplus_module_2.append([a, i])(builder);
        j++;
        i++;
      }
    }

    return builder;
  };
}
//# sourceMappingURL=zipWithIndexOffset.mjs.map