var _a;

export const ChunkPatchSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch");
export const ChunkPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch.Value");
export const ChunkPatchPatchSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch.Patch");
/**
 * @tsplus static Differ.Ops Chunk
 */

export const ChunkPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.Chunk.Patch
 */

export function unifyChunkPatch(self) {
  return self;
}
export class BaseChunkPatch {
  constructor() {
    this[_a] = ChunkPatchSym;
  }

}
_a = ChunkPatchSym;
export class AppendChunkPatch extends BaseChunkPatch {
  constructor(values) {
    super();
    this.values = values;
    this._tag = "Append";
  }

}
export class SliceChunkPatch extends BaseChunkPatch {
  constructor(from, until) {
    super();
    this.from = from;
    this.until = until;
    this._tag = "Slice";
  }

}
export class UpdateChunkPatch extends BaseChunkPatch {
  constructor(index, patch) {
    super();
    this.index = index;
    this.patch = patch;
    this._tag = "Update";
  }

}
export class AndThenChunkPatch extends BaseChunkPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}
export class EmptyChunkPatch extends BaseChunkPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}
/**
 * @tsplus macro identity
 */

export function chunkPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.mjs.map