import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/mutate";
/**
 * Maps over the entries of the `HashMap` using the specified partial function
 * and filters out `None` values.
 *
 * @tsplus static HashMap.Aspects collectWithIndex
 * @tsplus pipeable HashMap collectWithIndex
 */

export function collectWithIndex(f) {
  return self => {
    const m = tsplus_module_1.empty();
    return tsplus_module_4.mutate_(m => {
      for (const [k, a] of self) {
        const o = f(k, a);

        if (tsplus_module_2.isSome(o)) {
          tsplus_module_3.set(k, o.value)(m);
        }
      }
    })(m);
  };
}
//# sourceMappingURL=collectWithIndex.mjs.map