import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/forEachWithIndex";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/mutate";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashMap/operations/reduceWithIndex";
/**
 * Chains over the entries of the `HashMap` using the specified function.
 *
 * **NOTE**: the hash and equal of both maps have to be the same.
 *
 * @tsplus static HashMap.Aspects flatMapWithIndex
 * @tsplus pipeable HashMap flatMapWithIndex
 */

export function flatMapWithIndex(f) {
  return self => {
    return tsplus_module_5.reduceWithIndex(tsplus_module_1.empty(), (z, k, v) => tsplus_module_4.mutate_(m => {
      tsplus_module_3.forEachWithIndex((_k, _a) => {
        tsplus_module_2.set(_k, _a)(m);
      })(f(k, v));
    })(z))(self);
  };
}
//# sourceMappingURL=flatMapWithIndex.mjs.map