import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/beginMutation";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/endMutation";
/**
 * Constructs a new `HashMap` from an array of key/value pairs.
 *
 * @tsplus static HashMap.Ops from
 */

export function from(entries) {
  const map = tsplus_module_2.beginMutation(tsplus_module_1.empty());

  for (const entry of entries) {
    tsplus_module_3.set(entry[0], entry[1])(map);
  }

  return tsplus_module_4.endMutation(map);
}
//# sourceMappingURL=from.mjs.map