import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/update";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/reduceWithIndex";
import * as tsplus_module_5 from "@tsplus/stdlib/prelude/Associative/definition";
/**
 * Given an `Associative<V>` (a way to combine `V`'s, get an `Associative` to combine `<HashMap<K, V>>`'s
 * This preserves keys in both maps `V`
 *
 * @tsplus static HashMap.Ops getAssociative
 */

export function getAssociative(A) {
  return tsplus_module_5.Associative((x, y) => tsplus_module_4.reduceWithIndex(x, (z, key, vy) => tsplus_module_1.has_(z, key) ? tsplus_module_2.update(key, vx => A.combine(vx, vy))(z) : tsplus_module_3.set(key, vy)(z))(y));
}
//# sourceMappingURL=getAssociative.mjs.map