import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/modifyHash";
/**
 * Alter the value of the specified key in the `HashMap` using the specified
 * update function. The value of the specified key will be computed using the
 * provided hash.
 *
 * The update function will be invoked with the current value of the key if it
 * exists, or `None` if no such value exists.
 *
 * This function will always either update or insert a value into the `HashMap`.
 *
 * @tsplus static HashMap.Aspects modify
 * @tsplus pipeable HashMap modify
 */

export function modify(key, f) {
  return self => tsplus_module_2.modifyHash(key, tsplus_module_1.hashUnknown(key), f)(self);
}
//# sourceMappingURL=modify.mjs.map