import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/beginMutation";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/endMutation";
/**
 * Mutates the `HashMap` within the context of the provided function.
 *
 * @tsplus static HashMap.Aspects mutate
 * @tsplus pipeable HashMap mutate
 */

export function mutate_(f) {
  return self => {
    const transient = tsplus_module_1.beginMutation(self);
    f(transient);
    return tsplus_module_2.endMutation(transient);
  };
}
//# sourceMappingURL=mutate.mjs.map