import { visitLazy as visitLazyInternal, visitLazyChildren as visitLazyChildrenInternal } from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import { ArrayNode, canEditNode as canEditNodeInternal, CollisionNode, EmptyNode, IndexedNode, isEmptyNode as isEmptyNodeInternal, isLeafNode as isLeafNodeInternal, LeafNode } from "@tsplus/stdlib/collections/HashMap/_internal/node";
export { Node } from "@tsplus/stdlib/collections/HashMap/_internal/node";
/**
 * @tsplus static HashMap.Node.Ops empty
 */

export function emptyNode() {
  return new EmptyNode();
}
/**
 * @tsplus static HashMap.Node.Ops leaf
 */

export function leafNode(edit, hash, key, value) {
  return new LeafNode(edit, hash, key, value);
}
/**
 * @tsplus static HashMap.Node.Ops collision
 */

export function collisionNode(edit, hash, children) {
  return new CollisionNode(edit, hash, children);
}
/**
 * @tsplus static HashMap.Node.Ops indexed
 */

export function indexedNode(edit, mask, children) {
  return new IndexedNode(edit, mask, children);
}
/**
 * @tsplus static HashMap.Node.Ops array
 */

export function arrayNode(edit, size, children) {
  return new ArrayNode(edit, size, children);
} // -----------------------------------------------------------------------------
// Type Guards
// -----------------------------------------------------------------------------

/**
 * @tsplus static HashMap.Node.Ops isEmptyNode
 */

export const isEmptyNode = isEmptyNodeInternal;
/**
 * @tsplus static HashMap.Node.Ops isLeafNode
 */

export const isLeafNode = isLeafNodeInternal; // -----------------------------------------------------------------------------
// Operations
// -----------------------------------------------------------------------------

/**
 * @tsplus pipeable HashMap.Node canEdit
 */

export function canEditNode(edit) {
  return node => canEditNodeInternal(node, edit);
}
/**
 * @tsplus pipeable HashMap.Node visitLazy
 */

export function visitLazy(f, cont) {
  return node => visitLazyInternal(node, f);
}
/**
 * @tsplus fluent HashMap.Node.Ops visitLazyChildren
 */

export const visitLazyChildren = visitLazyChildrenInternal;
//# sourceMappingURL=node.mjs.map