import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/node";
import { realHashMap } from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
/**
 * Reduces the specified state over the entries of the `HashMap`.
 *
 * @tsplus static HashMap.Aspects reduceWithIndex
 * @tsplus pipeable HashMap reduceWithIndex
 */

export function reduceWithIndex(z, f) {
  return self => {
    void 0;
    const root = self._root;

    if (root._tag === "LeafNode") {
      return tsplus_module_1.isSome(root.value) ? f(z, root.key, root.value.value) : z;
    }

    if (root._tag === "EmptyNode") {
      return z;
    }

    const toVisit = [root.children];
    let children;

    while (children = toVisit.pop()) {
      for (let i = 0, len = children.length; i < len;) {
        const child = children[i++];

        if (child && !tsplus_module_2.isEmptyNode(child)) {
          if (child._tag === "LeafNode") {
            if (tsplus_module_1.isSome(child.value)) {
              z = f(z, child.key, child.value.value);
            }
          } else toVisit.push(child.children);
        }
      }
    }

    return z;
  };
}
//# sourceMappingURL=reduceWithIndex.mjs.map