import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/remove";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/mutate";
/**
 * Removes all entries in the `HashMap` which have the specified keys.
 *
 * @tsplus static HashMap.Aspects removeMany
 * @tsplus pipeable HashMap removeMany
 */

export function removeMany(ks) {
  return self => tsplus_module_2.mutate_(m => {
    for (const k of ks) {
      tsplus_module_1.remove(k)(m);
    }
  })(self);
}
//# sourceMappingURL=removeMany.mjs.map