import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/beginMutation";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/operations/set";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/forEachWithIndex";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/operations/endMutation";
/**
 * Performs a union of this `HashMap` and that `HashMap`.
 *
 * @tsplus pipeable-operator HashMap +
 * @tsplus static HashMap.Aspects union
 * @tsplus pipeable HashMap union
 */

export function union(that) {
  return self => {
    const result = tsplus_module_1.beginMutation(self);
    tsplus_module_3.forEachWithIndex((k, v) => {
      tsplus_module_2.set(k, v)(result);
    })(that);
    return tsplus_module_4.endMutation(result);
  };
}
//# sourceMappingURL=union.mjs.map