import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_4 from "@tsplus/stdlib/exceptions";
/**
 * Unsafely lookup the value for the specified key in the `HashMap` using the
 * internal hashing function.
 *
 * @tsplus static HashMap.Aspects unsafeGet
 * @tsplus pipeable HashMap unsafeGet
 */

export function unsafeGet(key) {
  return self => {
    const element = tsplus_module_2.getHash_(self, key, tsplus_module_1.hashUnknown(key));

    if (tsplus_module_3.isNone(element)) {
      throw new tsplus_module_4.NoSuchElement();
    }

    return element.value;
  };
}
//# sourceMappingURL=unsafeGet.mjs.map