var _a;

export const HashMapPatchSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch");
export const HashMapPatchKeySym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Key");
export const HashMapPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Value");
export const HashMapPatchPatchSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Patch");
/**
 * @tsplus static Differ.Ops HashMap
 */

export const HashMapPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.HashMap.Patch
 */

export function unifyHashMapPatch(self) {
  return self;
}
export class BaseHashMapPatch {
  constructor() {
    this[_a] = HashMapPatchSym;
  }

}
_a = HashMapPatchSym;
export class AddHashMapPatch extends BaseHashMapPatch {
  constructor(key, value) {
    super();
    this.key = key;
    this.value = value;
    this._tag = "Add";
  }

}
export class RemoveHashMapPatch extends BaseHashMapPatch {
  constructor(key) {
    super();
    this.key = key;
    this._tag = "Remove";
  }

}
export class UpdateHashMapPatch extends BaseHashMapPatch {
  constructor(key, patch) {
    super();
    this.key = key;
    this.patch = patch;
    this._tag = "Update";
  }

}
export class EmptyHashMapPatch extends BaseHashMapPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}
export class AndThenHashMapPatch extends BaseHashMapPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}
/**
 * @tsplus macro identity
 */

export function hashMapPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.mjs.map