import * as tsplus_module_1 from "@tsplus/stdlib/data/Differ/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/patch/operations/emptyPatch";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/operations/get";
import * as tsplus_module_4 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashMap/operations/remove";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/HashMap/patch/operations/combine";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/HashMap/operations/reduceWithIndex";
import { AddHashMapPatch, RemoveHashMapPatch, UpdateHashMapPatch } from "@tsplus/stdlib/collections/HashMap/patch/definition";
/**
 * Constructs a map patch from a new and old map of keys and values and a
 * differ for the values.
 *
 * @tsplus static Differ.HashMap.Patch.Ops diff
 */

export function diff(oldValue, newValue, differ) {
  const [removed, patch] = tsplus_module_7.reduceWithIndex([oldValue, tsplus_module_2.emptyPatch()], ([map, patch], key, newValue) => {
    const maybe = tsplus_module_3.get(key)(map);

    switch (maybe._tag) {
      case "Some":
        {
          const valuePatch = differ.diff(maybe.value, newValue);

          if (tsplus_module_4.equals(valuePatch, differ.empty)) {
            return [tsplus_module_5.remove(key)(map), patch];
          }

          return [tsplus_module_5.remove(key)(map), tsplus_module_6.combine(new UpdateHashMapPatch(key, valuePatch))(patch)];
        }

      case "None":
        {
          return [map, tsplus_module_6.combine(new AddHashMapPatch(key, newValue))(patch)];
        }
    }
  })(newValue);
  return tsplus_module_7.reduceWithIndex(patch, (patch, key, _) => tsplus_module_6.combine(new RemoveHashMapPatch(key))(patch))(removed);
}
//# sourceMappingURL=diff.mjs.map