import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/remove";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/mutate";
/**
 * Computes the set difference between this `HashSet` and the specified
 * `Iterable<A>`.
 *
 * **NOTE**: the hash and equal of the values in both the set and the iterable
 * must be the same.
 *
 * @tsplus static HashSet.Aspects difference
 * @tsplus pipeable HashSet difference
 */

export function difference(that) {
  return self => tsplus_module_2.mutate(s => {
    for (const k of that) {
      tsplus_module_1.remove(k)(s);
    }
  })(self);
}
//# sourceMappingURL=difference.mjs.map