import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashMap/operations/size";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/_internal/hashMap";
import { realHashSet } from "@tsplus/stdlib/collections/HashSet/_internal/hashSet";
/**
 * Determines if two `HashSet`s are equivalent.
 *
 * @tsplus pipeable-operator HashSet ==
 * @tsplus static HashSet.Aspects equals
 * @tsplus pipeable HashSet equals
 */

export function equals(that) {
  return self => {
    if (self === that) {
      return true;
    }

    void 0;
    void 0;

    if (tsplus_module_1.size(self._keyMap) !== tsplus_module_1.size(that._keyMap)) {
      return false;
    }

    let eq = true;

    for (const vx of self) {
      if (!tsplus_module_2.has_(that._keyMap, vx)) {
        eq = false;
        break;
      }
    }

    return eq;
  };
}
//# sourceMappingURL=equals.mjs.map