import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/forEach";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/operations/mutate";
/**
 * Chains over the values of the `HashSet` using the specified function.
 *
 * @tsplus static HashSet.Aspects flatMap
 * @tsplus pipeable HashSet flatMap
 */

export function flatMap(f) {
  return self => {
    const set = tsplus_module_1.empty();
    return tsplus_module_5.mutate(_ => {
      tsplus_module_4.forEach(a => {
        for (const b of f(a)) {
          if (!tsplus_module_2.has(b)(_)) {
            tsplus_module_3.add(b)(_);
          }
        }
      })(self);
    })(set);
  };
}
//# sourceMappingURL=flatMap.mjs.map