import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/beginMutation";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/endMutation";
/**
 * Construct a new `HashSet` from a `Collection` of values
 *
 * @tsplus static HashSet.Ops from
 * @tsplus getter Collection toHashSet
 * @tsplus getter List toHashSet
 */

export function from(elements) {
  const set = tsplus_module_2.beginMutation(tsplus_module_1.empty());

  for (const v of elements) {
    tsplus_module_3.add(v)(set);
  }

  return tsplus_module_4.endMutation(set);
}
//# sourceMappingURL=from.mjs.map