import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/mutate";
/**
 * Returns a `HashSet` of values which are present in both this set and that
 * `Iterable<A>`.
 *
 * **NOTE**: the hash and equal of the values in both the set and the iterable
 * must be the same.
 *
 * @tsplus static HashSet.Aspects intersection
 * @tsplus pipeable HashSet intersection
 */

export function intersection(that) {
  return self => {
    const set = tsplus_module_1.empty();
    return tsplus_module_4.mutate(_ => {
      for (const k of that) {
        if (tsplus_module_2.has(k)(self)) {
          tsplus_module_3.add(k)(_);
        }
      }
    })(set);
  };
}
//# sourceMappingURL=intersection.mjs.map