import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/every";
/**
 * Returns `true` if and only if every element in the this `HashSet` is an
 * element of the second set,
 *
 * **NOTE**: the hash and equal of both sets must be the same.
 *
 * @tsplus static HashSet.Aspects isSubset
 * @tsplus pipeable HashSet isSubset
 */

export function isSubset(that) {
  return self => tsplus_module_2.every(a => tsplus_module_1.has(a)(that))(self);
}
//# sourceMappingURL=isSubset.mjs.map