import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/forEach";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/operations/mutate";
/**
 * Maps over the values of the `HashSet` using the specified function.
 *
 * @tsplus static HashSet.Aspects map
 * @tsplus pipeable HashSet map
 */

export function map(f) {
  return self => {
    const set = tsplus_module_1.empty();
    return tsplus_module_5.mutate(_ => {
      tsplus_module_4.forEach(e => {
        const v = f(e);

        if (!tsplus_module_2.has(v)(_)) {
          tsplus_module_3.add(v)(_);
        }
      })(self);
    })(set);
  };
}
//# sourceMappingURL=map.mjs.map