import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/beginMutation";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/endMutation";
/**
 * Mutates the `HashSet` within the context of the provided function.
 *
 * @tsplus static HashSet.Aspects mutate
 * @tsplus pipeable HashSet mutate
 */

export function mutate(f) {
  return self => {
    const transient = tsplus_module_1.beginMutation(self);
    f(transient);
    return tsplus_module_2.endMutation(transient);
  };
}
//# sourceMappingURL=mutate.mjs.map