/**
 * Returns `true` if any value in the `HashSet` matches the specified predicate.
 *
 * @tsplus static HashSet.Aspects some
 * @tsplus pipeable HashSet some
 */
export function some(f) {
  return self => {
    let found = false;

    for (const v of self) {
      found = f(v);

      if (found) {
        break;
      }
    }

    return found;
  };
}
//# sourceMappingURL=some.mjs.map