import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/remove";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/add";
/**
 * Checks if a value is present in the `HashSet`. If it is present, the value
 * will be removed from the `HashSet`, otherwise the value will be added to the
 * `HashSet`.
 *
 * @tsplus static HashSet.Aspects toggle
 * @tsplus pipeable HashSet toggle
 */

export function toggle(value) {
  return self => tsplus_module_1.has(value)(self) ? tsplus_module_2.remove(value)(self) : tsplus_module_3.add(value)(self);
}
//# sourceMappingURL=toggle.mjs.map