import * as tsplus_module_1 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/operations/add";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/forEach";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/mutate";
/**
 * Computes the set union `(`self` + `that`)` between this `HashSet` and the
 * specified `Iterable<A>`.
 *
 * **NOTE**: the hash and equal of the values in both the set and the iterable
 * must be the same.
 *
 * @tsplus static HashSet.Aspects union
 * @tsplus pipeable HashSet union
 */

export function union(that) {
  return self => {
    const set = tsplus_module_1.empty();
    return tsplus_module_4.mutate(_ => {
      tsplus_module_3.forEach(a => {
        tsplus_module_2.add(a)(_);
      })(self);

      for (const a of that) {
        tsplus_module_2.add(a)(_);
      }
    })(set);
  };
}
//# sourceMappingURL=union.mjs.map