import * as tsplus_module_1 from "@tsplus/stdlib/data/Differ/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/patch/operations/emptyPatch";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/operations/has";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/operations/remove";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/patch/operations/combine";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/HashSet/operations/reduce";
import { AddHashSetPatch, RemoveHashSetPatch } from "@tsplus/stdlib/collections/HashSet/patch/definition";
/**
 * Constructs a set patch from a new set of values.
 *
 * @tsplus static Differ.HashSet.Patch.Ops diff
 */

export function diff(oldValue, newValue) {
  const [removed, patch] = tsplus_module_6.reduce([oldValue, tsplus_module_2.emptyPatch()], ([set, patch], value) => {
    if (tsplus_module_3.has(value)(set)) {
      return [tsplus_module_4.remove(value)(set), patch];
    }

    return [set, tsplus_module_5.combine(new AddHashSetPatch(value))(patch)];
  })(newValue);
  return tsplus_module_6.reduce(patch, (patch, value) => tsplus_module_5.combine(new RemoveHashSetPatch(value))(patch))(removed);
}
//# sourceMappingURL=diff.mjs.map