import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/from";
/**
 * Filters the `ImmutableArray` and maps the output using the specified
 * function.
 *
 * @tsplus static ImmutableArray.Aspects collectWithIndex
 * @tsplus pipeable ImmutableArray collectWithIndex
 */

export function collectWithIndex(f) {
  return self => {
    const results = [];

    for (let i = 0; i < self.array.length; i = i + 1) {
      const optionB = f(i, self.array[i]);

      if (optionB._tag === "Some") {
        results.push(optionB.value);
      }
    }

    return tsplus_module_1.from(results);
  };
}
//# sourceMappingURL=collectWithIndex.mjs.map