import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Hash";
/**
 * @tsplus type ImmutableArray
 * @tsplus companion ImmutableArray.Ops
 */

export class ImmutableArray {
  constructor(array) {
    this.array = array;
  }

  [Symbol.iterator]() {
    return this.array[Symbol.iterator]();
  }

  [tsplus_module_1.Equals.sym](other) {
    return other instanceof ImmutableArray && this.array.length === other.array.length && this.array.every((v, i) => tsplus_module_1.equals(v, other.array[i]));
  }

  [tsplus_module_2.Hash.sym]() {
    return tsplus_module_2.hashArray(this.array);
  }

}
/**
 * @tsplus static ImmutableArray.Ops $
 */

export const ImmutableArrayAspects = {};
//# sourceMappingURL=definition.mjs.map