import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/elem";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/filter";
/**
 * Creates an `ImmutableArray<A>` of values not included in that
 * `ImmutableArray<A>` using an `Equivalence<A>` for equality comparisons. The
 * order and references of result values are determined by the first array.
 *
 * @tsplus static ImmutableArray.Aspects difference
 * @tsplus pipeable ImmutableArray difference
 */

export function difference(E, that) {
  return self => tsplus_module_2.filter(a => !tsplus_module_1.elem(E, a)(that))(self);
}
//# sourceMappingURL=difference.mjs.map