import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/from";
/**
 * Extends calls f with all the progressive slices up to the current element's
 * index, and uses the return value to construct the result array (i.e: like
 * `map` that also consumes all the elements up to `i`).
 *
 * @tsplus static ImmutableArray.Aspects extend
 * @tsplus pipeable ImmutableArray extend
 */

export function extend(f) {
  return self => tsplus_module_1.from(self.array.map((_, i, as) => f(tsplus_module_1.from(as.slice(i)))));
}
//# sourceMappingURL=extend.mjs.map