import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Ord/common";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/definition";
/**
 * Returns a `Ord` for an `ImmutableArray<A>` given an `Ord<A>`.
 *
 * @tsplus static ImmutableArray.Ops getOrd
 */

export function getOrd(O) {
  return tsplus_module_2.Ord((a, b) => {
    const aLen = a.array.length;
    const bLen = b.array.length;
    const len = Math.min(aLen, bLen);

    for (let i = 0; i < len; i = i + 1) {
      const ordering = O.compare(a.array[i], b.array[i]);

      if (ordering !== 0) {
        return ordering;
      }
    }

    return tsplus_module_1.number.compare(aLen, bLen);
  });
}
//# sourceMappingURL=getOrd.mjs.map