import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/HKT";
export const depthFirstChainRec = depthFirstChainRec_1;
export const breadthFirstChainRec = breadthFirstChainRec_1;
/**
 * @tsplus static ImmutableArray.Ops depthFirstChainRec
 */

function depthFirstChainRec_1(a, f) {
  const todo = [...f(a)];
  const result = [];

  while (todo.length > 0) {
    const e = todo.shift();

    if (e._tag === "Left") {
      todo.unshift(...f(e.left));
    } else {
      result.push(e.right);
    }
  }

  return new tsplus_module_1.ImmutableArray(result);
}
/**
 * @tsplus static ImmutableArray.Ops DepthFirstChainRec
 */


export const DepthFirstChainRec = {
  chainRec: f => a => depthFirstChainRec_1(a, f)
};
/**
 * @tsplus static ImmutableArray.Ops breadthFirstChainRec
 */

function breadthFirstChainRec_1(a, f) {
  const initial = f(a);
  const todo = [];
  const result = [];

  for (const e of initial) {
    if (e._tag === "Left") {
      f(e.left).array.forEach(v => todo.push(v));
    } else {
      result.push(e.right);
    }
  }

  while (todo.length > 0) {
    const e = todo.shift();

    if (e._tag === "Left") {
      f(e.left).array.forEach(v => todo.push(v));
    } else {
      result.push(e.right);
    }
  }

  return new tsplus_module_1.ImmutableArray(result);
}
/**
 * @tsplus static ImmutableArray.Ops BreadthFirstChainRec
 */


export const BreadthFirstChainRec = {
  chainRec: f => a => breadthFirstChainRec_1(a, f)
};
//# sourceMappingURL=ChainRec.mjs.map