import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/elem";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/filter";
/**
 * Creates an `ImmutableArray<A>` of unique values that are included in the
 * given arrays using the specified `Equivalence` for equality comparisons.
 * The order and references of result values are determined by the first array.
 *
 * @tsplus static ImmutableArray.Aspects intersection
 * @tsplus pipeable ImmutableArray intersection
 */

export function intersection(E, that) {
  return self => tsplus_module_2.filter(a => tsplus_module_1.elem(E, a)(that))(self);
}
//# sourceMappingURL=intersection.mjs.map