import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Separate elements based on a map function that also exposes the index.
 *
 * @tsplus static ImmutableArray.Aspects partitionMapWithIndex
 * @tsplus pipeable ImmutableArray partitionMapWithIndex
 */

export function partitionMapWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.array.length; i = i + 1) {
      const e = f(i, self.array[i]);

      if (e._tag === "Left") {
        left.push(e.left);
      } else {
        right.push(e.right);
      }
    }

    return [new tsplus_module_1.ImmutableArray(left), new tsplus_module_1.ImmutableArray(right)];
  };
}
//# sourceMappingURL=partitionMapWithIndex.mjs.map