import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Separate elements based on a predicate that also exposes the index.
 *
 * @tsplus static ImmutableArray.Aspects partitionWithIndex
 * @tsplus pipeable ImmutableArray partitionWithIndex
 */

export function partitionWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.array.length; i = i + 1) {
      const a = self.array[i];

      if (f(i, a)) {
        right.push(a);
      } else {
        left.push(a);
      }
    }

    return [new tsplus_module_1.ImmutableArray(left), new tsplus_module_1.ImmutableArray(right)];
  };
}
//# sourceMappingURL=partitionWithIndex.mjs.map