import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Ord/consecutive";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/sort";
/**
 * Sort the elements of an `ImmutableArray<A>` in increasing order, where
 * elements are compared using first `ords[0]`, then `ords[1]`, then `ords[2]`,
 * etc.
 *
 * @tsplus static ImmutableArray.Aspects sortBy
 * @tsplus pipeable ImmutableArray sortBy
 */

export function sortBy(...ords) {
  return self => {
    const O = tsplus_module_1.consecutive(...ords);
    return tsplus_module_2.sort(O)(self);
  };
}
//# sourceMappingURL=sortBy.mjs.map