import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/elem";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/filter";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/ImmutableArray/concat";
/**
 * Creates an `ImmutableArray<A>` of unique values, in order, from the given
 * arrays using the specified `Equivalence<A>` for equality comparisons.
 *
 * @tsplus static ImmutableArray.Aspects union
 * @tsplus pipeable ImmutableArray union
 */

export function union(E, that) {
  return self => tsplus_module_3.concat(tsplus_module_2.filter(a => !tsplus_module_1.elem(E, a)(self))(that))(self);
}
//# sourceMappingURL=union.mjs.map