import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Remove duplicates from an array, keeping the first occurrence of an element.
 *
 * @tsplus static ImmutableArray.Aspects uniq
 * @tsplus pipeable ImmutableArray uniq
 */

export function uniq(E) {
  return self => {
    const includes = arrayIncludes(E);
    const result = [];
    const length = self.array.length;
    let i = 0;

    for (; i < length; i = i + 1) {
      const a = self.array[i];

      if (!includes(result, a)) {
        result.push(a);
      }
    }

    return length === result.length ? self : new tsplus_module_1.ImmutableArray(result);
  };
}

function arrayIncludes(E) {
  return (array, value) => {
    for (let i = 0; i < array.length; i = i + 1) {
      const element = array[i];

      if (E.equals(value, element)) {
        return true;
      }
    }

    return false;
  };
}
//# sourceMappingURL=uniq.mjs.map