import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Filters out `None` values from a map whose values are of type `Maybe<V>`.
 *
 * @tsplus getter ImmutableMap compact
 */

export function compact(self) {
  const map = new Map();

  for (const [key, value] of self.internalMap) {
    if (tsplus_module_1.isSome(value)) {
      map.set(key, value.value);
    }
  }

  return new tsplus_module_2.ImmutableMap(map);
}
//# sourceMappingURL=compact.mjs.map