import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Applies the specified partial function to each entry of the map, filtering
 * out `None` values.
 *
 * @tsplus static ImmutableMap.Aspects filterMapWithIndex
 * @tsplus pipeable ImmutableMap filterMapWithIndex
 */

export function filterMapWithIndex(pf) {
  return self => {
    const map = new Map();

    for (const [key, value] of self.internalMap) {
      const result = pf(key, value);

      if (tsplus_module_1.isSome(result)) {
        map.set(key, result.value);
      }
    }

    return new tsplus_module_2.ImmutableMap(map);
  };
}
//# sourceMappingURL=filterMapWithIndex.mjs.map