import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Transforms the values of the map using the specified function.
 *
 * @tsplus static ImmutableMap.Aspects map
 * @tsplus pipeable ImmutableMap map
 */

export function map(f) {
  return self => {
    const map = new Map();

    for (const [key, value] of self.internalMap) {
      map.set(key, f(value));
    }

    return new tsplus_module_1.ImmutableMap(map);
  };
}
//# sourceMappingURL=map.mjs.map