import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Transforms the values of the map using the specified function.
 *
 * @tsplus static ImmutableMap.Aspects mapWithIndex
 * @tsplus pipeable ImmutableMap mapWithIndex
 */

export function mapWithIndex(f) {
  return self => {
    const map = new Map();

    for (const [key, value] of self.internalMap) {
      map.set(key, f(key, value));
    }

    return new tsplus_module_1.ImmutableMap(map);
  };
}
//# sourceMappingURL=mapWithIndex.mjs.map