import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableMap/copy";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Removes the key/value pair associated with the specified key from the map.
 *
 * @tsplus static ImmutableMap.Aspects remove
 * @tsplus pipeable ImmutableMap remove
 */

export function remove(key) {
  return self => {
    const map = tsplus_module_1.copy(self).internalMap;
    map.delete(key);
    return new tsplus_module_2.ImmutableMap(map);
  };
}
//# sourceMappingURL=remove.mjs.map