import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableMap/copy";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Removes all key/value pairs associated with the keys in the specified
 * collection from the map.
 *
 * @tsplus static ImmutableMap.Aspects removeMany
 * @tsplus pipeable ImmutableMap removeMany
 */

export function removeMany(keys) {
  return self => {
    const map = tsplus_module_1.copy(self).internalMap;

    for (const key of keys) {
      map.delete(key);
    }

    return new tsplus_module_2.ImmutableMap(map);
  };
}
//# sourceMappingURL=removeMany.mjs.map