import * as tsplus_module_1 from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Performs a union of this `ImmutableMap` and that `ImmutableMap`.
 *
 * @tsplus pipeable-operator ImmutableMap +
 * @tsplus static ImmutableMap.Aspects union
 * @tsplus pipeable ImmutableMap union
 */

export function union(that) {
  return self => {
    const result = new Map(self.internalMap);
    that.internalMap.forEach((v, k) => {
      result.set(k, v);
    });
    return new tsplus_module_1.ImmutableMap(result);
  };
}
//# sourceMappingURL=union.mjs.map