import * as tsplus_module_1 from "@tsplus/stdlib/exceptions";
/**
 * Returns a `Some` containing the value associated with the specified key from
 * the map, or `None` if the key/value pair is not present within the map.
 *
 * @tsplus static ImmutableMap.Aspects unsafeGet
 * @tsplus pipeable ImmutableMap unsafeGet
 */

export function unsafeGet(key) {
  return self => {
    if (!self.internalMap.has(key)) {
      throw new tsplus_module_1.NoSuchElement();
    }

    return self.internalMap.get(key);
  };
}
//# sourceMappingURL=unsafeGet.mjs.map