import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
/**
 * Drops the first `n` elements.
 *
 * @tsplus static List.Aspects drop
 * @tsplus pipeable List drop
 */

export function drop(n) {
  return self => {
    if (n <= 0) {
      return self;
    }

    if (n >= tsplus_module_1.length(self)) {
      return tsplus_module_1.nil();
    }

    let these = self;
    let i = 0;

    while (!tsplus_module_1.isNil(these) && i < n) {
      these = these.tail;
      i += 1;
    }

    return these;
  };
}
//# sourceMappingURL=drop.mjs.map