import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/unsafeHead";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/unsafeTail";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Function";
export function filter(p) {
  return self => filterCommon_(self, p, false);
}

function noneIn(l, p, isFlipped) {
  /* eslint-disable no-constant-condition */
  while (true) {
    if (tsplus_module_1.isNil(l)) {
      return tsplus_module_1.nil();
    } else {
      if (p(l.head) !== isFlipped) {
        return allIn(l, l.tail, p, isFlipped);
      } else {
        l = l.tail;
      }
    }
  }
}

function allIn(start, remaining, p, isFlipped) {
  /* eslint-disable no-constant-condition */
  while (true) {
    if (tsplus_module_1.isNil(remaining)) {
      return start;
    } else {
      if (p(remaining.head) !== isFlipped) {
        remaining = remaining.tail;
      } else {
        return partialFill(start, remaining, p, isFlipped);
      }
    }
  }
}

function partialFill(origStart, firstMiss, p, isFlipped) {
  const newHead = tsplus_module_1.cons(tsplus_module_2.unsafeHead(origStart), tsplus_module_1.nil());
  let toProcess = tsplus_module_3.unsafeTail(origStart);
  let currentLast = newHead;

  while (!(toProcess === firstMiss)) {
    const newElem = tsplus_module_1.cons(tsplus_module_2.unsafeHead(toProcess), tsplus_module_1.nil());
    currentLast.tail = newElem;
    currentLast = newElem;
    toProcess = toProcess.tail;
  }

  let next = firstMiss.tail;
  let nextToCopy = next;

  while (!tsplus_module_1.isNil(next)) {
    const head = tsplus_module_2.unsafeHead(next);

    if (p(head) !== isFlipped) {
      next = next.tail;
    } else {
      while (!(nextToCopy === next)) {
        const newElem = tsplus_module_1.cons(tsplus_module_2.unsafeHead(nextToCopy), tsplus_module_1.nil());
        currentLast.tail = newElem;
        currentLast = newElem;
        nextToCopy = nextToCopy.tail;
      }

      nextToCopy = next.tail;
      next = next.tail;
    }
  }

  if (!tsplus_module_1.isNil(nextToCopy)) {
    currentLast.tail = nextToCopy;
  }

  return newHead;
}

function filterCommon_(list, p, isFlipped) {
  return noneIn(list, p, isFlipped);
}
//# sourceMappingURL=filter.mjs.map