import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
/**
 * @tsplus static List.Aspects flatMap
 * @tsplus pipeable List flatMap
 */

export function flatMap(f) {
  return self => {
    let rest = self;
    let h = undefined;
    let t = undefined;

    while (!tsplus_module_1.isNil(rest)) {
      let bs = f(rest.head);

      while (!tsplus_module_1.isNil(bs)) {
        const nx = tsplus_module_1.cons(bs.head, tsplus_module_1.nil());

        if (t === undefined) {
          h = nx;
        } else {
          t.tail = nx;
        }

        t = nx;
        bs = bs.tail;
      }

      rest = rest.tail;
    }

    if (h === undefined) return tsplus_module_1.nil();else return h;
  };
}
//# sourceMappingURL=flatMap.mjs.map