/**
 * Determines whether a predicate is satisfied for all elements of this List.
 *
 * @tsplus static List.Aspects forAll
 * @tsplus pipeable List forAll
 */
export function forAll(f) {
  return self => {
    for (const a of self) {
      if (!f(a)) {
        return false;
      }
    }

    return true;
  };
}
//# sourceMappingURL=forAll.mjs.map