/**
 * Determines whether a predicate is satisfied for all elements of this List.
 *
 * @tsplus static List.Aspects forAny
 * @tsplus pipeable List forAny
 */
export function forAny(f) {
  return self => {
    for (const a of self) {
      if (f(a)) {
        return true;
      }
    }

    return false;
  };
}
//# sourceMappingURL=forAny.mjs.map