import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
export const from = from_1;
/**
 * Constructs a new `List` from an `Iterable`
 *
 * @tsplus static List.Ops from
 * @tsplus getter Collection toList
 */

function from_1(prefix) {
  const iter = prefix[Symbol.iterator]();
  let a;

  if (!(a = iter.next()).done) {
    const result = tsplus_module_1.cons(a.value, tsplus_module_1.nil());
    let curr = result;

    while (!(a = iter.next()).done) {
      const temp = tsplus_module_1.cons(a.value, tsplus_module_1.nil());
      curr.tail = temp;
      curr = temp;
    }

    return result;
  } else {
    return tsplus_module_1.nil();
  }
}
/**
 * Constructs a new `List` from an `Iterable`
 *
 * @tsplus static List.Ops __call
 * @tsplus static List.Ops make
 */


export function make(...prefix) {
  return from_1(prefix);
}
//# sourceMappingURL=from.mjs.map