import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
/**
 * @tsplus static List.Aspects map
 * @tsplus pipeable List map
 */

export function map(f) {
  return self => {
    if (tsplus_module_1.isNil(self)) {
      return self;
    } else {
      const h = tsplus_module_1.cons(f(self.head), tsplus_module_1.nil());
      let t = h;
      let rest = self.tail;

      while (!tsplus_module_1.isNil(rest)) {
        const nx = tsplus_module_1.cons(f(rest.head), tsplus_module_1.nil());
        t.tail = nx;
        t = nx;
        rest = rest.tail;
      }

      return h;
    }
  };
}
//# sourceMappingURL=map.mjs.map