import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/from";
/**
 * Separate elements based on a predicate.
 *
 * @tsplus static List.Aspects partition
 * @tsplus pipeable List partition
 */

export function partition(f) {
  return self => {
    const left = [];
    const right = [];

    for (const a of self) {
      if (f(a)) {
        right.push(a);
      } else {
        left.push(a);
      }
    }

    return [tsplus_module_1.from(left), tsplus_module_1.from(right)];
  };
}
//# sourceMappingURL=partition.mjs.map