import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/from";
/**
 * Partitions the elements of this List into two Lists using the specified
 * function.
 *
 * @tsplus static List.Aspects partitionMap
 * @tsplus pipeable List partitionMap
 */

export function partitionMap(f) {
  return self => {
    const left = [];
    const right = [];

    for (const a of self) {
      const e = f(a);

      if (e._tag === "Left") {
        left.push(e.left);
      } else {
        right.push(e.right);
      }
    }

    return [tsplus_module_1.from(left), tsplus_module_1.from(right)];
  };
}
//# sourceMappingURL=partitionMap.mjs.map