import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
/**
 * @tsplus static List.Aspects prependAll
 * @tsplus pipeable List prependAll
 */

export function prependAll(prefix) {
  return self => {
    if (tsplus_module_1.isNil(self)) {
      return prefix;
    } else if (tsplus_module_1.isNil(prefix)) {
      return self;
    } else {
      const result = tsplus_module_1.cons(prefix.head, self);
      let curr = result;
      let that = prefix.tail;

      while (!tsplus_module_1.isNil(that)) {
        const temp = tsplus_module_1.cons(that.head, self);
        curr.tail = temp;
        curr = temp;
        that = that.tail;
      }

      return result;
    }
  };
}
//# sourceMappingURL=prependAll.mjs.map