import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/mutable/ListBuffer";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/unsafeHead";
/**
 * @tsplus static List.Aspects sortWith
 * @tsplus pipeable List sortWith
 */

export function sortWith(ord) {
  return self => {
    const len = tsplus_module_1.length(self);
    const b = new tsplus_module_2.ListBuffer();

    if (len === 1) {
      b.append(tsplus_module_3.unsafeHead(self));
    } else if (len > 1) {
      const arr = new Array(len);
      copyToArrayWithIndex(self, arr);
      arr.sort(([i, x], [j, y]) => {
        const c = ord.compare(x, y);
        return c !== 0 ? c : i < j ? -1 : 1;
      });

      for (let i = 0; i < len; i++) {
        b.append(arr[i][1]);
      }
    }

    return b.toList;
  };
}

function copyToArrayWithIndex(list, arr) {
  let these = list;
  let i = 0;

  while (!tsplus_module_1.isNil(these)) {
    arr[i] = [i, these.head];
    these = these.tail;
    i++;
  }
}
//# sourceMappingURL=sortWith.mjs.map