import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Constructs a `NonEmptyImmutableArray` from a `Collection`, returning `None`
 * if the provided `Collection` is empty.
 *
 * @tsplus static NonEmptyImmutableArray.Ops from
 */

export function from(collection) {
  const array = Array.from(collection);
  return array.length === 0 ? tsplus_module_1.none : tsplus_module_1.some(new tsplus_module_2.ImmutableArray(array));
}
//# sourceMappingURL=from.mjs.map