import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Ord/common";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/definition";
/**
 * @tsplus static NonEmptyImmutableArray.Ops getOrd
 */

export function getOrd(O) {
  return tsplus_module_2.Ord((x, y) => {
    const xLen = x.array.length;
    const yLen = y.array.length;
    const len = Math.min(xLen, yLen);

    for (let i = 0; i < len; i++) {
      const ordering = O.compare(x.array[i], y.array[i]);

      if (ordering !== 0) {
        return ordering;
      }
    }

    return tsplus_module_1.number.compare(xLen, yLen);
  });
}
//# sourceMappingURL=getOrd.mjs.map