var _a, _b, _c, _d;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/io/Eval/run";
import * as tsplus_module_4 from "@tsplus/stdlib/io/Eval/succeed";
import * as tsplus_module_5 from "@tsplus/stdlib/io/Eval/gen";
import * as tsplus_module_6 from "@tsplus/stdlib/io/Eval/zipWith";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_8 from "@tsplus/stdlib/collections/List/unsafeHead";
import * as tsplus_module_9 from "@tsplus/stdlib/collections/HashSet/operations/size";
import * as tsplus_module_10 from "@tsplus/stdlib/collections/List/from";
import * as tsplus_module_11 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_12 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_13 from "@tsplus/stdlib/collections/HashSet/operations/empty";
import * as tsplus_module_14 from "@tsplus/stdlib/collections/HashSet/operations/union";
import * as tsplus_module_15 from "@tsplus/stdlib/collections/List/concat";
import * as tsplus_module_16 from "@tsplus/stdlib/collections/List/reduce";
import * as tsplus_module_17 from "@tsplus/stdlib/collections/List/reverse";
import * as tsplus_module_18 from "@tsplus/stdlib/collections/HashSet/operations/add";
export const combinePar_ = combinePar_1;
export const combineSeq_ = combineSeq_1;
export const isParSeq = isParSeq_1;
export const isEmpty = isEmpty_1;
export const ParSeqSym = /*#__PURE__*/Symbol.for("@tsplus/stdlib/collections/ParSeq");
export const _A = /*#__PURE__*/Symbol.for("@tsplus/stdlib/collections/ParSeq/A");
export const ParSeq = {
  $: {}
};

const _emptyHash = /*#__PURE__*/tsplus_module_1.optimize( /*#__PURE__*/tsplus_module_1.hashRandom());
/**
 * @tsplus type ParSeq/Empty
 */


export class Empty {
  constructor() {
    this._tag = "Empty";
    this[_a] = ParSeqSym;
  }

  [(_a = ParSeqSym, tsplus_module_2.Equals.sym)](that) {
    return isParSeq_1(that) && tsplus_module_3.run(this.equalsSafe(that));
  }

  [tsplus_module_1.Hash.sym]() {
    return _emptyHash;
  }

  equalsSafe(that) {
    return tsplus_module_4.succeed(() => that._tag === "Empty");
  }

}
/**
 * @tsplus type ParSeq/Single
 */

export class Single {
  constructor(a) {
    this.a = a;
    this._tag = "Single";
    this[_b] = ParSeqSym;
  }

  [(_b = ParSeqSym, tsplus_module_2.Equals.sym)](that) {
    return isParSeq_1(that) && tsplus_module_3.run(this.equalsSafe(that));
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.combine(tsplus_module_1.hashString(this._tag), tsplus_module_1.hashUnknown(this.a));
  }

  equalsSafe(that) {
    return tsplus_module_4.succeed(() => that._tag === "Single" && tsplus_module_2.equals(this.a, that.a));
  }

}
/**
 * @tsplus type ParSeq/Then
 */

export class Then {
  constructor(left, right) {
    this.left = left;
    this.right = right;
    this._tag = "Then";
    this[_c] = ParSeqSym;
  }

  [(_c = ParSeqSym, tsplus_module_2.Equals.sym)](that) {
    return isParSeq_1(that) && tsplus_module_3.run(this.equalsSafe(that));
  }

  [tsplus_module_1.Hash.sym]() {
    return hashCode(this);
  }

  equalsSafe(that) {
    // eslint-disable-next-line @typescript-eslint/no-this-alias
    const self = this;
    return tsplus_module_5.gen(function* ($) {
      return (yield* $(self.eq(that))) || (yield* $(symmetric(associateThen)(self, that))) || (yield* $(symmetric(distributiveThen)(self, that))) || (yield* $(symmetric(zero)(self, that)));
    });
  }

  eq(that) {
    if (that._tag === "Then") {
      return tsplus_module_6.zipWith(this.right.equalsSafe(that.right), (a, b) => a && b)(this.left.equalsSafe(that.left));
    }

    return tsplus_module_4.succeed(() => false);
  }

}
/**
 * @tsplus type ParSeq/Both
 */

export class Both {
  constructor(left, right) {
    this.left = left;
    this.right = right;
    this._tag = "Both";
    this[_d] = ParSeqSym;
  }

  [(_d = ParSeqSym, tsplus_module_2.Equals.sym)](that) {
    return isParSeq_1(that) && tsplus_module_3.run(this.equalsSafe(that));
  }

  [tsplus_module_1.Hash.sym]() {
    return hashCode(this);
  }

  equalsSafe(that) {
    // eslint-disable-next-line @typescript-eslint/no-this-alias
    const self = this;
    return tsplus_module_5.gen(function* (_) {
      return (yield* _(self.eq(that))) || (yield* _(symmetric(associativeBoth)(self, that))) || (yield* _(symmetric(distributiveBoth)(self, that))) || (yield* _(commutativeBoth(self, that))) || (yield* _(symmetric(zero)(self, that)));
    });
  }

  eq(that) {
    if (that._tag === "Both") {
      return tsplus_module_6.zipWith(this.right.equalsSafe(that.right), (a, b) => a && b)(this.left.equalsSafe(that.left));
    }

    return tsplus_module_4.succeed(() => false);
  }

}

function associateThen(self, that) {
  if (self._tag === "Then" && self.left._tag === "Then" && that._tag === "Then" && that.right._tag === "Then") {
    const al = self.left.left;
    const bl = self.left.right;
    const cl = self.right;
    const ar = that.left;
    const br = that.right.left;
    const cr = that.right.right;
    return tsplus_module_6.zipWith(tsplus_module_6.zipWith(cl.equalsSafe(cr), (a, b) => a && b)(bl.equalsSafe(br)), (a, b) => a && b)(al.equalsSafe(ar));
  }

  return tsplus_module_4.succeed(() => false);
}

function distributiveThen(self, that) {
  return tsplus_module_5.gen(function* (_) {
    if (self._tag === "Then" && self.right._tag === "Both" && that._tag === "Both" && that.left._tag === "Then" && that.right._tag === "Then") {
      const al = self.left;
      const bl = self.right.left;
      const cl = self.right.right;
      const ar1 = that.left.left;
      const br = that.left.right;
      const ar2 = that.right.left;
      const cr = that.right.right;

      if ((yield* _(ar1.equalsSafe(ar2))) && (yield* _(al.equalsSafe(ar1))) && (yield* _(bl.equalsSafe(br))) && (yield* _(cl.equalsSafe(cr)))) {
        return true;
      }
    }

    if (self._tag === "Then" && self.left._tag === "Both" && that._tag === "Both" && that.left._tag === "Then" && that.right._tag === "Then") {
      const al = self.left.left;
      const bl = self.left.right;
      const cl = self.right;
      const ar = that.left.left;
      const cr1 = that.left.right;
      const br = that.right.left;
      const cr2 = that.right.right;

      if ((yield* _(cr1.equalsSafe(cr2))) && (yield* _(al.equalsSafe(ar))) && (yield* _(bl.equalsSafe(br))) && (yield* _(cl.equalsSafe(cr1)))) {
        return true;
      }
    }

    return false;
  });
}

function associativeBoth(self, that) {
  return tsplus_module_5.gen(function* (_) {
    if (self._tag === "Both" && self.left._tag === "Both" && that._tag === "Both" && that.right._tag === "Both") {
      const al = self.left.left;
      const bl = self.left.right;
      const cl = self.right;
      const ar = that.left;
      const br = that.right.left;
      const cr = that.right.right;
      return (yield* _(al.equalsSafe(ar))) && (yield* _(bl.equalsSafe(br))) && (yield* _(cl.equalsSafe(cr)));
    }

    return false;
  });
}

function distributiveBoth(self, that) {
  return tsplus_module_5.gen(function* (_) {
    if (self._tag === "Both" && self.left._tag === "Then" && self.right._tag === "Then" && that._tag === "Then" && that.right._tag === "Both") {
      const al1 = self.left.left;
      const bl = self.left.right;
      const al2 = self.right.left;
      const cl = self.right.right;
      const ar = that.left;
      const br = that.right.left;
      const cr = that.right.right;

      if ((yield* _(al1.equalsSafe(al2))) && (yield* _(al1.equalsSafe(ar))) && (yield* _(bl.equalsSafe(br))) && (yield* _(cl.equalsSafe(cr)))) {
        return true;
      }
    }

    if (self._tag === "Both" && self.left._tag === "Then" && self.right._tag === "Then" && that._tag === "Then" && that.left._tag === "Both") {
      const al = self.left.left;
      const cl1 = self.left.right;
      const bl = self.right.left;
      const cl2 = self.right.right;
      const ar = that.left.left;
      const br = that.left.right;
      const cr = that.right;

      if ((yield* _(cl1.equalsSafe(cl2))) && (yield* _(al.equalsSafe(ar))) && (yield* _(bl.equalsSafe(br))) && (yield* _(cl1.equalsSafe(cr)))) {
        return true;
      }
    }

    return false;
  });
}

function commutativeBoth(self, that) {
  if (that._tag === "Both") {
    return tsplus_module_6.zipWith(self.right.equalsSafe(that.left), (a, b) => a && b)(self.left.equalsSafe(that.right));
  }

  return tsplus_module_4.succeed(() => false);
}

function zero(self, that) {
  if (self._tag === "Then" && self.right._tag === "Empty") {
    return self.left.equalsSafe(that);
  }

  if (self._tag === "Then" && self.left._tag === "Empty") {
    return self.right.equalsSafe(that);
  }

  if (self._tag === "Both" && self.right._tag === "Empty") {
    return self.left.equalsSafe(that);
  }

  if (self._tag === "Both" && self.left._tag === "Empty") {
    return self.right.equalsSafe(that);
  }

  return tsplus_module_4.succeed(() => false);
}

function symmetric(f) {
  return (a, b) => tsplus_module_5.gen(function* (_) {
    return (yield* _(f(a, b))) || (yield* _(f(b, a)));
  });
}

function hashCode(self) {
  const flat = flatten(self);
  const size = tsplus_module_7.length(flat);
  let head;

  if (size === 0) {
    return _emptyHash;
  } else if (size === 1 && (head = tsplus_module_8.unsafeHead(flat)) && tsplus_module_9.size(head) === 1) {
    return tsplus_module_8.unsafeHead(tsplus_module_10.make(head))[tsplus_module_1.Hash.sym]();
  } else {
    return tsplus_module_1.hashIterator(flat[Symbol.iterator]());
  }
}
/**
 * Empty collection of events
 *
 * @tsplus static ParSeq.Ops empty
 */


export function empty() {
  return new Empty();
}
/**
 * Constructs a new collection of events that contains the specified event.
 *
 * @tsplus static ParSeq.Ops single
 */

export function single(a) {
  return new Single(a);
}
/**
 * Combines this collection of events with that collection of events to
 * return a new collection of events that represents this collection of
 * events in parallel with that collection of events.
 *
 * @tsplus static ParSeq.Ops combinePar
 */

function combinePar_1(left, right) {
  return isEmpty_1(left) ? right : isEmpty_1(right) ? left : new Both(left, right);
}
/**
 * Combines this collection of events with that collection of events to
 * return a new collection of events that represents this collection of
 * events in parallel with that collection of events.
 *
 * @tsplus static ParSeq.Aspects combinePar
 */


export const combinePar = right => left => combinePar_(left, right);
/**
 * Combines this collection of events with that collection of events to
 * return a new collection of events that represents this collection of
 * events followed by that collection of events.
 *
 * @tsplus static ParSeq.Ops combineSeq
 */

function combineSeq_1(left, right) {
  return isEmpty_1(left) ? right : isEmpty_1(right) ? left : new Then(left, right);
}
/**
 * Combines this collection of events with that collection of events to
 * return a new collection of events that represents this collection of
 * events followed by that collection of events.
 *
 * @tsplus static ParSeq.Aspects combineSeq
 */


export const combineSeq = right => left => combineSeq_(left, right);
/**
 * @tsplus static ParSeq.Ops isParSeq
 */

function isParSeq_1(u) {
  return typeof u === "object" && u != null && ParSeqSym in u;
}
/**
 * Checks if the ParSeq is empty.
 *
 * @tsplus getter ParSeq isEmpty
 */


function isEmpty_1(self) {
  return isEmptyLoop(tsplus_module_10.make(self));
}

function isEmptyLoop(self) {
  while (!tsplus_module_7.isNil(self)) {
    const head = self.head;
    const tail = self.tail;

    switch (head._tag) {
      case "Empty":
        {
          self = tail;
          break;
        }

      case "Single":
        {
          return false;
        }

      case "Both":
        {
          self = tsplus_module_11.prepend(head.left)(tsplus_module_11.prepend(head.right)(tail));
          break;
        }

      case "Then":
        {
          self = tsplus_module_11.prepend(head.left)(tsplus_module_11.prepend(head.right)(tail));
          break;
        }
    }
  }

  return true;
}

function flatten(self) {
  return flattenLoop(tsplus_module_10.make(self), tsplus_module_12.empty());
}

function flattenLoop(causes, flattened) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    const [parallel, sequential] = tsplus_module_16.reduce([tsplus_module_13.empty(), tsplus_module_12.empty()], ([parallel, sequential], cause) => {
      const [set, seq] = step(cause);
      return [tsplus_module_14.union(set)(parallel), tsplus_module_15.concatOperator(sequential, seq)];
    })(causes);
    const updated = tsplus_module_9.size(parallel) > 0 ? tsplus_module_11.prepend(parallel)(flattened) : flattened;

    if (tsplus_module_7.isNil(sequential)) {
      return tsplus_module_17.reverse(updated);
    } else {
      causes = sequential;
      flattened = updated;
    }
  }

  throw new Error("Bug");
}

function step(self) {
  return stepLoop(self, tsplus_module_12.empty(), tsplus_module_13.empty(), tsplus_module_12.empty());
}

function stepLoop(cause, stack, parallel, sequential) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    switch (cause._tag) {
      case "Empty":
        {
          if (tsplus_module_7.isNil(stack)) {
            return [parallel, sequential];
          } else {
            cause = stack.head;
            stack = stack.tail;
          }

          break;
        }

      case "Both":
        {
          stack = tsplus_module_11.prepend(cause.right)(stack);
          cause = cause.left;
          break;
        }

      case "Then":
        {
          const left = cause.left;
          const right = cause.right;

          switch (left._tag) {
            case "Empty":
              {
                cause = cause.right;
                break;
              }

            case "Then":
              {
                cause = combineSeq_1(left.left, combineSeq_1(left.right, right));
                break;
              }

            case "Both":
              {
                cause = combinePar_1(combineSeq_1(left.left, right), combineSeq_1(left.right, right));
                break;
              }

            default:
              {
                cause = left;
                sequential = tsplus_module_11.prepend(right)(sequential);
              }
          }

          break;
        }

      default:
        {
          if (tsplus_module_7.isNil(stack)) {
            return [tsplus_module_18.add(cause)(parallel), sequential];
          } else {
            parallel = tsplus_module_18.add(cause)(parallel);
            cause = stack.head;
            stack = stack.tail;
            break;
          }
        }
    }
  }

  throw new Error("Bug");
}
//# sourceMappingURL=definition.mjs.map