import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns the first event in this collection of events. If multiple events
 * occur in parallel and before any other events then any of these events
 * may be returned.
 *
 * @tsplus getter ParSeq first
 */

export function first(self) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    switch (self._tag) {
      case "Single":
        {
          return tsplus_module_1.some(self.a);
        }

      case "Empty":
        {
          return tsplus_module_1.none;
        }

      case "Both":
        {
          self = self.left;
          break;
        }

      case "Then":
        {
          self = self.left;
          break;
        }
    }
  }

  throw new Error("Bug");
}
//# sourceMappingURL=first.mjs.map