import * as tsplus_module_1 from "@tsplus/stdlib/collections/List/from";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/List/empty";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/List/unsafeHead";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/List/definition";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/List/prepend";
import * as tsplus_module_6 from "@tsplus/stdlib/collections/List/unsafeTail";
import * as tsplus_module_7 from "@tsplus/stdlib/collections/List/reduce";
import * as tsplus_module_8 from "@tsplus/stdlib/data/Either/definition";
/**
 * Folds over the events in this collection of events using the specified
 * functions.
 *
 * @tsplus static ParSeq.Aspects fold
 * @tsplus pipeable ParSeq fold
 */

export function fold(emptyCase, singleCase, thenCase, bothCase) {
  return self => tsplus_module_3.unsafeHead(foldLoop(emptyCase, singleCase, thenCase, bothCase, tsplus_module_1.make(self), tsplus_module_2.empty()));
}

function foldLoop(emptyCase, singleCase, thenCase, bothCase, inp, out) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    if (tsplus_module_4.isNil(inp)) {
      return tsplus_module_7.reduce(tsplus_module_2.empty(), (acc, val) => {
        if (val._tag === "Right") {
          return tsplus_module_5.prepend(val.right)(acc);
        } else {
          if (val.left) {
            let parSeqs = acc;
            const left = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            const right = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            return tsplus_module_5.prepend(bothCase(left, right))(parSeqs);
          } else {
            let parSeqs = acc;
            const left = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            const right = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            return tsplus_module_5.prepend(thenCase(left, right))(parSeqs);
          }
        }
      })(out);
    } else {
      const head = inp.head;
      const parSeqs = inp.tail;

      switch (head._tag) {
        case "Empty":
          {
            inp = parSeqs;
            out = tsplus_module_5.prepend(tsplus_module_8.right(emptyCase))(out);
            break;
          }

        case "Single":
          {
            inp = parSeqs;
            out = tsplus_module_5.prepend(tsplus_module_8.right(singleCase(head.a)))(out);
            break;
          }

        case "Then":
          {
            inp = tsplus_module_5.prepend(head.left)(tsplus_module_5.prepend(head.right)(parSeqs));
            out = tsplus_module_5.prepend(tsplus_module_8.left(false))(out);
            break;
          }

        case "Both":
          {
            inp = tsplus_module_5.prepend(head.left)(tsplus_module_5.prepend(head.right)(parSeqs));
            out = tsplus_module_5.prepend(tsplus_module_8.left(true))(out);
            break;
          }
      }
    }
  }

  throw new Error("Bug");
}
//# sourceMappingURL=fold.mjs.map