import { RedBlackTreeIterator } from "@tsplus/stdlib/collections/RedBlackTree/definition";
/**
 * Traverse the tree backwards.
 *
 * @tsplus getter RedBlackTree backwards
 */

export function backwards(self) {
  return {
    ord: self.ord,
    [Symbol.iterator]: () => {
      const stack = [];
      let n = self.root;

      while (n) {
        stack.push(n);
        n = n.right;
      }

      return new RedBlackTreeIterator(self, stack, "Backward");
    }
  };
}
//# sourceMappingURL=backwards.mjs.map