import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/ImmutableArray/from";
/**
 * Finds the item with key if it exists.
 *
 * @tsplus static RedBlackTree.Aspects find
 * @tsplus pipeable RedBlackTree find
 */

export function find(key) {
  return self => {
    const cmp = self.ord.compare;
    let n = self.root;
    const res = [];

    while (n) {
      const d = cmp(key, n.key);

      if (d === 0 && tsplus_module_1.equals(key, n.key)) {
        res.push(n.value);
      }

      if (d <= 0) {
        n = n.left;
      } else {
        n = n.right;
      }
    }

    return tsplus_module_2.from(res.reverse());
  };
}
//# sourceMappingURL=find.mjs.map