import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Finds the item with key if it exists.
 *
 * @tsplus static RedBlackTree.Aspects findFirst
 * @tsplus pipeable RedBlackTree findFirst
 */

export function findFirst(key) {
  return self => {
    const cmp = self.ord.compare;
    let n = self.root;

    while (n) {
      const d = cmp(key, n.key);

      if (tsplus_module_1.equals(key, n.key)) {
        return tsplus_module_2.some(n.value);
      }

      if (d <= 0) {
        n = n.left;
      } else {
        n = n.right;
      }
    }

    return tsplus_module_2.none;
  };
}
//# sourceMappingURL=findFirst.mjs.map