import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/RedBlackTree/visitFull";
/**
 * Visit each node of the tree in order.
 *
 * @tsplus static RedBlackTree.Aspects forEach
 * @tsplus pipeable RedBlackTree forEach
 */

export function forEach(visit) {
  return self => {
    if (self.root) {
      tsplus_module_2.visitFull(self.root, (key, value) => {
        visit(key, value);
        return tsplus_module_1.none;
      });
    }
  };
}
//# sourceMappingURL=forEach.mjs.map