import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/RedBlackTree/visitBetween";
/**
 * Visit each node of the tree in order with key lower than max and greater
 * than or equal to min.
 *
 * @tsplus static RedBlackTree.Aspects forEachBetween
 * @tsplus pipeable RedBlackTree forEachBetween
 */

export function forEachBetween(min, max, visit) {
  return self => {
    if (self.root) {
      tsplus_module_2.visitBetween(self.root, min, max, self.ord, (key, value) => {
        visit(key, value);
        return tsplus_module_1.none;
      });
    }
  };
}
//# sourceMappingURL=forEachBetween.mjs.map