import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/RedBlackTree/visitGe";
/**
 * Visit each node of the tree in order with key greater then or equal to max.
 *
 * @tsplus static RedBlackTree.Aspects forEachGe
 * @tsplus pipeable RedBlackTree forEachGe
 */

export function forEachGe(min, visit) {
  return self => {
    if (self.root) {
      tsplus_module_2.visitGe(self.root, min, self.ord, (key, value) => {
        visit(key, value);
        return tsplus_module_1.none;
      });
    }
  };
}
//# sourceMappingURL=forEachGe.mjs.map