import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/RedBlackTree/visitLt";
/**
 * Visit each node of the tree in order with key lower then max.
 *
 * @tsplus static RedBlackTree.Aspects forEachLt
 * @tsplus pipeable RedBlackTree forEachLt
 */

export function forEachLt(max, visit) {
  return self => {
    if (self.root) {
      tsplus_module_2.visitLt(self.root, max, self.ord, (key, value) => {
        visit(key, value);
        return tsplus_module_1.none;
      });
    }
  };
}
//# sourceMappingURL=forEachLt.mjs.map