import * as tsplus_module_1 from "@tsplus/stdlib/collections/RedBlackTree/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/RedBlackTree/insert";
/**
 * Constructs a new tree from an iterable of key-value pairs.
 *
 * @tsplus static RedBlackTree.Ops from
 */

export function from(ord) {
  return data => {
    let tree = tsplus_module_1.empty(ord);

    for (const [k, v] of data) {
      tree = tsplus_module_2.insert(k, v)(tree);
    }

    return tree;
  };
}
//# sourceMappingURL=from.mjs.map