import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns the element at the specified index within the tree or `None` if the
 * specified index does not exist.
 *
 * @tsplus static RedBlackTree.Aspects getAt
 * @tsplus pipeable RedBlackTree getAt
 */

export function getAt(index) {
  return self => {
    if (index < 0) {
      return tsplus_module_1.none;
    }

    let n = self.root;
    let node = undefined;

    while (n) {
      node = n;

      if (n.left) {
        if (index < n.left.count) {
          n = n.left;
          continue;
        }

        index -= n.left.count;
      }

      if (!index) {
        return tsplus_module_1.some([node.key, node.value]);
      }

      index -= 1;

      if (n.right) {
        if (index >= n.right.count) {
          break;
        }

        n = n.right;
      } else {
        break;
      }
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=getAt.mjs.map