import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/fold";
export const keys = keys_1;
/**
 * Get the keys of the tree.
 *
 * @tsplus static RedBlackTree.Aspects keys
 * @tsplus pipeable RedBlackTree keys
 */

function keys_1(direction = "Forward") {
  return self => {
    const begin = self[Symbol.iterator]();
    let count = 0;
    return {
      [Symbol.iterator]: () => keys_1(direction)(self),
      next: () => {
        count++;
        const entry = begin.key;

        if (direction === "Forward") {
          begin.moveNext();
        } else {
          begin.movePrev();
        }

        return tsplus_module_1.fold(() => ({
          value: count,
          done: true
        }), entry => ({
          value: entry,
          done: false
        }))(entry);
      }
    };
  };
}
//# sourceMappingURL=keys.mjs.map