import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/fold";
export const values_ = values_1;
/**
 * Get the values of the tree.
 *
 * @tsplus static RedBlackTree.Aspects values
 * @tsplus pipeable RedBlackTree values
 */

function values_1(direction = "Forward") {
  return self => {
    const begin = self[Symbol.iterator]();
    let count = 0;
    return {
      [Symbol.iterator]: () => values_1(direction)(self),
      next: () => {
        count++;
        const entry = begin.value;

        if (direction === "Forward") {
          begin.moveNext();
        } else {
          begin.movePrev();
        }

        return tsplus_module_1.fold(() => ({
          value: count,
          done: true
        }), entry => ({
          value: entry,
          done: false
        }))(entry);
      }
    };
  };
}
//# sourceMappingURL=values.mjs.map