import * as tsplus_module_1 from "@tsplus/stdlib/data/Stack";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Visit nodes with key lower than max and greater then or equal to min.
 *
 * @tsplus static RedBlackTree.Ops visitBetween
 */

export function visitBetween(node, min, max, ord, visit) {
  let current = node;
  let stack = undefined;
  let done = false;

  while (!done) {
    if (current) {
      stack = new tsplus_module_1.Stack(current, stack);

      if (ord.compare(min, current.key) <= 0) {
        current = current.left;
      } else {
        current = undefined;
      }
    } else if (stack && ord.compare(max, stack.value.key) > 0) {
      if (ord.compare(min, stack.value.key) <= 0) {
        const v = visit(stack.value.key, stack.value.value);

        if (tsplus_module_2.isSome(v)) {
          return v;
        }
      }

      current = stack.value.right;
      stack = stack.previous;
    } else {
      done = true;
    }
  }

  return tsplus_module_2.none;
}
//# sourceMappingURL=visitBetween.mjs.map