import * as tsplus_module_1 from "@tsplus/stdlib/data/Stack";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Visit nodes lower than key.
 *
 * @tsplus static RedBlackTree.Ops visitLt
 */

export function visitLt(node, max, ord, visit) {
  let current = node;
  let stack = undefined;
  let done = false;

  while (!done) {
    if (current) {
      stack = new tsplus_module_1.Stack(current, stack);
      current = current.left;
    } else if (stack && ord.compare(max, stack.value.key) > 0) {
      const v = visit(stack.value.key, stack.value.value);

      if (tsplus_module_2.isSome(v)) {
        return v;
      }

      current = stack.value.right;
      stack = stack.previous;
    } else {
      done = true;
    }
  }

  return tsplus_module_2.none;
}
//# sourceMappingURL=visitLt.mjs.map