import * as tsplus_module_1 from "@tsplus/stdlib/collections/SortedSet/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/SortedSet/has";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/SortedSet/add";
import { concreteSortedSet } from "@tsplus/stdlib/collections/SortedSet/_internal/SortedSetInternal";
/**
 * The set of elements which are in both the first and second set.
 *
 * **Note**: the hash and equal of the 2 sets must be the same.
 *
 * @tsplus static SortedSet.Aspects intersection
 * @tsplus pipeable SortedSet intersection
 */

export function intersection(that) {
  return self => {
    void 0;
    let out = tsplus_module_1.empty(self.keyTree.ord);

    for (const key of that) {
      if (tsplus_module_2.has(key)(self)) {
        out = tsplus_module_3.add(key)(out);
      }
    }

    return out;
  };
}
//# sourceMappingURL=intersection.mjs.map