import * as tsplus_module_1 from "@tsplus/stdlib/collections/SortedSet/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/SortedSet/add";
import { concreteSortedSet } from "@tsplus/stdlib/collections/SortedSet/_internal/SortedSetInternal";
/**
 * Computes the set union of the set and the specified collection
 *
 * **Note**: the hash and equal of the 2 sets must be the same.
 *
 * @tsplus static SortedSet.Aspects union
 * @tsplus pipeable SortedSet union
 */

export function union(that) {
  return self => {
    void 0;
    let out = tsplus_module_1.empty(self.keyTree.ord);

    for (const value of self) {
      out = tsplus_module_2.add(value)(out);
    }

    for (const value of that) {
      out = tsplus_module_2.add(value)(out);
    }

    return out;
  };
}
//# sourceMappingURL=union.mjs.map