var _a;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/empty";
export const isTree = isTree_1;
export const TreeTypeId = /*#__PURE__*/Symbol.for("@tsplus/collections/Tree");
/**
 * @tsplus type Tree
 * @tsplus companion Tree.Ops
 */

export class Tree {
  constructor(value, forest) {
    this.value = value;
    this.forest = forest;
    this[_a] = TreeTypeId;
  }

  [(_a = TreeTypeId, tsplus_module_1.Equals.sym)](other) {
    return isTree_1(other) && tsplus_module_1.equals(this.value, other.value) && tsplus_module_2.corresponds_(this.forest, other.forest, (a, b) => tsplus_module_1.equals(a, b));
  }

  [tsplus_module_3.Hash.sym]() {
    return tsplus_module_3.optimize(tsplus_module_3.combine(tsplus_module_3.hashUnknown(this.value), this.forest[tsplus_module_3.Hash.sym]()));
  }

}
/**
 * @tsplus static Tree.Ops $
 */

export const TreeAspects = {};
const empty = /*#__PURE__*/tsplus_module_4.empty();
/**
 * @tsplus static Tree.Ops __call
 */

export function make(value, forest = empty) {
  return new Tree(value, forest);
}
/**
 * Type guard
 *
 * @tsplus static Tree.Ops isTree
 */

function isTree_1(t) {
  return typeof t === "object" && t instanceof Tree && TreeTypeId in t;
}
//# sourceMappingURL=definition.mjs.map