import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/unsafeGet";
/**
 * @tsplus getter Tree draw
 */

export function drawTree(tree) {
  return tree.value + drawForest("\n", tree.forest);
}

function drawForest(indentation, forest) {
  let r = "";
  const len = forest.length;
  let tree;

  for (let i = 0; i < len; i++) {
    tree = tsplus_module_1.unsafeGet(i)(forest);
    const isLast = i === len - 1;
    r += indentation + (isLast ? "└" : "├") + "─ " + tree.value;
    r += drawForest(indentation + (len > 1 && !isLast ? "│  " : "   "), tree.forest);
  }

  return r;
}
//# sourceMappingURL=drawTree.mjs.map