import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Chunk/operations/concat";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/Tree/definition";
export const flatMap = flatMap_1;
/**
 * Take a `Tree<A>` and a function from `f: (a:A) => Tree<B>` and
 * return a Tree<B>
 *
 * @tsplus static Tree.Aspects flatMap
 * @tsplus pipeable Tree flatMap
 */

function flatMap_1(f) {
  return self => {
    const {
      forest,
      value
    } = f(self.value);
    return tsplus_module_3.make(value, tsplus_module_2.concat(tsplus_module_1.map(a => flatMap_1(f)(a))(self.forest))(forest));
  };
}
//# sourceMappingURL=flatMap.mjs.map