import * as tsplus_module_1 from "@tsplus/stdlib/collections/Chunk/operations/map";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/Tree/definition";
export const unfold = unfold_1;
/**
 * Constructs a `Tree` by repeatedly applying the (possibly infinite) function `f`
 * in breadth-first order.
 *
 * @tsplus static Tree.Ops unfold
 */

function unfold_1(s, f) {
  const next = f(s);
  const [a, s0] = [next[0], next[1]];
  return tsplus_module_2.make(a, tsplus_module_1.map(b => unfold_1(b, f))(s0));
}
//# sourceMappingURL=unfold.mjs.map