import * as tsplus_module_1 from "@tsplus/stdlib/collections/mutable/MutableHashMap/empty";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_3 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/mutable/MutableHashMap/has";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Collection/functions";
/**
 * @tsplus type MutableHashSet
 * @tsplus companion MutableHashSet.Ops
 */

export class MutableHashSet {
  constructor() {
    this.backingMap = tsplus_module_1.empty();
  }

  [tsplus_module_2.Hash.sym]() {
    return tsplus_module_2.hashRandomCached(this);
  }

  [tsplus_module_3.Equals.sym](that) {
    return this === that;
  }

  get size() {
    return this.backingMap.size;
  }

  isEmpty() {
    return this.size === 0;
  }

  contains(value) {
    return tsplus_module_4.has(value)(this.backingMap);
  }

  add(value) {
    this.backingMap.set(value, true);
    return tsplus_module_4.has(value)(this.backingMap);
  }

  remove(value) {
    this.backingMap.remove(value);
    return !tsplus_module_4.has(value)(this.backingMap);
  }

  [Symbol.iterator]() {
    return tsplus_module_5.map(([a]) => a)(this.backingMap)[Symbol.iterator]();
  }

}
//# sourceMappingURL=definition.mjs.map