var _a;

import * as tsplus_module_1 from "@tsplus/stdlib/collections/mutable/DoublyLinkedList";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_3 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/Chunk/operations/empty";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/Chunk/operations/append";
import { EmptyMutableQueue, MutableQueueSym } from "@tsplus/stdlib/collections/mutable/MutableQueue/definition";
export class Bounded {
  constructor(max) {
    this[_a] = MutableQueueSym;
    this.queue = new tsplus_module_1.DoublyLinkedList();
    this.max = max;
  }

  [(_a = MutableQueueSym, tsplus_module_2.Hash.sym)]() {
    return tsplus_module_2.hashRandomCached(this);
  }

  [tsplus_module_3.Equals.sym](that) {
    return this === that;
  }

  get size() {
    return this.queue.length;
  }

  get isEmpty() {
    return this.size === 0;
  }

  get isFull() {
    return this.size === this.capacity;
  }

  get capacity() {
    return this.max;
  }

  offer(value) {
    if (this.isFull) {
      return false;
    }

    this.queue.add(value);
    return true;
  }

  offerAll(as) {
    const it = as[Symbol.iterator]();
    let next;
    let rem = tsplus_module_4.empty();
    let offering = true;

    while (offering && (next = it.next()) && !next.done) {
      offering = this.offer(next.value);
    }

    while (next && !next.done) {
      rem = tsplus_module_5.append(next.value)(rem);
      next = it.next();
    }

    return rem;
  }

  poll(a) {
    if (this.isEmpty) {
      return a;
    }

    return this.queue.shift();
  }

  pollUpTo(n) {
    let result = tsplus_module_4.empty();
    let count = 0;

    while (count < n) {
      const elem = this.poll(EmptyMutableQueue);

      if (elem === EmptyMutableQueue) {
        break;
      }

      result = tsplus_module_5.append(elem)(result);
      count += 1;
    }

    return result;
  }

  [Symbol.iterator]() {
    return this.queue[Symbol.iterator]();
  }

}
//# sourceMappingURL=Bounded.mjs.map