import * as tsplus_module_1 from "@tsplus/stdlib/data/AtomicReference";
export class AtomicNumber extends tsplus_module_1.AtomicReference {
  constructor(n) {
    super(n);
    this.incrementAndGet = this.incrementAndGet.bind(this);
    this.decrementAndGet = this.decrementAndGet.bind(this);
  }

  incrementAndGet() {
    this.set(this.get + 1);
    return this.get;
  }

  decrementAndGet() {
    this.set(this.get - 1);
    return this.get;
  }

  getAndIncrement() {
    const ret = this.get;
    this.set(this.get + 1);
    return ret;
  }

}
//# sourceMappingURL=AtomicNumber.mjs.map