import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
import * as tsplus_module_3 from "@tsplus/stdlib/structure/Copy";
export const Case = {
  of: () => // @ts-expect-error
  args => {
    const obj = {
      [tsplus_module_1.Hash.sym]: hashImpl,
      [tsplus_module_2.Equals.sym]: equalsImpl,
      [tsplus_module_3.Copy.sym]: copyImpl
    };

    for (const k of Object.keys(args)) {
      if (typeof args[k] !== "undefined") {
        obj[k] = args[k];
      }
    }

    return obj;
  },
  tagged: tag => // @ts-expect-error
  args => {
    const obj = {
      [tsplus_module_1.Hash.sym]: hashImpl,
      [tsplus_module_2.Equals.sym]: equalsImpl,
      [tsplus_module_3.Copy.sym]: copyImpl,
      _tag: tag
    };

    for (const k of Object.keys(args)) {
      if (typeof args[k] !== "undefined") {
        obj[k] = args[k];
      }
    }

    return obj;
  }
};

function copyImpl(that) {
  const obj = {
    [tsplus_module_1.Hash.sym]: hashImpl,
    [tsplus_module_2.Equals.sym]: equalsImpl,
    [tsplus_module_3.Copy.sym]: copyImpl
  };

  for (const k of Object.keys(this)) {
    if (typeof this[k] !== "undefined") {
      obj[k] = this[k];
    }
  }

  for (const k of Object.keys(that)) {
    if (typeof that[k] !== "undefined") {
      obj[k] = that[k];
    } else {
      delete obj[k];
    }
  } // @ts-expect-error


  return obj;
}

function equalsImpl(that) {
  const keysA = Object.keys(this);
  const keysB = Object.keys(that);

  if (keysA.length !== keysB.length) {
    return false;
  }

  for (const key of keysA) {
    if (!tsplus_module_2.equals(this[key], that[key])) {
      return false;
    }
  }

  return true;
}

function hashImpl() {
  return tsplus_module_1.hashPlainObject(this);
}
//# sourceMappingURL=Case.mjs.map