import * as tsplus_module_1 from "@tsplus/stdlib/data/Differ/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashMap/patch/operations/emptyPatch";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashMap/patch/operations/combine";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashMap/patch/operations/diff";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashMap/patch/operations/apply";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Differ/operations/make";
/**
 * Constructs a differ that knows how to diff a `HashMap` of keys and values given
 * a differ that knows how to diff the values.
 *
 * @tsplus static Differ.Ops hashMap
 */

export function hashMap(differ) {
  return tsplus_module_6.make({
    empty: tsplus_module_2.emptyPatch(),
    combine: (first, second) => tsplus_module_3.combine(second)(first),
    diff: (oldValue, newValue) => tsplus_module_4.diff(oldValue, newValue, differ),
    patch: (patch, oldValue) => tsplus_module_5.apply(oldValue, differ)(patch)
  });
}
//# sourceMappingURL=hashMap.mjs.map