import * as tsplus_module_1 from "@tsplus/stdlib/data/Differ/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/collections/HashSet/patch/operations/emptyPatch";
import * as tsplus_module_3 from "@tsplus/stdlib/collections/HashSet/patch/operations/combine";
import * as tsplus_module_4 from "@tsplus/stdlib/collections/HashSet/patch/operations/diff";
import * as tsplus_module_5 from "@tsplus/stdlib/collections/HashSet/patch/operations/apply";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Differ/operations/make";
/**
 * Constructs a differ that knows how to diff a `HashSet` of values.
 *
 * @tsplus static Differ.Ops hashSet
 */

export function hashSet() {
  return tsplus_module_6.make({
    empty: tsplus_module_2.emptyPatch(),
    combine: (first, second) => tsplus_module_3.combine(second)(first),
    diff: (oldValue, newValue) => tsplus_module_4.diff(oldValue, newValue),
    patch: (patch, oldValue) => tsplus_module_5.apply(oldValue)(patch)
  });
}
//# sourceMappingURL=hashSet.mjs.map