import * as tsplus_module_1 from "@tsplus/stdlib/data/Differ/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Differ/OrPatch/operations/emptyPatch";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Differ/OrPatch/operations/combine";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Differ/OrPatch/operations/diff";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Differ/OrPatch/operations/apply";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Differ/operations/make";
/**
 * Combines this differ and the specified differ to produce a differ that
 * knows how to diff the sum of their values.
 *
 * @tsplus static Differ.Aspects orElseEither
 * @tsplus pipeable Differ orElseEither
 */

export function orElseEither(that) {
  return self => tsplus_module_6.make({
    empty: tsplus_module_2.emptyPatch(),
    combine: (first, second) => tsplus_module_3.combine(second)(first),
    diff: (oldValue, newValue) => tsplus_module_4.diff(oldValue, newValue, self, that),
    patch: (patch, oldValue) => tsplus_module_5.apply(oldValue, self, that)(patch)
  });
}
//# sourceMappingURL=orElseEither.mjs.map