var _a;

import * as tsplus_module_1 from "@tsplus/stdlib/structure/Hash";
import * as tsplus_module_2 from "@tsplus/stdlib/structure/Equals";
export const isDuration = isDuration_1;
export const DurationSym = /*#__PURE__*/Symbol.for("@tsplus/stdlib/data/Duration");
export class DurationInternal {
  constructor(millis) {
    this.millis = millis;
    this[_a] = DurationSym;
  }

  [(_a = DurationSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashNumber(this.millis);
  }

  [tsplus_module_2.Equals.sym](other) {
    return isDuration_1(other) && this.millis === other.millis;
  }

}
/**
 * @tsplus static Duration.Ops isDuration
 */

function isDuration_1(u) {
  return typeof u === "object" && u != null && DurationSym in u;
}

export const Duration = {
  $: {},
  Zero: /*#__PURE__*/new DurationInternal(0),
  Infinity: /*#__PURE__*/new DurationInternal(Number.MAX_SAFE_INTEGER)
};
/**
 * @tsplus getter number millis
 * @tsplus static Duration.Ops millis
 */

export function millis(self) {
  return new DurationInternal(self);
}
/**
 * @tsplus getter number seconds
 * @tsplus static Duration.Ops seconds
 */

export function seconds(self) {
  return new DurationInternal(self * 1000);
}
/**
 * @tsplus getter number minutes
 * @tsplus static Duration.Ops minutes
 */

export function minutes(self) {
  return new DurationInternal(self * 60000);
}
/**
 * @tsplus getter number hours
 * @tsplus static Duration.Ops hours
 */

export function hours(self) {
  return new DurationInternal(self * 3600000);
}
/**
 * @tsplus getter number days
 * @tsplus static Duration.Ops days
 */

export function days(self) {
  return new DurationInternal(self * 86400000);
}
/**
 * @tsplus getter number weeks
 * @tsplus static Duration.Ops weeks
 */

export function weeks(self) {
  return new DurationInternal(self * 604800000);
}
/**
 * @tsplus pipeable-operator Duration *
 * @tsplus static Duration.Aspects times
 * @tsplus pipeable Duration times
 */

export function times(times) {
  return self => new DurationInternal(self.millis * times);
}
/**
 * @tsplus operator Duration *
 */

export function timesInverted(times, self) {
  return new DurationInternal(self.millis * times);
}
/**
 * @tsplus pipeable-operator Duration +
 * @tsplus static Duration.Aspects add
 * @tsplus pipeable Duration add
 */

export function add(that) {
  return self => new DurationInternal(self.millis + that.millis);
}
/**
 * @tsplus pipeable-operator Duration -
 * @tsplus static Duration.Aspects subtract
 * @tsplus pipeable Duration subtract
 */

export function subtract(that) {
  return self => new DurationInternal(self.millis - that.millis);
}
/**
 * @tsplus pipeable-operator Duration <
 * @tsplus static Duration.Aspects lowerThen
 * @tsplus pipeable Duration lowerThen
 */

export function lowerThen(that) {
  return self => self.millis < that.millis;
}
/**
 * @tsplus pipeable-operator Duration <=
 * @tsplus static Duration.Aspects lowerThenOrEqual
 * @tsplus pipeable Duration lowerThenOrEqual
 */

export function lowerThenOrEqual(that) {
  return self => self.millis <= that.millis;
}
/**
 * @tsplus pipeable-operator Duration >
 * @tsplus static Duration.Aspects greaterThen
 * @tsplus pipeable Duration greaterThen
 */

export function greaterThen(that) {
  return self => self.millis > that.millis;
}
/**
 * @tsplus pipeable-operator Duration >=
 * @tsplus static Duration.Aspects greaterThenOrEqual
 * @tsplus pipeable Duration greaterThenOrEqual
 */

export function greaterThenOrEqual(that) {
  return self => self.millis >= that.millis;
}
/**
 * @tsplus pipeable-operator Duration ==
 * @tsplus static Duration.Aspects equals
 * @tsplus pipeable Duration equals
 */

export function equals(that) {
  return self => self.millis === that.millis;
}
//# sourceMappingURL=Duration.mjs.map