import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/separate";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/HKT";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Either/forEachF";
/**
 * Get `Wiltable`'s `separateF` for an `Either<E, A>` given an
 * `AssociativeIdentity<E>`.
 *
 * @tsplus static Either.Ops getSeparateF
 */

export function getSeparateF(M) {
  const separate = tsplus_module_1.separate(M);
  return G => f => either => {
    const traverseF = tsplus_module_3.forEachF(G);
    return G.map(e => separate(e))(traverseF(f)(either));
  };
}
//# sourceMappingURL=getSeparateF.mjs.map