import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
/**
 * Extends this computation with another computation that depends on the
 * result of this computation by running the first computation, using its
 * result to generate a second computation, and running that computation.
 *
 * @tsplus static Either.Aspects flatMap
 * @tsplus pipeable Either flatMap
 */

export function flatMap(f) {
  return self => tsplus_module_1.isLeft(self) ? self : f(self.right);
}
//# sourceMappingURL=flatMap.mjs.map