import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
/**
 * Takes two functions and an `Either` value, if the value is a `Left` the
 * inner value is applied to the first function, if the value is a `Right` the
 * inner value is applied to the second function.
 *
 * @tsplus static Either.Aspects fold
 * @tsplus pipeable Either fold
 */

export function fold(onLeft, onRight) {
  return self => tsplus_module_1.isLeft(self) ? onLeft(self.left) : onRight(self.right);
}
//# sourceMappingURL=fold.mjs.map