import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Either/definition";
/**
 * Construct `Either<E, A>` from `Maybe<A>` constructing `E` with `onNone`.
 *
 * @tsplus static Either.Ops fromMaybe
 */

export function fromMaybe(maybe, onNone) {
  return tsplus_module_1.isNone(maybe) ? tsplus_module_2.left(onNone()) : tsplus_module_2.right(maybe.value);
}
//# sourceMappingURL=fromMaybe.mjs.map