import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Associative/definition";
/**
 * Get an `Associative` instance for `Either` that combines both success and failure
 * given `Associative` of `A` & `E`.
 *
 * @tsplus static Either.Ops getValidationAssociative
 */

export function getValidationAssociative(SE, SA) {
  return tsplus_module_2.Associative((fx, fy) => tsplus_module_1.isLeft(fx) ? tsplus_module_1.isLeft(fy) ? tsplus_module_1.left(SE.combine(fx.left, fy.left)) : fx : tsplus_module_1.isLeft(fy) ? fy : tsplus_module_1.right(SA.combine(fx.right, fy.right)));
}
//# sourceMappingURL=getValidationAssociative.mjs.map