import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
/**
 * Separates an `Either<E, Either<A, B>>` into a
 * `Tuple<[Either<E, A>, Either<E, B>]>` given an `AssociativeIdentity<E>`.
 *
 * @tsplus static Either.Aspects separate
 * @tsplus pipeable Either separate
 */

export function separate(M) {
  return self => {
    const empty = tsplus_module_1.left(M.identity);
    return tsplus_module_1.isLeft(self) ? [self, self] : tsplus_module_1.isLeft(self.right) ? [tsplus_module_1.right(self.right.left), empty] : [empty, tsplus_module_1.right(self.right.right)];
  };
}
//# sourceMappingURL=separate.mjs.map