import * as tsplus_module_1 from "@tsplus/stdlib/data/Either/definition";
/**
 * Constructs a new `Either` from a function that might throw.
 *
 * @tsplus static Either.Ops tryCatch
 */

export function tryCatch(f, onError) {
  try {
    return tsplus_module_1.right(f());
  } catch (e) {
    return tsplus_module_1.left(onError(e));
  }
}
//# sourceMappingURL=tryCatch.mjs.map