/**
 * Performs unsafe coercion of types
 *
 * @tsplus macro identity
 */
export function unsafeCoerce(a) {
  return a;
}
/**
 * Will raise if called
 */

export function absurd(_) {
  throw new Error("Called `absurd` function which should be uncallable");
}
/**
 * A constant function that always return A
 */

export function constant(a) {
  return () => a;
}
/**
 * A thunk that returns always `false`
 */

export function constFalse() {
  return false;
}
/**
 * A thunk that returns always `null`
 */

export function constNull() {
  return null;
}
/**
 * A thunk that returns always `true`
 */

export function constTrue() {
  return true;
}
/**
 * A thunk that returns always `undefined`
 */

export function constUndefined() {
  return;
}
/**
 * A thunk that returns always `void`
 */

export function constVoid() {
  return;
}
/**
 * Flips the order of the arguments of a function of two arguments.
 */

export function flip(f) {
  return (b, a) => f(a, b);
}
/**
 * Identity function
 *
 * @tsplus macro identity
 */

export function identity(a) {
  return a;
}
/**
 * Force string to be literal
 *
 * @tsplus macro identity
 */

export function literal(k) {
  return k;
}
/**
 * Type Hole, to be used while implementing functions where you need a placeholder
 */

export function hole() {
  throw new Error("Hole should never be called");
}
export * from "@tsplus/stdlib/data/Function/pipe";
//# sourceMappingURL=Function.mjs.map