export class LazyValue {
  constructor(__lazy) {
    this.__lazy = __lazy;
  }

  get value() {
    const computed = this.__lazy();

    Object.defineProperty(this, "value", {
      value: computed
    });
    return computed;
  }

}

LazyValue.make = f => new LazyValue(f);
//# sourceMappingURL=LazyValue.mjs.map