import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
export const Match = {
  $: {}
};
/**
 * @tsplus static Match/Aspects pattern
 */

const pattern_1 = n => (_, d) => m => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

export const pattern = pattern_1;
/**
 * @tsplus static Match/Aspects tag
 */

export const matchTag = /*#__PURE__*/pattern_1("_tag");
/**
 * @tsplus static Match/Ops pattern
 */

const pattern_2 = n => (m, _, d) => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

export const pattern_ = pattern_2;
/**
 * @tsplus static Match/Ops tag
 */

export const matchTag_ = /*#__PURE__*/pattern_2("_tag");
/**
 * @tsplus static Match/Aspects patternFor
 */

const patternFor_1 = n => () => (_, d) => m => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

export const patternFor = patternFor_1;
/**
 * @tsplus static Match/Ops tagFor
 */

export const matchTagFor = /*#__PURE__*/patternFor_1("_tag");
/**
 * @tsplus static Match/Ops isAdtElement
 */

export function isAdtElement_(tag, adt) {
  return adt["_tag"] === tag;
}
/**
 * @tsplus static Match/Aspects isAdtElement
 */

export const isAdtElement = adt => tag => isAdtElement_(tag, adt);
/**
 * @tsplus static Match/Ops isGenericAdtElement
 */

export function isGenericAdtElement(_t) {
  return tag => adt => adt[_t] === tag;
}
/**
 * @tsplus static Match/Ops onAdtElement
 */

export function onAdtElement(tag, f) {
  return adt => {
    if (adt["_tag"] === tag) {
      return tsplus_module_1.some(f(adt));
    }

    return tsplus_module_1.none;
  };
}
/**
 * @tsplus static Match/Ops onGenericAdtElement
 */

export function onGenericAdtElement(_t) {
  return (tag, f) => adt => {
    if (adt[_t] === tag) {
      return tsplus_module_1.some(f(adt));
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=Match.mjs.map