import * as tsplus_module_1 from "@tsplus/stdlib/structure/Equals";
export const Maybe = {
  $: {}
};
/**
 * @tsplus unify Maybe
 * @tsplus unify Maybe.Some
 * @tsplus unify Maybe.None
 */

export function unifyMaybe(self) {
  return self;
}
/**
 * Constructs `None`.
 *
 * @tsplus static Maybe.Ops none
 */

const none_1 = {
  _tag: "None"
};
export const none = none_1;
/**
 * Constructs `None`.
 *
 * @tsplus static Maybe.Ops empty
 */

export function empty() {
  return none_1;
}
/**
 * Constructs `Some<A>`.
 *
 * @tsplus static Maybe.Ops some
 */

export function some(a) {
  return {
    _tag: "Some",
    value: a
  };
}
/**
 * Returns `true` if the maybe is `None`, `false` otherwise.
 *
 * @tsplus fluent Maybe isNone
 */

export function isNone(fa) {
  return fa._tag === "None";
}
/**
 * Returns `true` if the maybe is an instance of `Some`, `false` otherwise.
 *
 * @tsplus fluent Maybe isSome
 */

export function isSome(fa) {
  return fa._tag === "Some";
}
/**
 * @tsplus static Maybe.Ops isMaybe
 */

export function isMaybe(u) {
  return typeof u === "object" && u != null && "_tag" in u && (u["_tag"] === "Some" || u["_tag"] === "None");
}
/**
 * @tsplus operator Maybe ==
 */

export function equals(a, b) {
  return tsplus_module_1.equals(a, b);
}
//# sourceMappingURL=definition.mjs.map