import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Takes a default value, a function, and an `Maybe` value, if the `Maybe`
 * value is `None` the default value is returned, otherwise the function is
 * applied to the value inside the `Some` and the result is returned.
 *
 * @tsplus static Maybe.Aspects fold
 * @tsplus pipeable Maybe fold
 */

export function fold(onNone, onSome) {
  return self => tsplus_module_1.isNone(self) ? onNone() : onSome(self.value);
}
//# sourceMappingURL=fold.mjs.map