import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Associative/definition";
/**
 * Associative for `Maybe<A>`
 *
 * @tsplus static Maybe.Ops getAssociative
 */

export function getAssociative(S) {
  switch (S) {
    case "First":
      {
        return tsplus_module_2.Associative((x, y) => tsplus_module_1.isNone(x) ? y : x);
      }

    case "Last":
      {
        return tsplus_module_2.Associative((x, y) => tsplus_module_1.isNone(y) ? x : y);
      }
  }

  return tsplus_module_2.Associative((x, y) => tsplus_module_1.isSome(x) && tsplus_module_1.isSome(y) ? tsplus_module_1.some(S.combine(x.value, y.value)) : tsplus_module_1.none);
}
//# sourceMappingURL=getAssociative.mjs.map