import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/getAssociative";
import * as tsplus_module_3 from "@tsplus/stdlib/prelude/AssociativeIdentity/fromAssociative";
/**
 * AssociativeIdentity for `Maybe<A>`
 *
 * @tsplus static Maybe.Ops getAssociativeIdentity
 */

export function getAssociativeIdentity(M) {
  switch (M) {
    case "First":
      {
        return tsplus_module_3.fromAssociative(tsplus_module_1.none, tsplus_module_2.getAssociative("First"));
      }

    case "Last":
      {
        return tsplus_module_3.fromAssociative(tsplus_module_1.none, tsplus_module_2.getAssociative("Last"));
      }
  }

  return tsplus_module_3.fromAssociative(tsplus_module_1.some(M.identity), tsplus_module_2.getAssociative(M));
}
//# sourceMappingURL=getAssociativeIdentity.mjs.map