import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Extracts the value out of the structure, if it exists. Otherwise returns the
 * given default value.
 *
 * @tsplus fluent Maybe getOrElse
 */

export function getOrElse_(self, onNone) {
  return tsplus_module_1.isNone(self) ? onNone() : self.value;
}
/**
 * @tsplus static Maybe.Aspects getOrElse
 */

export const getOrElse = onNone => self => getOrElse_(self, onNone);
//# sourceMappingURL=getOrElse.mjs.map