import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Returns a `Refinement` (i.e. a custom type guard) from a `Maybe` returning
 * function.
 *
 * This function ensures that a custom type guard definition is type-safe.
 *
 * @tsplus static Maybe.Ops getRefinement
 */

export function getRefinement(getMaybe) {
  return a => tsplus_module_1.isSome(getMaybe(a));
}
//# sourceMappingURL=getRefinement.mjs.map