import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/fromNullable";
/**
 * This is `chain` + `fromNullable`, useful when working with optional values.
 *
 * @tsplus static Maybe.Aspects mapNullable
 * @tsplus pipeable Maybe mapNullable
 */

export function mapNullable(f) {
  return self => tsplus_module_1.isNone(self) ? tsplus_module_1.none : tsplus_module_2.fromNullable(f(self.value));
}
//# sourceMappingURL=mapNullable.mjs.map