import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Transforms an exception into an `Maybe`. If `f` throws, returns `None`,
 * otherwise returns the output wrapped in `Some`.
 *
 * @tsplus static Maybe.Ops tryCatch
 */

export function tryCatch(f) {
  try {
    return tsplus_module_1.some(f());
  } catch (e) {
    return tsplus_module_1.none;
  }
}
//# sourceMappingURL=tryCatch.mjs.map