import * as tsplus_module_1 from "@tsplus/stdlib/data/Maybe/map";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/flatMap";
/**
 * Zips `Maybe<A>` and `Maybe<B>` into `Maybe<C>` using the provided zipper.
 *
 * @tsplus static Maybe.Aspects zipWith
 * @tsplus pipeable Maybe zipWith
 */

export function zipWith(that, f) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.map(b => f(a, b))(that))(self);
}
//# sourceMappingURL=zipWith.mjs.map