import * as tsplus_module_1 from "@tsplus/stdlib/io/Eval/succeed";
import * as tsplus_module_2 from "@tsplus/stdlib/io/Eval/flatMap";
import * as tsplus_module_3 from "@tsplus/stdlib/io/Eval/suspend";
export class GenEval {
  constructor(io) {
    this.io = io;
  }

  *[Symbol.iterator]() {
    return yield this;
  }

}

function adapter(_) {
  return new GenEval(_);
}

function run_(state, iterator) {
  if (state.done) {
    return tsplus_module_1.succeed(() => state.value);
  }

  return tsplus_module_2.flatMap(val => {
    const next = iterator.next(val);
    return run_(next, iterator);
  })(state.value["io"]);
}
/**
 * Generator
 *
 * @tsplus static Eval.Ops gen
 */


export function gen(f) {
  return tsplus_module_3.suspend(() => {
    const iterator = f(adapter);
    const state = iterator.next();
    return run_(state, iterator);
  });
}
//# sourceMappingURL=gen.mjs.map