import * as tsplus_module_1 from "@tsplus/stdlib/io/Eval/succeed";
import * as tsplus_module_2 from "@tsplus/stdlib/io/Eval/flatMap";
/**
 * Extends this computation with another computation that depends on the
 * result of this computation by running the first computation, using its
 * result to generate a second computation, and running that computation.
 *
 * @tsplus static Eval.Aspects map
 * @tsplus pipeable Eval map
 */

export function map(f) {
  return self => tsplus_module_2.flatMap(a => tsplus_module_1.succeed(() => f(a)))(self);
}
//# sourceMappingURL=map.mjs.map