import * as tsplus_module_1 from "@tsplus/stdlib/data/Stack";
/**
 * Runs this computation.
 *
 * @tsplus getter Eval run
 */

export function run(self) {
  let stack = undefined;
  let a = undefined;
  let curIO = self;

  while (curIO != null) {
    switch (curIO._tag) {
      case "FlatMap":
        {
          switch (curIO.value._tag) {
            case "Succeed":
              {
                curIO = curIO.cont(curIO.value.a());
                break;
              }

            default:
              {
                stack = new tsplus_module_1.Stack(curIO.cont, stack);
                curIO = curIO.value;
              }
          }

          break;
        }

      case "Suspend":
        {
          curIO = curIO.f();
          break;
        }

      case "Succeed":
        {
          a = curIO.a();

          if (stack) {
            curIO = stack.value(a);
            stack = stack.previous;
          } else {
            curIO = undefined;
          }

          break;
        }
    }
  } // @ts-expect-error


  return a;
}
//# sourceMappingURL=run.mjs.map