import { addArrayIntToNew, addOneToPositiveArrayInt, substractArrayIntToNew, trimArrayIntInplace } from "@tsplus/stdlib/io/Random/Distribution/_internal/ArrayInt";
import { uniformArrayIntDistributionInternal } from "@tsplus/stdlib/io/Random/Distribution/_internal/uniformArrayIntDistributionInternal";
/** @internal */

function uniformArrayIntInternal(from, to, rng) {
  const rangeSize = trimArrayIntInplace(addOneToPositiveArrayInt(substractArrayIntToNew(to, from)));
  const emptyArrayIntData = rangeSize.data.slice(0);
  const g = uniformArrayIntDistributionInternal(emptyArrayIntData, rangeSize.data, rng);
  return trimArrayIntInplace(addArrayIntToNew({
    sign: 1,
    data: g
  }, from));
}

export function uniformArrayIntDistribution(from, to, rng) {
  if (rng != null) {
    return uniformArrayIntInternal(from, to, rng);
  }

  return function (rng) {
    return uniformArrayIntInternal(from, to, rng);
  };
}
//# sourceMappingURL=uniformArrayIntDistribution.mjs.map