import { fromNumberToArrayInt64, substractArrayInt64 } from "@tsplus/stdlib/io/Random/Distribution/_internal/ArrayInt";
import { uniformArrayIntDistributionInternal } from "@tsplus/stdlib/io/Random/Distribution/_internal/uniformArrayIntDistributionInternal";
import { uniformIntDistributionInternal } from "@tsplus/stdlib/io/Random/Distribution/_internal/uniformIntDistributionInternal";
const sharedA = {
  sign: 1,
  data: [0, 0]
};
const sharedB = {
  sign: 1,
  data: [0, 0]
};
const sharedC = {
  sign: 1,
  data: [0, 0]
};
const sharedData = [0, 0];

function uniformLargeIntInternal(from, to, rangeSize, rng) {
  const rangeSizeArrayIntValue = rangeSize <= Number.MAX_SAFE_INTEGER ? fromNumberToArrayInt64(sharedC, rangeSize) // no possible overflow given rangeSize is in a safe range
  : substractArrayInt64(sharedC, fromNumberToArrayInt64(sharedA, to), fromNumberToArrayInt64(sharedB, from)); // rangeSize might be incorrect, we compute a safer range
  // Adding 1 to the range

  if (rangeSizeArrayIntValue.data[1] === 0xffffffff) {
    // rangeSizeArrayIntValue.length === 2 by construct
    // rangeSize >= 0x00000001_00000000 and rangeSize <= 0x003fffff_fffffffe
    // with Number.MAX_SAFE_INTEGER - Number.MIN_SAFE_INTEGER = 0x003fffff_fffffffe
    rangeSizeArrayIntValue.data[0] += 1;
    rangeSizeArrayIntValue.data[1] = 0;
  } else {
    rangeSizeArrayIntValue.data[1] += 1;
  }

  uniformArrayIntDistributionInternal(sharedData, rangeSizeArrayIntValue.data, rng);
  return sharedData[0] * 0x100000000 + sharedData[1] + from;
}

function uniformIntInternal(from, to, rng) {
  const rangeSize = to - from;

  if (rangeSize <= 0xffffffff) {
    // Calling uniformIntDistributionInternal can be considered safe
    // up-to 2**32 values. Above this range it may miss values.
    let g = uniformIntDistributionInternal(rangeSize + 1, rng);
    g += from;
    return g;
  }

  return uniformLargeIntInternal(from, to, rangeSize, rng);
}

export function uniformIntDistribution(from, to, rng) {
  if (rng != null) {
    return uniformIntInternal(from, to, rng);
  }

  return rng => uniformIntInternal(from, to, rng);
}
//# sourceMappingURL=uniformIntDistribution.mjs.map