import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Associative/definition";
/**
 * Given a struct of `Associative`s, returns an `Associative` for the structure.
 *
 * @tsplus static Associative/Ops struct
 */

export function struct(associatives) {
  return tsplus_module_1.Associative((x, y) => {
    const r = {};

    for (const k in associatives) {
      if (Object.prototype.hasOwnProperty.call(associatives, k)) {
        r[k] = associatives[k].combine(x[k], y[k]);
      }
    }

    return r;
  });
}
//# sourceMappingURL=struct.mjs.map