import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Associative/struct";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/AssociativeIdentity/definition";
/**
 * Given a struct of `AssociativeIdentity`s, returns a `Identity` for the
 * structure.
 *
 * @tsplus static AssociativeIdentity/Ops struct
 */

export function struct(identities) {
  const r = {};

  for (const k in identities) {
    if (Object.prototype.hasOwnProperty.call(identities, k)) {
      r[k] = identities[k].identity;
    }
  }

  return tsplus_module_2.AssociativeIdentity(r, tsplus_module_1.struct(identities).combine);
}
//# sourceMappingURL=struct.mjs.map