import * as tsplus_module_1 from "@tsplus/stdlib/prelude/DSL/apF";
import { curried } from "@tsplus/stdlib/prelude/DSL/_internal/curried";

function getRecordConstructor(keys) {
  const len = keys.length;
  return curried((...args) => {
    const r = {};

    for (let i = 0; i < len; i++) {
      r[keys[i]] = args[i];
    }

    return r;
  }, len - 1, []);
}
/**
 * @tsplus static DSL structF
 */


export function structF(F) {
  return r => {
    const ap = tsplus_module_1.apF(F);
    const keys = Object.keys(r);
    const len = keys.length;
    const f = getRecordConstructor(keys);
    let fr = F.map(f)(r[keys[0]]);

    for (let i = 1; i < len; i++) {
      fr = ap(r[keys[i]])(fr);
    }

    return fr;
  };
}
//# sourceMappingURL=structF.mjs.map