import * as tsplus_module_1 from "@tsplus/stdlib/prelude/DSL/apF";
import { curried } from "@tsplus/stdlib/prelude/DSL/_internal/curried";
const tupleConstructors = {};

function getTupleConstructor(len) {
  // eslint-disable-next-line no-prototype-builtins
  if (!tupleConstructors.hasOwnProperty(len)) {
    tupleConstructors[len] = curried((...t) => t, len - 1, []);
  }

  return tupleConstructors[len];
}
/**
 * @tsplus static DSL tupleF
 */


export const tupleF = F => (...args) => {
  const ap = tsplus_module_1.apF(F);
  const len = args.length;
  const f = getTupleConstructor(len);
  let fas = F.map(f)(args[0]);

  for (let i = 1; i < len; i++) {
    fas = ap(args[i])(fas);
  }

  return fas;
};
//# sourceMappingURL=tupleF.mjs.map