import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Equivalence/definition";
/**
 * Derives an `Equivalence<Array<A>>` given an `Equivalence<A>`.
 *
 * @tsplus static Equivalence/Ops array
 */

export function array(E) {
  return tsplus_module_1.Equivalence((x, y) => {
    if (x.length === y.length) {
      for (let i = 0; i < x.length; i++) {
        if (!E.equals(x[i], y[i])) {
          return false;
        }
      }

      return true;
    }

    return false;
  });
}
//# sourceMappingURL=array.mjs.map