import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Equivalence/definition";
/**
 * Constructs an `Equivalence<B>` given an `Equivalence<A>` and a function `f`
 * to transform a `B` value into an `A` value. The instance will convert each
 * `B` value into an `A` and the compare the `A` values for equality.
 *
 * @tsplus fluent Equivalence contramap
 */

export function contramap_(self, f) {
  return tsplus_module_1.Equivalence((x, y) => self.equals(f(x), f(y)));
}
/**
 * Constructs an `Equivalence<B>` given an `Equivalence<A>` and a function `f`
 * to transform a `B` value into an `A` value. The instance will convert each
 * `B` value into an `A` and the compare the `A` values for equality.
 *
 * @tsplus static Equivalence/Aspects contramap
 */

export const contramap = f => self => contramap_(self, f);
//# sourceMappingURL=contramap.mjs.map