import * as tsplus_module_1 from "@tsplus/stdlib/prelude/HKT";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Covariant";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Function";
export const ForEach = {};
export function implementForEachF() {
  return i => i();
}
/**
 * @tsplus static ForEach/Ops getComposition
 */

export function getComposition(F_, G_) {
  return { ...tsplus_module_2.getCovariantComposition(F_, G_),
    forEachF: H => f => fa => F_.forEachF(H)(G_.forEachF(H)(f))(fa)
  };
}
/**
 * @tsplus static ForEach/Ops sequenceF
 */

export function sequenceF(T) {
  return App => {
    const traverse = T.forEachF(App);
    return traverse(tsplus_module_3.identity);
  };
}
//# sourceMappingURL=ForEach.mjs.map