import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Ordering/instances/Associative";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/prelude/Associative/definition";
/**
 * Returns a `Associative` such that `combine(ord2)(ord1)`  will order first by
 * `ord1`, and then by `ord2`.
 *
 * @tsplus static Ord/Ops getAssociative
 */

export function getAssociative() {
  return tsplus_module_3.Associative((x, y) => tsplus_module_2.Ord((a, b) => tsplus_module_1.Associative.combine(x.compare(a, b), y.compare(a, b))));
}
//# sourceMappingURL=getAssociative.mjs.map