import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Ord/definition";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/Ord/getAssociative";
import * as tsplus_module_3 from "@tsplus/stdlib/prelude/AssociativeIdentity/fromAssociative";
/**
 * Returns an `AssociativeIdentity` such that:
 * - `combine(ord2)(ord1)` will order first by `ord1`, and then by `ord2`
 * - `identity` is an `Ord` that always considers compared elements equal
 *
 * @tsplus static Ord/Ops getAssociativeIdentity
 */

export function getAssociativeIdentity() {
  return tsplus_module_3.fromAssociative(tsplus_module_1.Ord(() => 0), tsplus_module_2.getAssociative());
}
//# sourceMappingURL=getAssociativeIdentity.mjs.map