import * as tsplus_module_1 from "@tsplus/stdlib/prelude/DSL/flatMapF";
/**
 * Monadic fold over a datstructure `R` with an algebra `(r: Recursive<Z>) => M<Z>`
 * eventually returning an `M<Z>`
 *
 * @tsplus static Recursive/Aspects foldM
 * @tsplus pipeable Recursive foldM
 */

export function foldM(F, M, f) {
  const mapM = F.forEachF(M);
  const chain = tsplus_module_1.flatMapF(M);

  const go = term => chain(f)(mapM(go)(term.caseValue));

  return self => go(self);
}
//# sourceMappingURL=foldM.mjs.map