import * as tsplus_module_1 from "@tsplus/stdlib/prelude/Recursive/definition";
import { Recursive } from "@tsplus/stdlib/prelude/Recursive/definition";
/**
 * Use a `Covariant<F>` and an `Unfolder.Fn<F, Z>` function to generate a Recurisve<F>
 * structure.  The `unfolder` is non-recursive and generates a single level of the
 * structure.
 * i.e. _anamorphism_
 *
 * @tsplus static Recursive/Ops unfold
 */

export function unfold(F, unfolder) {
  return function self(a) {
    return tsplus_module_1.makeRecursive(F.map(self)(unfolder(a)));
  };
}
//# sourceMappingURL=unfold.mjs.map