import * as tsplus_module_1 from "@tsplus/stdlib/prelude/DSL/succeedF";
import * as tsplus_module_2 from "@tsplus/stdlib/prelude/DSL/flatMapF";
import * as tsplus_module_3 from "@tsplus/stdlib/prelude/HKT";
import * as tsplus_module_4 from "@tsplus/stdlib/data/Either/fold";
import * as tsplus_module_5 from "@tsplus/stdlib/data/Function";
import * as tsplus_module_6 from "@tsplus/stdlib/data/Either/definition";
import * as tsplus_module_7 from "@tsplus/stdlib/data/Either/map";
export const branchF = branchF_1;
export const ifF = ifF_1;
export const Select = {};
/**
 * @tsplus static Select/Ops monad
 */

export function monadF(F) {
  const succeedF = tsplus_module_1.succeedF(F);
  const flatMapF_ = tsplus_module_2.flatMapF_(F);
  return { ...F,
    select: fab => fa => flatMapF_(fa, either => tsplus_module_4.fold(a => F.map(g => g(a))(fab), b => succeedF(b))(either))
  };
}
/**
 * @tsplus static Select/Ops applicative
 */

export function applicativeF(F) {
  return { ...F,
    select: fab => fa => {
      const both = F.both(fab)(fa);
      return F.map(([ea, f]) => tsplus_module_4.fold(f, tsplus_module_5.identity)(ea))(both);
    }
  };
}
/**
 * @tsplus static Select/Ops branchF
 */

function branchF_1(F) {
  return (left, right) => fe => {
    const mapped = F.map(either => tsplus_module_7.map(tsplus_module_6.left)(either))(fe);
    const selected = F.select(F.map(fac => a => tsplus_module_6.right(fac(a)))(left))(mapped);
    return F.select(right)(selected);
  };
}
/**
 * @tsplus static Select/Ops ifF
 */


function ifF_1(F) {
  return (then_, else_) => if_ => {
    const mapped = F.map(b => b ? tsplus_module_6.left(undefined) : tsplus_module_6.right(undefined))(if_);
    return branchF_1(F)(F.map(a => () => a)(then_), F.map(b => () => b)(else_))(mapped);
  };
}
/**
 * @tsplus static Select/Ops whenF
 */


export function whenF(F) {
  const succeedF = tsplus_module_1.succeedF(F);
  return act => if_ => ifF_1(F)(act, succeedF(undefined))(if_);
}
//# sourceMappingURL=Selective.mjs.map