import * as tsplus_module_1 from "@tsplus/stdlib/exceptions";
import * as tsplus_module_2 from "@tsplus/stdlib/data/Maybe/definition";
import * as tsplus_module_3 from "@tsplus/stdlib/data/Function";

function methodAdd(tag, service) {
  const map = new Map(this.unsafeMap); // @ts-expect-error

  map.set(tag, service);
  return new Env(map);
}

function methodGet(tag) {
  // @ts-expect-error
  if (!this.unsafeMap.has(tag)) {
    throw new tsplus_module_1.NoSuchElement();
  } // @ts-expect-error


  return this.unsafeMap.get(tag);
}

function methodGetMaybe(tag) {
  // @ts-expect-error
  return this.unsafeMap.has(tag) ? tsplus_module_2.some(this.unsafeMap.get(tag)) : tsplus_module_2.none;
}

function methodMerge(that) {
  const map = new Map(this.unsafeMap);

  for (const [tag, s] of that.unsafeMap) {
    map.set(tag, s);
  }

  return new Env(map);
}

function pruneMethod(...tags) {
  const tagSet = new Set(tags);
  const newEnv = new Map();

  for (const [tag, s] of this.unsafeMap.entries()) {
    // @ts-expect-error
    if (tagSet.has(tag)) {
      newEnv.set(tag, s);
    }
  }

  return new Env(newEnv);
}

const sym = /*#__PURE__*/Symbol("@tsplus/stdlib/Env/Env");
export const Env = /*#__PURE__*/Object.assign(function self(a, b) {
  if (this != null && this.constructor === self) {
    return createEnv(a);
  }

  return Env.empty.add(a, b);
}, {
  sym,
  empty: /*#__PURE__*/createEnv( /*#__PURE__*/new Map())
});

function createEnv(unsafeMap) {
  return {
    [sym]: tsplus_module_3.identity,
    add: methodAdd,
    get: methodGet,
    unsafeGet: methodGet,
    getMaybe: methodGetMaybe,
    merge: methodMerge,
    prune: pruneMethod,
    unsafeMap
  };
}
//# sourceMappingURL=Env.mjs.map