import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import type * as P from "@tsplus/stdlib/prelude/ChainRec";
/**
 * @tsplus static Chunk.Ops depthFirstChainRec
 * @tsplus location "@tsplus/stdlib/collections/Chunk/instances/ChainRec"
 */
export declare function depthFirstChainRec_<A, B>(init: A, f: (a: A) => Chunk<Either<A, B>>): Chunk<B>;
/**
 * @tsplus static Chunk.Aspects depthFirstChainRec
 */
export declare const depthFirstChainRec: <A, B>(f: (a: A) => import("../definition").Chunk<import("../../../data/Either").Either<A, B>>) => (init: A) => import("../definition").Chunk<B>;
/**
 * @tsplus static Chunk.Ops DepthFirstChainRec
 * @tsplus location "@tsplus/stdlib/collections/Chunk/instances/ChainRec"
 */
export declare const DepthFirstChainRec: P.ChainRec<import("../definition").ChunkF>;
/**
 * @tsplus static Chunk.Ops breadthFirstChainRec
 * @tsplus location "@tsplus/stdlib/collections/Chunk/instances/ChainRec"
 */
export declare function breadthFirstChainRec_<A, B>(init: A, f: (a: A) => Chunk<Either<A, B>>): Chunk<B>;
/**
 * @tsplus static Chunk.Aspects breadthFirstChainRec
 */
export declare const breadthFirstChainRec: <A, B>(f: (a: A) => import("../definition").Chunk<import("../../../data/Either").Either<A, B>>) => (init: A) => import("../definition").Chunk<B>;
/**
 * @tsplus static Chunk.Ops BreadthFirstChainRec
 * @tsplus location "@tsplus/stdlib/collections/Chunk/instances/ChainRec"
 */
export declare const BreadthFirstChainRec: P.ChainRec<import("../definition").ChunkF>;
//# sourceMappingURL=ChainRec.d.ts.map