"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.breadthFirstChainRec = exports.DepthFirstChainRec = exports.BreadthFirstChainRec = void 0;
exports.breadthFirstChainRec_ = breadthFirstChainRec_;
exports.depthFirstChainRec = void 0;
exports.depthFirstChainRec_ = depthFirstChainRec_;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeHead"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeTail"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/concat"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/HKT"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static Chunk.Ops depthFirstChainRec
 */
function depthFirstChainRec_(init, f) {
  let todo = f(init);
  let result = tsplus_module_1.empty();

  while (tsplus_module_2.size(todo) > 0) {
    const either = tsplus_module_3.unsafeHead(todo);
    todo = tsplus_module_4.unsafeTail(todo);

    if (either._tag === "Left") {
      todo = tsplus_module_5.concat(todo)(f(either.left));
    } else {
      result = tsplus_module_6.append(either.right)(result);
    }
  }

  return result;
}
/**
 * @tsplus static Chunk.Aspects depthFirstChainRec
 */


const depthFirstChainRec_1 = f => init => depthFirstChainRec_(init, f);

const depthFirstChainRec = depthFirstChainRec_1;
/**
 * @tsplus static Chunk.Ops DepthFirstChainRec
 */

exports.depthFirstChainRec = depthFirstChainRec;
const DepthFirstChainRec = {
  chainRec: depthFirstChainRec_1
};
/**
 * @tsplus static Chunk.Ops breadthFirstChainRec
 */

exports.DepthFirstChainRec = DepthFirstChainRec;

function breadthFirstChainRec_(init, f) {
  let todo = f(init);
  let result = tsplus_module_1.empty();

  while (tsplus_module_2.size(todo) > 0) {
    const either = tsplus_module_3.unsafeHead(todo);
    todo = tsplus_module_4.unsafeTail(todo);

    if (either._tag === "Left") {
      todo = tsplus_module_5.concat(f(either.left))(todo);
    } else {
      result = tsplus_module_6.append(either.right)(result);
    }
  }

  return result;
}
/**
 * @tsplus static Chunk.Aspects breadthFirstChainRec
 */


const breadthFirstChainRec_1 = f => init => breadthFirstChainRec_(init, f);

const breadthFirstChainRec = breadthFirstChainRec_1;
/**
 * @tsplus static Chunk.Ops BreadthFirstChainRec
 */

exports.breadthFirstChainRec = breadthFirstChainRec;
const BreadthFirstChainRec = {
  chainRec: breadthFirstChainRec_1
};
exports.BreadthFirstChainRec = BreadthFirstChainRec;
//# sourceMappingURL=ChainRec.js.map