"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.collectWhile = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/single"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fold"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const collectWhile = collectWhile_1;
exports.collectWhile = collectWhile;

/**
 * Transforms all elements of the chunk for as long as the specified partial
 * function is defined.
 *
 * @tsplus static Chunk.Aspects collectWhile
 * @tsplus pipeable Chunk collectWhile
 */
function collectWhile_1(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case _definition2.SingletonTypeId:
        {
          return tsplus_module_3.fold(() => tsplus_module_1.empty(), tsplus_module_2.single)(f(self.a));
        }

      case _definition2.ArrTypeId:
        {
          const array = self._arrayLike();

          let dest = tsplus_module_1.empty();

          for (let i = 0; i < array.length; i++) {
            const rhs = f(array[i]);

            if (tsplus_module_4.isSome(rhs)) {
              dest = tsplus_module_5.append(rhs.value)(dest);
            } else {
              return dest;
            }
          }

          return dest;
        }

      default:
        {
          return collectWhile_1(f)(self._materialize());
        }
    }
  };
}
//# sourceMappingURL=collectWhile.js.map