"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.drop = drop;

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

/**
 * Drops the first `n` elements.
 *
 * @tsplus static Chunk.Aspects drop
 * @tsplus pipeable Chunk drop
 */
function drop(n) {
  return self => {
    void 0;

    if (n <= 0) {
      return self;
    } else if (n >= self.length) {
      return _definition._Empty;
    } else {
      const len = self.length;

      switch (self._typeId) {
        case _definition.EmptyTypeId:
          {
            return _definition._Empty;
          }

        case _definition.SliceTypeId:
          {
            return new _definition.Slice(self.chunk, self.offset + n, self.length - n);
          }

        case _definition.SingletonTypeId:
          {
            if (n > 0) {
              return _definition._Empty;
            }

            return self;
          }

        default:
          {
            return new _definition.Slice(self, n, len - n);
          }
      }
    }
  };
}
//# sourceMappingURL=drop.js.map