"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filter = filter;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function filter(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case _definition.ArrTypeId:
        {
          const arr = self._arrayLike();

          const len = arr.length;
          let i = 0;
          let builder = tsplus_module_1.empty();

          while (i < len) {
            const elem = arr[i];

            if (f(elem)) {
              builder = tsplus_module_2.append(elem)(builder);
            }

            i++;
          }

          return builder;
        }

      default:
        {
          const iterator = self._arrayLikeIterator();

          let next;
          let builder = tsplus_module_1.empty();

          while ((next = iterator.next()) && !next.done) {
            const array = next.value;
            const len = array.length;
            let i = 0;

            while (i < len) {
              const a = array[i];

              if (f(a)) {
                builder = tsplus_module_2.append(a)(builder);
              }

              i++;
            }
          }

          return builder;
        }
    }
  };
}
//# sourceMappingURL=filter.js.map