import { Refinement } from "@tsplus/stdlib/data/Function";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Returns the first element that satisfies the predicate.
 * @tsplus static Chunk.Aspects find
 * @tsplus pipeable Chunk find
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/find"
 */
export declare function find<A, B extends A>(f: Refinement<A, B>): (self: Chunk<A>) => Maybe<B>;
export declare function find<A>(f: Predicate<A>): (self: Chunk<A>) => Maybe<A>;
//# sourceMappingURL=find.d.ts.map