import { Refinement } from "@tsplus/stdlib/data/Function";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Returns the last element that satisfies the predicate.
 * @tsplus static Chunk.Aspects findLast
 * @tsplus pipeable Chunk findLast
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/findLast"
 */
export declare function findLast<A, B extends A>(f: Refinement<A, B>): (self: Chunk<A>) => Maybe<B>;
export declare function findLast<A>(f: Predicate<A>): (self: Chunk<A>) => Maybe<A>;
//# sourceMappingURL=findLast.d.ts.map