"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findLastIndex = findLastIndex;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns the last index of the element that satisfies the predicate.
 *
 * @tsplus static Chunk.Aspects findLastIndex
 * @tsplus pipeable Chunk findLastIndex
 */
function findLastIndex(f) {
  return self => {
    void 0;

    const iterator = self._reverseArrayLikeIterator();

    let next;
    let index = self.length - 1;

    while ((next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let i = len - 1;

      while (i >= 0) {
        const a = array[i];

        if (f(a)) {
          return tsplus_module_1.some(index);
        }

        i--;
        index--;
      }
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=findLastIndex.js.map