"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forEach = forEach;

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

/**
 * Iterate over the chunk applying `f`.
 *
 * @tsplus static Chunk.Aspects forEach
 * @tsplus pipeable Chunk forEach
 */
function forEach(f) {
  return self => {
    void 0;

    switch (self._typeId) {
      case _definition.ArrTypeId:
        {
          const arr = self._arrayLike();

          const len = arr.length;
          let i = 0;

          while (i < len) {
            f(arr[i]);
            i++;
          }

          return;
        }

      default:
        {
          const iterator = self._arrayLikeIterator();

          let next;

          while ((next = iterator.next()) && !next.done) {
            const array = next.value;
            const len = array.length;
            let i = 0;

            while (i < len) {
              const a = array[i];
              f(a);
              i++;
            }
          }

          return;
        }
    }
  };
}
//# sourceMappingURL=forEach.js.map