"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.grouped = grouped;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/size"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/forEach"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Groups elements in chunks of up to `n` elements.
 *
 * @tsplus static Chunk.Aspects grouped
 * @tsplus pipeable Chunk grouped
 */
function grouped(n) {
  return self => {
    let gr = tsplus_module_1.empty();
    let current = tsplus_module_1.empty();
    tsplus_module_4.forEach(a => {
      current = tsplus_module_2.append(a)(current);

      if (tsplus_module_3.size(current) >= n) {
        gr = tsplus_module_2.append(current)(gr);
        current = tsplus_module_1.empty();
      }
    })(self);

    if (tsplus_module_3.size(current) > 0) {
      gr = tsplus_module_2.append(current)(gr);
    }

    return gr;
  };
}
//# sourceMappingURL=grouped.js.map