import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Creates an array of unique values that are included in all given arrays using
 * an `Equivalence<A>` for equality comparisons. The order and references of
 * result values are determined by the first array.
 * @tsplus static Chunk.Aspects intersection
 * @tsplus pipeable Chunk intersection
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/intersection"
 */
export declare function intersection<A>(E: Equivalence<A>, that: Chunk<A>): (self: Chunk<A>) => Chunk<A>;
//# sourceMappingURL=intersection.d.ts.map