import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Separate elements based on a map function that also exposes the index of the
 * element.
 * @tsplus static Chunk.Aspects partitionMapWithIndex
 * @tsplus pipeable Chunk partitionMapWithIndex
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/partitionMapWithIndex"
 */
export declare function partitionMapWithIndex<A, B, C>(f: (i: number, a: A) => Either<B, C>): (self: Chunk<A>) => readonly [Chunk<B>, Chunk<C>];
//# sourceMappingURL=partitionMapWithIndex.d.ts.map