"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.partitionWithIndex = partitionWithIndex;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Separate elements based on a predicate that also exposes the index of the
 * element.
 *
 * @tsplus static Chunk.Aspects partitionWithIndex
 * @tsplus pipeable Chunk partitionWithIndex
 */
function partitionWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.length; i++) {
      const a = tsplus_module_1.unsafeGet(i)(self);

      if (f(i, a)) {
        right.push(a);
      } else {
        left.push(a);
      }
    }

    return [tsplus_module_2.from(left), tsplus_module_2.from(right)];
  };
}
//# sourceMappingURL=partitionWithIndex.js.map