import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Sort the elements of an array in increasing order, where elements are
 * compared using first `ords[0]`, then `ords[1]`, then `ords[2]`, etc.
 * @tsplus static Chunk.Aspects sortBy
 * @tsplus pipeable Chunk sortBy
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/sortBy"
 */
export declare function sortBy<A>(...ords: Array<Ord<A>>): (self: Chunk<A>) => Chunk<A>;
//# sourceMappingURL=sortBy.d.ts.map