"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.split = split;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/append"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/forEach"));

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits this chunk into `n` equally sized chunks.
 *
 * @tsplus static Chunk.Aspects split
 * @tsplus pipeable Chunk split
 */
function split(n) {
  return self => {
    const length = self.length;
    const k = Math.floor(n);
    const quotient = Math.floor(length / k);
    const remainder = length % k;
    let chunks = tsplus_module_1.empty();
    let i = 0;
    let chunk = tsplus_module_1.empty();
    tsplus_module_3.forEach(a => {
      chunk = tsplus_module_2.append(a)(chunk);

      if (i <= remainder && chunk.length > quotient || i > remainder && chunk.length >= quotient) {
        chunks = tsplus_module_2.append(chunk)(chunks);
        chunk = tsplus_module_1.empty();
      }

      i++;
    })(self);

    if (chunk.length > 0) {
      chunks = tsplus_module_2.append(chunk)(chunks);
    }

    return chunks;
  };
}
//# sourceMappingURL=split.js.map