"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitWhere = splitWhere;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/splitAt"));

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Splits this chunk on the first element that matches this predicate.
 *
 * @tsplus static Chunk.Aspects splitWhere
 * @tsplus pipeable Chunk splitWhere
 */
function splitWhere(f) {
  return self => {
    const iterator = self._arrayLikeIterator();

    let next;
    let cont = true;
    let i = 0;

    while (cont && (next = iterator.next()) && !next.done) {
      const array = next.value;
      const len = array.length;
      let j = 0;

      while (cont && j < len) {
        const a = array[j];

        if (f(a)) {
          cont = false;
        } else {
          i++;
          j++;
        }
      }
    }

    return tsplus_module_1.splitAt(i)(self);
  };
}
//# sourceMappingURL=splitWhere.js.map