import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Constructs a `Chunk` by repeatedly applying the function `f` as long as it
 * returns `Some`.
 * @tsplus static Chunk.Ops unfold
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/unfold"
 */
export declare function unfold<A, S>(s: S, f: (s: S) => Maybe<readonly [A, S]>): Chunk<A>;
//# sourceMappingURL=unfold.d.ts.map