import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Zips this chunk with the specified chunk to produce a new chunk with
 * pairs of elements from each chunk, filling in missing values from the
 * shorter chunk with `None`. The returned chunk will have the length of the
 * longer chunk.
 * @tsplus static Chunk.Aspects zipAll
 * @tsplus pipeable Chunk zipAll
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/zipAll"
 */
export declare function zipAll<B>(that: Chunk<B>): <A>(self: import("../definition").Chunk<A>) => import("../definition").Chunk<readonly [import("../../../data/Maybe").Maybe<A>, import("../../../data/Maybe").Maybe<B>]>;
//# sourceMappingURL=zipAll.d.ts.map