import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
/**
 * Zips with chunk with the specified chunk to produce a new chunk with
 * pairs of elements from each chunk combined using the specified function
 * `both`. If one chunk is shorter than the other uses the specified
 * function `left` or `right` to map the element that does exist to the
 * result type.
 * @tsplus static Chunk.Aspects zipAllWith
 * @tsplus pipeable Chunk zipAllWith
 * @tsplus location "@tsplus/stdlib/collections/Chunk/operations/zipAllWith"
 */
export declare function zipAllWith<A, B, C, D, E>(that: Chunk<B>, f: (a: A, b: B) => C, left: (a: A) => D, right: (b: B) => E): (self: Chunk<A>) => Chunk<C | D | E>;
//# sourceMappingURL=zipAllWith.d.ts.map