"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UpdateChunkPatch = exports.SliceChunkPatch = exports.EmptyChunkPatch = exports.ChunkPatchValueSym = exports.ChunkPatchSym = exports.ChunkPatchPatchSym = exports.ChunkPatch = exports.BaseChunkPatch = exports.AppendChunkPatch = exports.AndThenChunkPatch = void 0;
exports.chunkPatchInstruction = chunkPatchInstruction;
exports.unifyChunkPatch = unifyChunkPatch;

var _a;

const ChunkPatchSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch");
exports.ChunkPatchSym = ChunkPatchSym;
const ChunkPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch.Value");
exports.ChunkPatchValueSym = ChunkPatchValueSym;
const ChunkPatchPatchSym = /*#__PURE__*/Symbol.for("@Differ.Chunk.Patch.Patch");
/**
 * @tsplus static Differ.Ops Chunk
 */

exports.ChunkPatchPatchSym = ChunkPatchPatchSym;
const ChunkPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.Chunk.Patch
 */

exports.ChunkPatch = ChunkPatch;

function unifyChunkPatch(self) {
  return self;
}

class BaseChunkPatch {
  constructor() {
    this[_a] = ChunkPatchSym;
  }

}

exports.BaseChunkPatch = BaseChunkPatch;
_a = ChunkPatchSym;

class AppendChunkPatch extends BaseChunkPatch {
  constructor(values) {
    super();
    this.values = values;
    this._tag = "Append";
  }

}

exports.AppendChunkPatch = AppendChunkPatch;

class SliceChunkPatch extends BaseChunkPatch {
  constructor(from, until) {
    super();
    this.from = from;
    this.until = until;
    this._tag = "Slice";
  }

}

exports.SliceChunkPatch = SliceChunkPatch;

class UpdateChunkPatch extends BaseChunkPatch {
  constructor(index, patch) {
    super();
    this.index = index;
    this.patch = patch;
    this._tag = "Update";
  }

}

exports.UpdateChunkPatch = UpdateChunkPatch;

class AndThenChunkPatch extends BaseChunkPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}

exports.AndThenChunkPatch = AndThenChunkPatch;

class EmptyChunkPatch extends BaseChunkPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}
/**
 * @tsplus macro identity
 */


exports.EmptyChunkPatch = EmptyChunkPatch;

function chunkPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.js.map