import { Chunk } from "@tsplus/stdlib/collections/Chunk/definition";
import { Differ } from "@tsplus/stdlib/data/Differ/definition";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Applies a chunk patch to a chunk of values to produce a new chunk of
 * values which represents the original chunk of values updated with the
 * changes described by this patch.
 * @tsplus static Differ.Chunk.Patch.Aspects apply
 * @tsplus pipeable Differ.Chunk.Patch apply
 * @tsplus location "@tsplus/stdlib/collections/Chunk/patch/operations/apply"
 */
export declare function apply<Value, Patch>(oldValue: Chunk<Value>, differ: Differ<Value, Patch>): (self: Differ.Chunk.Patch<Value, Patch>) => Chunk<Value>;
//# sourceMappingURL=apply.d.ts.map