"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.diff = diff;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Differ/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/patch/operations/emptyPatch"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/unsafeGet"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/patch/operations/combine"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/drop"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/patch/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs a chunk patch from a new and old chunk of values and a differ
 * for the values.
 *
 * @tsplus static Differ.Chunk.Patch.Ops diff
 */
function diff(oldValue, newValue, differ) {
  let i = 0;
  let patch = tsplus_module_2.emptyPatch();

  while (i < oldValue.length && i < newValue.length) {
    const oldElement = tsplus_module_3.unsafeGet(i)(oldValue);
    const newElement = tsplus_module_3.unsafeGet(i)(newValue);
    const valuePatch = differ.diff(oldElement, newElement);

    if (!tsplus_module_4.equals(valuePatch, differ.empty)) {
      patch = tsplus_module_5.combine(new _definition2.UpdateChunkPatch(i, valuePatch))(patch);
    }

    i = i + 1;
  }

  if (i < oldValue.length) {
    patch = tsplus_module_5.combine(new _definition2.SliceChunkPatch(0, i))(patch);
  }

  if (i < newValue.length) {
    patch = tsplus_module_5.combine(new _definition2.AppendChunkPatch(tsplus_module_6.drop(i)(newValue)))(patch);
  }

  return patch;
}
//# sourceMappingURL=diff.js.map