import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Equals } from "@tsplus/stdlib/structure/Equals";
export declare const HashMapSym: unique symbol;
export type HashMapSym = typeof HashMapSym;
export declare const _K: unique symbol;
export type _K = typeof _K;
export declare const _V: unique symbol;
export type _V = typeof _V;
/**
 * @tsplus type HashMap
 */
export interface HashMap<K, V> extends Collection<readonly [K, V]>, Equals {
    readonly [HashMapSym]: HashMapSym;
    readonly [_K]: () => K;
    readonly [_V]: () => V;
    [Symbol.iterator](): Iterator<readonly [K, V]>;
}
/**
 * @tsplus type HashMap.Ops
 */
export interface HashMapOps {
    $: HashMapAspects;
}
export declare const HashMap: HashMapOps;
/**
 * @tsplus type HashMap.Aspects
 */
export interface HashMapAspects {
}
/**
 * @tsplus unify HashMap
 */
export declare function unifyHashMap<X extends HashMap<any, any>>(self: X): HashMap<[
    X
] extends [HashMap<infer K, any>] ? K : never, [
    X
] extends [HashMap<any, infer V>] ? V : never>;
/**
 * @tsplus static HashMap.Ops isHashMap
 * @tsplus location "@tsplus/stdlib/collections/HashMap/definition"
 */
export declare function isHashMap<K, V>(u: Iterable<readonly [K, V]>): u is HashMap<K, V>;
export declare function isHashMap(u: unknown): u is HashMap<unknown, unknown>;
//# sourceMappingURL=definition.d.ts.map