import { Refinement } from "@tsplus/stdlib/data/Function";
import { HashMap } from "@tsplus/stdlib/collections/HashMap/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Filters entries out of a `HashMap` using the specified predicate.
 * @tsplus static HashMap.Aspects filter
 * @tsplus pipeable HashMap filter
 * @tsplus location "@tsplus/stdlib/collections/HashMap/operations/filter"
 */
export declare function filter<A, B extends A>(f: Refinement<A, B>): <K>(self: HashMap<K, A>) => HashMap<K, B>;
export declare function filter<A>(f: Predicate<A>): <K>(self: HashMap<K, A>) => HashMap<K, A>;
//# sourceMappingURL=filter.d.ts.map