"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Node", {
  enumerable: true,
  get: function () {
    return _node.Node;
  }
});
exports.arrayNode = arrayNode;
exports.canEditNode = canEditNode;
exports.collisionNode = collisionNode;
exports.emptyNode = emptyNode;
exports.indexedNode = indexedNode;
exports.isLeafNode = exports.isEmptyNode = void 0;
exports.leafNode = leafNode;
exports.visitLazy = visitLazy;
exports.visitLazyChildren = void 0;

var _hashMap = /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/hashMap");

var _node = /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/node");

/**
 * @tsplus static HashMap.Node.Ops empty
 */
function emptyNode() {
  return new _node.EmptyNode();
}
/**
 * @tsplus static HashMap.Node.Ops leaf
 */


function leafNode(edit, hash, key, value) {
  return new _node.LeafNode(edit, hash, key, value);
}
/**
 * @tsplus static HashMap.Node.Ops collision
 */


function collisionNode(edit, hash, children) {
  return new _node.CollisionNode(edit, hash, children);
}
/**
 * @tsplus static HashMap.Node.Ops indexed
 */


function indexedNode(edit, mask, children) {
  return new _node.IndexedNode(edit, mask, children);
}
/**
 * @tsplus static HashMap.Node.Ops array
 */


function arrayNode(edit, size, children) {
  return new _node.ArrayNode(edit, size, children);
} // -----------------------------------------------------------------------------
// Type Guards
// -----------------------------------------------------------------------------

/**
 * @tsplus static HashMap.Node.Ops isEmptyNode
 */


const isEmptyNode = _node.isEmptyNode;
/**
 * @tsplus static HashMap.Node.Ops isLeafNode
 */

exports.isEmptyNode = isEmptyNode;
const isLeafNode = _node.isLeafNode; // -----------------------------------------------------------------------------
// Operations
// -----------------------------------------------------------------------------

/**
 * @tsplus pipeable HashMap.Node canEdit
 */

exports.isLeafNode = isLeafNode;

function canEditNode(edit) {
  return node => (0, _node.canEditNode)(node, edit);
}
/**
 * @tsplus pipeable HashMap.Node visitLazy
 */


function visitLazy(f, cont) {
  return node => (0, _hashMap.visitLazy)(node, f);
}
/**
 * @tsplus fluent HashMap.Node.Ops visitLazyChildren
 */


const visitLazyChildren = _hashMap.visitLazyChildren;
exports.visitLazyChildren = visitLazyChildren;
//# sourceMappingURL=node.js.map