"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceWithIndex = reduceWithIndex;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/node"));

var _hashMap = /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/hashMap");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Reduces the specified state over the entries of the `HashMap`.
 *
 * @tsplus static HashMap.Aspects reduceWithIndex
 * @tsplus pipeable HashMap reduceWithIndex
 */
function reduceWithIndex(z, f) {
  return self => {
    void 0;
    const root = self._root;

    if (root._tag === "LeafNode") {
      return tsplus_module_1.isSome(root.value) ? f(z, root.key, root.value.value) : z;
    }

    if (root._tag === "EmptyNode") {
      return z;
    }

    const toVisit = [root.children];
    let children;

    while (children = toVisit.pop()) {
      for (let i = 0, len = children.length; i < len;) {
        const child = children[i++];

        if (child && !tsplus_module_2.isEmptyNode(child)) {
          if (child._tag === "LeafNode") {
            if (tsplus_module_1.isSome(child.value)) {
              z = f(z, child.key, child.value.value);
            }
          } else toVisit.push(child.children);
        }
      }
    }

    return z;
  };
}
//# sourceMappingURL=reduceWithIndex.js.map