"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setTree = setTree;

var _hashMap = /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/hashMap");

/**
 * Sets the root of the `HashMap`.
 *
 * @tsplus static HashMap.Aspects setTree
 * @tsplus pipeable HashMap setTree
 */
function setTree(newRoot, newSize) {
  return self => {
    void 0;

    if (self._editable) {
      self._root = newRoot;
      self._size = newSize;
      return self;
    }

    return newRoot === self._root ? self : new _hashMap.HashMapInternal(self._editable, self._edit, newRoot, newSize);
  };
}
//# sourceMappingURL=setTree.js.map