"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UpdateHashMapPatch = exports.RemoveHashMapPatch = exports.HashMapPatchValueSym = exports.HashMapPatchSym = exports.HashMapPatchPatchSym = exports.HashMapPatchKeySym = exports.HashMapPatch = exports.EmptyHashMapPatch = exports.BaseHashMapPatch = exports.AndThenHashMapPatch = exports.AddHashMapPatch = void 0;
exports.hashMapPatchInstruction = hashMapPatchInstruction;
exports.unifyHashMapPatch = unifyHashMapPatch;

var _a;

const HashMapPatchSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch");
exports.HashMapPatchSym = HashMapPatchSym;
const HashMapPatchKeySym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Key");
exports.HashMapPatchKeySym = HashMapPatchKeySym;
const HashMapPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Value");
exports.HashMapPatchValueSym = HashMapPatchValueSym;
const HashMapPatchPatchSym = /*#__PURE__*/Symbol.for("@Differ.HashMap.Patch.Patch");
/**
 * @tsplus static Differ.Ops HashMap
 */

exports.HashMapPatchPatchSym = HashMapPatchPatchSym;
const HashMapPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.HashMap.Patch
 */

exports.HashMapPatch = HashMapPatch;

function unifyHashMapPatch(self) {
  return self;
}

class BaseHashMapPatch {
  constructor() {
    this[_a] = HashMapPatchSym;
  }

}

exports.BaseHashMapPatch = BaseHashMapPatch;
_a = HashMapPatchSym;

class AddHashMapPatch extends BaseHashMapPatch {
  constructor(key, value) {
    super();
    this.key = key;
    this.value = value;
    this._tag = "Add";
  }

}

exports.AddHashMapPatch = AddHashMapPatch;

class RemoveHashMapPatch extends BaseHashMapPatch {
  constructor(key) {
    super();
    this.key = key;
    this._tag = "Remove";
  }

}

exports.RemoveHashMapPatch = RemoveHashMapPatch;

class UpdateHashMapPatch extends BaseHashMapPatch {
  constructor(key, patch) {
    super();
    this.key = key;
    this.patch = patch;
    this._tag = "Update";
  }

}

exports.UpdateHashMapPatch = UpdateHashMapPatch;

class EmptyHashMapPatch extends BaseHashMapPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}

exports.EmptyHashMapPatch = EmptyHashMapPatch;

class AndThenHashMapPatch extends BaseHashMapPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}
/**
 * @tsplus macro identity
 */


exports.AndThenHashMapPatch = AndThenHashMapPatch;

function hashMapPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.js.map