import { HashMap } from "@tsplus/stdlib/collections/HashMap/definition";
import { Differ } from "@tsplus/stdlib/data/Differ/definition";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Applies a map patch to a map of keys and values to produce a new map of
 * keys and values values which represents the original map of keys and
 * values updated with the changes described by this patch.
 * @tsplus static Differ.HashMap.Patch.Aspects apply
 * @tsplus pipeable Differ.HashMap.Patch apply
 * @tsplus location "@tsplus/stdlib/collections/HashMap/patch/operations/apply"
 */
export declare function apply<Key, Value, Patch>(oldValue: HashMap<Key, Value>, differ: Differ<Value, Patch>): (self: Differ.HashMap.Patch<Key, Value, Patch>) => HashMap<Key, Value>;
//# sourceMappingURL=apply.d.ts.map