"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.diff = diff;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Differ/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/patch/operations/emptyPatch"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/get"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/remove"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/patch/operations/combine"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/reduceWithIndex"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/patch/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs a map patch from a new and old map of keys and values and a
 * differ for the values.
 *
 * @tsplus static Differ.HashMap.Patch.Ops diff
 */
function diff(oldValue, newValue, differ) {
  const [removed, patch] = tsplus_module_7.reduceWithIndex([oldValue, tsplus_module_2.emptyPatch()], ([map, patch], key, newValue) => {
    const maybe = tsplus_module_3.get(key)(map);

    switch (maybe._tag) {
      case "Some":
        {
          const valuePatch = differ.diff(maybe.value, newValue);

          if (tsplus_module_4.equals(valuePatch, differ.empty)) {
            return [tsplus_module_5.remove(key)(map), patch];
          }

          return [tsplus_module_5.remove(key)(map), tsplus_module_6.combine(new _definition2.UpdateHashMapPatch(key, valuePatch))(patch)];
        }

      case "None":
        {
          return [map, tsplus_module_6.combine(new _definition2.AddHashMapPatch(key, newValue))(patch)];
        }
    }
  })(newValue);
  return tsplus_module_7.reduceWithIndex(patch, (patch, key, _) => tsplus_module_6.combine(new _definition2.RemoveHashMapPatch(key))(patch))(removed);
}
//# sourceMappingURL=diff.js.map