import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Equals } from "@tsplus/stdlib/structure/Equals";
export declare const HashSetSym: unique symbol;
export type HashSetSym = typeof HashSetSym;
/**
 * @tsplus type HashSet
 */
export interface HashSet<A> extends Collection<A>, Equals {
    readonly [HashSetSym]: HashSetSym;
    [Symbol.iterator](): Iterator<A>;
}
/**
 * @tsplus type HashSet.Ops
 */
export interface HashSetOps {
    $: HashSetAspects;
}
export declare const HashSet: HashSetOps;
/**
 * @tsplus type HashSet.Aspects
 */
export interface HashSetAspects {
}
/**
 * @tsplus unify HashSet
 */
export declare function unifyHashSet<X extends HashSet<any>>(self: X): HashSet<[X] extends [HashSet<infer A>] ? A : never>;
/**
 * @tsplus static HashSet.Ops isHashSet
 * @tsplus location "@tsplus/stdlib/collections/HashSet/definition"
 */
export declare function isHashSet<A>(u: Iterable<A>): u is HashSet<A>;
export declare function isHashSet(u: unknown): u is HashSet<unknown>;
//# sourceMappingURL=definition.d.ts.map