"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.equals = equals;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/operations/size"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashMap/_internal/hashMap"));

var _hashSet = /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/_internal/hashSet");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Determines if two `HashSet`s are equivalent.
 *
 * @tsplus pipeable-operator HashSet ==
 * @tsplus static HashSet.Aspects equals
 * @tsplus pipeable HashSet equals
 */
function equals(that) {
  return self => {
    if (self === that) {
      return true;
    }

    void 0;
    void 0;

    if (tsplus_module_1.size(self._keyMap) !== tsplus_module_1.size(that._keyMap)) {
      return false;
    }

    let eq = true;

    for (const vx of self) {
      if (!tsplus_module_2.has_(that._keyMap, vx)) {
        eq = false;
        break;
      }
    }

    return eq;
  };
}
//# sourceMappingURL=equals.js.map