import { HashSet } from "@tsplus/stdlib/collections/HashSet/definition";
/**
 * Returns a `HashSet` of values which are present in both this set and that
 * `Iterable<A>`.
 *
 * **NOTE**: the hash and equal of the values in both the set and the iterable
 * must be the same.
 * @tsplus static HashSet.Aspects intersection
 * @tsplus pipeable HashSet intersection
 * @tsplus location "@tsplus/stdlib/collections/HashSet/operations/intersection"
 */
export declare function intersection<A>(that: Iterable<A>): (self: HashSet<A>) => HashSet<A>;
//# sourceMappingURL=intersection.d.ts.map