import { Refinement } from "@tsplus/stdlib/data/Function";
import { HashSet } from "@tsplus/stdlib/collections/HashSet/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Partition the values of a `HashSet` using the specified predicate.
 *
 * If a value matches the predicate, it will be placed into the `HashSet` on the
 * right side of the resulting `Tuple`, otherwise the value will be placed into
 * the left side.
 * @tsplus static HashSet.Aspects partition
 * @tsplus pipeable HashSet partition
 * @tsplus location "@tsplus/stdlib/collections/HashSet/operations/partition"
 */
export declare function partition<A, B extends A>(f: Refinement<A, B>): (self: HashSet<A>) => readonly [HashSet<A>, HashSet<B>];
export declare function partition<A>(f: Predicate<A>): (self: HashSet<A>) => readonly [HashSet<A>, HashSet<A>];
//# sourceMappingURL=partition.d.ts.map