import { HashSet } from "@tsplus/stdlib/collections/HashSet/definition";
/**
 * Computes the set union `(`self` + `that`)` between this `HashSet` and the
 * specified `Iterable<A>`.
 *
 * **NOTE**: the hash and equal of the values in both the set and the iterable
 * must be the same.
 * @tsplus static HashSet.Aspects union
 * @tsplus pipeable HashSet union
 * @tsplus location "@tsplus/stdlib/collections/HashSet/operations/union"
 */
export declare function union<A>(that: Iterable<A>): (self: HashSet<A>) => HashSet<A>;
//# sourceMappingURL=union.d.ts.map