"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemoveHashSetPatch = exports.HashSetPatchValueSym = exports.HashSetPatchSym = exports.HashSetPatch = exports.EmptyHashSetPatch = exports.BaseHashSetPatch = exports.AndThenHashSetPatch = exports.AddHashSetPatch = void 0;
exports.hashSetPatchInstruction = hashSetPatchInstruction;
exports.unifyHashSetPatch = unifyHashSetPatch;

var _a;

const HashSetPatchSym = /*#__PURE__*/Symbol.for("@Differ.HashSet.Patch");
exports.HashSetPatchSym = HashSetPatchSym;
const HashSetPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.HashSet.Patch.Value");
/**
 * @tsplus static Differ.Ops HashSet
 */

exports.HashSetPatchValueSym = HashSetPatchValueSym;
const HashSetPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.HashSet.Patch
 */

exports.HashSetPatch = HashSetPatch;

function unifyHashSetPatch(self) {
  return self;
}

class BaseHashSetPatch {
  constructor() {
    this[_a] = HashSetPatchSym;
  }

}

exports.BaseHashSetPatch = BaseHashSetPatch;
_a = HashSetPatchSym;

class AddHashSetPatch extends BaseHashSetPatch {
  constructor(value) {
    super();
    this.value = value;
    this._tag = "Add";
  }

}

exports.AddHashSetPatch = AddHashSetPatch;

class AndThenHashSetPatch extends BaseHashSetPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}

exports.AndThenHashSetPatch = AndThenHashSetPatch;

class EmptyHashSetPatch extends BaseHashSetPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}

exports.EmptyHashSetPatch = EmptyHashSetPatch;

class RemoveHashSetPatch extends BaseHashSetPatch {
  constructor(value) {
    super();
    this.value = value;
    this._tag = "Remove";
  }

}
/**
 * @tsplus macro identity
 */


exports.RemoveHashSetPatch = RemoveHashSetPatch;

function hashSetPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.js.map