import { HashSet } from "@tsplus/stdlib/collections/HashSet/definition";
import { Differ } from "@tsplus/stdlib/data/Differ/definition";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Applies a set patch to a set of values to produce a new set of values
 * which represents the original set of values updated with the changes
 * described by this patch.
 * @tsplus static Differ.HashSet.Patch.Aspects apply
 * @tsplus pipeable Differ.HashSet.Patch apply
 * @tsplus location "@tsplus/stdlib/collections/HashSet/patch/operations/apply"
 */
export declare function apply<Value>(oldValue: HashSet<Value>): (self: Differ.HashSet.Patch<Value>) => HashSet<Value>;
//# sourceMappingURL=apply.d.ts.map