"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.diff = diff;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Differ/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/patch/operations/emptyPatch"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/has"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/remove"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/patch/operations/combine"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/operations/reduce"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/collections/HashSet/patch/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs a set patch from a new set of values.
 *
 * @tsplus static Differ.HashSet.Patch.Ops diff
 */
function diff(oldValue, newValue) {
  const [removed, patch] = tsplus_module_6.reduce([oldValue, tsplus_module_2.emptyPatch()], ([set, patch], value) => {
    if (tsplus_module_3.has(value)(set)) {
      return [tsplus_module_4.remove(value)(set), patch];
    }

    return [set, tsplus_module_5.combine(new _definition2.AddHashSetPatch(value))(patch)];
  })(newValue);
  return tsplus_module_6.reduce(patch, (patch, value) => tsplus_module_5.combine(new _definition2.RemoveHashSetPatch(value))(patch))(removed);
}
//# sourceMappingURL=diff.js.map