import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { HKT } from "@tsplus/stdlib/prelude/HKT";
/**
 * @tsplus type ImmutableArray
 * @tsplus companion ImmutableArray.Ops
 */
export declare class ImmutableArray<A> implements Equals, Collection<A> {
    readonly array: ReadonlyArray<A>;
    constructor(array: ReadonlyArray<A>);
    [Symbol.iterator](): Iterator<A>;
    [Equals.sym](this: this, other: unknown): boolean;
    [Hash.sym](this: this): number;
}
export interface ImmutableArrayF extends HKT {
    readonly type: ImmutableArray<this["A"]>;
}
export declare namespace ImmutableArray {
    type HKT = ImmutableArrayF;
}
/**
 * @tsplus type ImmutableArray.Aspects
 */
export interface ImmutableArrayAspects {
}
/**
 * @tsplus static ImmutableArray.Ops $
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/definition"
 */
export declare const ImmutableArrayAspects: ImmutableArrayAspects;
//# sourceMappingURL=definition.d.ts.map