import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Creates an `ImmutableArray<A>` of values not included in that
 * `ImmutableArray<A>` using an `Equivalence<A>` for equality comparisons. The
 * order and references of result values are determined by the first array.
 * @tsplus static ImmutableArray.Aspects difference
 * @tsplus pipeable ImmutableArray difference
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/difference"
 */
export declare function difference<A>(E: Equivalence<A>, that: ImmutableArray<A>): (self: ImmutableArray<A>) => ImmutableArray<A>;
//# sourceMappingURL=difference.d.ts.map