import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Derives an `Equivalence` over the `ImmutableArray` of a given element type
 * from the `Equivalence` of that type. The derived `Equivalence` defines two
 * arrays as equal if all elements of both arrays are compared equal pairwise
 * with the given `Equivalence`. In case of arrays of different lengths, the
 * result is non equality.
 * @tsplus static ImmutableArray.Ops getEquivalence
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/getEquivalence"
 */
export declare function getEquivalnce<A>(E: Equivalence<A>): Equivalence<ImmutableArray<A>>;
//# sourceMappingURL=getEquivalence.d.ts.map