"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEquivalnce = getEquivalnce;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Equivalence/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Derives an `Equivalence` over the `ImmutableArray` of a given element type
 * from the `Equivalence` of that type. The derived `Equivalence` defines two
 * arrays as equal if all elements of both arrays are compared equal pairwise
 * with the given `Equivalence`. In case of arrays of different lengths, the
 * result is non equality.
 *
 * @tsplus static ImmutableArray.Ops getEquivalence
 */
function getEquivalnce(E) {
  return tsplus_module_1.Equivalence((xs, ys) => xs === ys || xs.array.length === ys.array.length && xs.array.every((x, i) => E.equals(x, ys.array[i])));
}
//# sourceMappingURL=getEquivalence.js.map