"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getOrd = getOrd;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Ord/common"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Ord/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns a `Ord` for an `ImmutableArray<A>` given an `Ord<A>`.
 *
 * @tsplus static ImmutableArray.Ops getOrd
 */
function getOrd(O) {
  return tsplus_module_2.Ord((a, b) => {
    const aLen = a.array.length;
    const bLen = b.array.length;
    const len = Math.min(aLen, bLen);

    for (let i = 0; i < len; i = i + 1) {
      const ordering = O.compare(a.array[i], b.array[i]);

      if (ordering !== 0) {
        return ordering;
      }
    }

    return tsplus_module_1.number.compare(aLen, bLen);
  });
}
//# sourceMappingURL=getOrd.js.map