"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.depthFirstChainRec = exports.breadthFirstChainRec = exports.DepthFirstChainRec = exports.BreadthFirstChainRec = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableArray/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/HKT"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const depthFirstChainRec = depthFirstChainRec_1;
exports.depthFirstChainRec = depthFirstChainRec;
const breadthFirstChainRec = breadthFirstChainRec_1;
/**
 * @tsplus static ImmutableArray.Ops depthFirstChainRec
 */

exports.breadthFirstChainRec = breadthFirstChainRec;

function depthFirstChainRec_1(a, f) {
  const todo = [...f(a)];
  const result = [];

  while (todo.length > 0) {
    const e = todo.shift();

    if (e._tag === "Left") {
      todo.unshift(...f(e.left));
    } else {
      result.push(e.right);
    }
  }

  return new tsplus_module_1.ImmutableArray(result);
}
/**
 * @tsplus static ImmutableArray.Ops DepthFirstChainRec
 */


const DepthFirstChainRec = {
  chainRec: f => a => depthFirstChainRec_1(a, f)
};
/**
 * @tsplus static ImmutableArray.Ops breadthFirstChainRec
 */

exports.DepthFirstChainRec = DepthFirstChainRec;

function breadthFirstChainRec_1(a, f) {
  const initial = f(a);
  const todo = [];
  const result = [];

  for (const e of initial) {
    if (e._tag === "Left") {
      f(e.left).array.forEach(v => todo.push(v));
    } else {
      result.push(e.right);
    }
  }

  while (todo.length > 0) {
    const e = todo.shift();

    if (e._tag === "Left") {
      f(e.left).array.forEach(v => todo.push(v));
    } else {
      result.push(e.right);
    }
  }

  return new tsplus_module_1.ImmutableArray(result);
}
/**
 * @tsplus static ImmutableArray.Ops BreadthFirstChainRec
 */


const BreadthFirstChainRec = {
  chainRec: f => a => breadthFirstChainRec_1(a, f)
};
exports.BreadthFirstChainRec = BreadthFirstChainRec;
//# sourceMappingURL=ChainRec.js.map