import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Creates an `ImmutableArray<A>` of unique values that are included in the
 * given arrays using the specified `Equivalence` for equality comparisons.
 * The order and references of result values are determined by the first array.
 * @tsplus static ImmutableArray.Aspects intersection
 * @tsplus pipeable ImmutableArray intersection
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/intersection"
 */
export declare function intersection<A>(E: Equivalence<A>, that: ImmutableArray<A>): (self: ImmutableArray<A>) => ImmutableArray<A>;
//# sourceMappingURL=intersection.d.ts.map