"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.partitionMapWithIndex = partitionMapWithIndex;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableArray/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Separate elements based on a map function that also exposes the index.
 *
 * @tsplus static ImmutableArray.Aspects partitionMapWithIndex
 * @tsplus pipeable ImmutableArray partitionMapWithIndex
 */
function partitionMapWithIndex(f) {
  return self => {
    const left = [];
    const right = [];

    for (let i = 0; i < self.array.length; i = i + 1) {
      const e = f(i, self.array[i]);

      if (e._tag === "Left") {
        left.push(e.left);
      } else {
        right.push(e.right);
      }
    }

    return [new tsplus_module_1.ImmutableArray(left), new tsplus_module_1.ImmutableArray(right)];
  };
}
//# sourceMappingURL=partitionMapWithIndex.js.map