import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import type { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray";
/**
 * Sort the elements of an `ImmutableArray<A>` in increasing order, where
 * elements are compared using first `ords[0]`, then `ords[1]`, then `ords[2]`,
 * etc.
 * @tsplus static ImmutableArray.Aspects sortBy
 * @tsplus pipeable ImmutableArray sortBy
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/sortBy"
 */
export declare function sortBy<A>(...ords: Array<Ord<A>>): (self: ImmutableArray<A>) => ImmutableArray<A>;
//# sourceMappingURL=sortBy.d.ts.map