import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Creates an `ImmutableArray<A>` of unique values, in order, from the given
 * arrays using the specified `Equivalence<A>` for equality comparisons.
 * @tsplus static ImmutableArray.Aspects union
 * @tsplus pipeable ImmutableArray union
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/union"
 */
export declare function union<A>(E: Equivalence<A>, that: ImmutableArray<A>): (self: ImmutableArray<A>) => ImmutableArray<A>;
//# sourceMappingURL=union.d.ts.map