"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uniq = uniq;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableArray/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Remove duplicates from an array, keeping the first occurrence of an element.
 *
 * @tsplus static ImmutableArray.Aspects uniq
 * @tsplus pipeable ImmutableArray uniq
 */
function uniq(E) {
  return self => {
    const includes = arrayIncludes(E);
    const result = [];
    const length = self.array.length;
    let i = 0;

    for (; i < length; i = i + 1) {
      const a = self.array[i];

      if (!includes(result, a)) {
        result.push(a);
      }
    }

    return length === result.length ? self : new tsplus_module_1.ImmutableArray(result);
  };
}

function arrayIncludes(E) {
  return (array, value) => {
    for (let i = 0; i < array.length; i = i + 1) {
      const element = array[i];

      if (E.equals(value, element)) {
        return true;
      }
    }

    return false;
  };
}
//# sourceMappingURL=uniq.js.map