import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
/**
 * Apply a function to pairs of elements at the same index in two arrays,
 * collecting the results in a new array. If one input array is short, excess
 * elements of the longer array are discarded.
 * @tsplus static ImmutableArray.Aspects zipWith
 * @tsplus pipeable ImmutableArray zipWith
 * @tsplus location "@tsplus/stdlib/collections/ImmutableArray/zipWith"
 */
export declare function zipWith<A, B, C>(that: ImmutableArray<B>, f: (a: A, b: B) => C): (self: ImmutableArray<A>) => ImmutableArray<C>;
//# sourceMappingURL=zipWith.d.ts.map