import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Hash } from "@tsplus/stdlib/structure/Hash";
/**
 * @tsplus type ImmutableMap
 * @tsplus companion ImmutableMap.Ops
 */
export declare class ImmutableMap<K, V> implements Equals, Collection<readonly [K, V]> {
    readonly internalMap: ReadonlyMap<K, V>;
    constructor(internalMap: ReadonlyMap<K, V>);
    [Symbol.iterator](): Iterator<readonly [K, V]>;
    [Equals.sym](this: this, other: unknown): boolean;
    [Hash.sym](): number;
}
/**
 * @tsplus static ImmutableMap.Ops $
 * @tsplus location "@tsplus/stdlib/collections/ImmutableMap/definition"
 */
export declare const ImmutableMapAspects: ImmutableMapAspects;
/**
 * @tsplus type ImmutableMap.Aspects
 */
export interface ImmutableMapAspects {
}
//# sourceMappingURL=definition.d.ts.map