"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImmutableMapAspects = exports.ImmutableMap = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus type ImmutableMap
 * @tsplus companion ImmutableMap.Ops
 */
class ImmutableMap {
  constructor(internalMap) {
    this.internalMap = internalMap;
  }

  [Symbol.iterator]() {
    const iterator = this.internalMap[Symbol.iterator]();
    return {
      next: () => {
        const next = iterator.next();

        if (next.done) {
          return {
            done: true,
            value: undefined
          };
        }

        return {
          done: false,
          value: [next.value[0], next.value[1]]
        };
      }
    };
  }

  [tsplus_module_1.Equals.sym](other) {
    if (other instanceof ImmutableMap && this.internalMap.size === other.internalMap.size) {
      for (const [otherKey, otherValue] of other.internalMap) {
        if (this.internalMap.has(otherKey)) {
          const value = this.internalMap.get(otherKey);

          if (!tsplus_module_1.equals(value, otherValue)) {
            return false;
          }
        } else {
          return false;
        }
      }

      return true;
    }

    return false;
  }

  [tsplus_module_2.Hash.sym]() {
    let hash = tsplus_module_2.hashString("ImmutableMap");

    for (const item of this) {
      hash ^= tsplus_module_2.combine(tsplus_module_2.hashUnknown(item[0]), tsplus_module_2.hashUnknown(item[1]));
    }

    return tsplus_module_2.optimize(hash);
  }

}
/**
 * @tsplus static ImmutableMap.Ops $
 */


exports.ImmutableMap = ImmutableMap;
const ImmutableMapAspects = {};
exports.ImmutableMapAspects = ImmutableMapAspects;
//# sourceMappingURL=definition.js.map