import { Refinement } from "@tsplus/stdlib/data/Function";
import { ImmutableMap } from "@tsplus/stdlib/collections/ImmutableMap/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Applies the specified predicate to each entry of the map, filitering out any
 * values that do not satisfy the predicate.
 * @tsplus static ImmutableMap.Aspects filter
 * @tsplus pipeable ImmutableMap filter
 * @tsplus location "@tsplus/stdlib/collections/ImmutableMap/filter"
 */
export declare function filter<V, B extends V>(f: Refinement<V, B>): <K>(self: ImmutableMap<K, V>) => ImmutableMap<V, B>;
export declare function filter<V>(f: Predicate<V>): <K>(self: ImmutableMap<K, V>) => ImmutableMap<K, V>;
//# sourceMappingURL=filter.d.ts.map