import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { ImmutableMap } from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Applies the specified partial function to each entry of the map, filtering
 * out `None` values.
 * @tsplus static ImmutableMap.Aspects filterMapWithIndex
 * @tsplus pipeable ImmutableMap filterMapWithIndex
 * @tsplus location "@tsplus/stdlib/collections/ImmutableMap/filterMapWithIndex"
 */
export declare function filterMapWithIndex<K, V, B>(pf: (key: K, value: V) => Maybe<B>): (self: ImmutableMap<K, V>) => ImmutableMap<K, B>;
//# sourceMappingURL=filterMapWithIndex.d.ts.map