"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterMapWithIndex = filterMapWithIndex;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableMap/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Applies the specified partial function to each entry of the map, filtering
 * out `None` values.
 *
 * @tsplus static ImmutableMap.Aspects filterMapWithIndex
 * @tsplus pipeable ImmutableMap filterMapWithIndex
 */
function filterMapWithIndex(pf) {
  return self => {
    const map = new Map();

    for (const [key, value] of self.internalMap) {
      const result = pf(key, value);

      if (tsplus_module_1.isSome(result)) {
        map.set(key, result.value);
      }
    }

    return new tsplus_module_2.ImmutableMap(map);
  };
}
//# sourceMappingURL=filterMapWithIndex.js.map