import { ImmutableMap } from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Applies the specified predicate to each entry of the map, filitering out any
 * values that do not satisfy the predicate.
 * @tsplus static ImmutableMap.Aspects filterWithIndex
 * @tsplus pipeable ImmutableMap filterWithIndex
 * @tsplus location "@tsplus/stdlib/collections/ImmutableMap/filterWithIndex"
 */
export declare function filterWithIndex<K, V, B extends V>(f: (key: K, value: V) => value is B): (self: ImmutableMap<K, V>) => ImmutableMap<V, B>;
export declare function filterWithIndex<K, V>(f: (key: K, value: V) => boolean): (self: ImmutableMap<K, V>) => ImmutableMap<K, V>;
//# sourceMappingURL=filterWithIndex.d.ts.map