"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceWithIndex = reduceWithIndex;

/**
 * Reduces the specified state over the entries of the `ImmutableMap`.
 *
 * @tsplus static ImmutableMap.Aspects reduceWithIndex
 * @tsplus pipeable ImmutableMap reduceWithIndex
 */
function reduceWithIndex(z, f) {
  return self => {
    let s = z;
    self.internalMap.forEach((v, k) => {
      s = f(s, k, v);
    });
    return s;
  };
}
//# sourceMappingURL=reduceWithIndex.js.map