import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { ImmutableMap } from "@tsplus/stdlib/collections/ImmutableMap/definition";
/**
 * Update a mapping for the specified key and its current optionally-mapped
 * value (`Some` if there is current mapping, `None` if not).
 *
 * - If the key/value pair already exists within the map, the key/value pair is
 *   removed.
 * - If the remapping function returns `Some(v)`, the mapping is updated with
 *   the new value `v`.
 * - If the remapping function returns `None`, the mapping is removed (or
 *   remains absent if initially absent).
 * @tsplus static ImmutableMap.Aspects update
 * @tsplus pipeable ImmutableMap update
 * @tsplus location "@tsplus/stdlib/collections/ImmutableMap/update"
 */
export declare function update<K, V>(key: K, f: (value: Maybe<V>) => Maybe<V>): (self: ImmutableMap<K, V>) => ImmutableMap<K, V>;
//# sourceMappingURL=update.d.ts.map