"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = update;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/fromNullable"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableMap/remove"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableMap/set"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Update a mapping for the specified key and its current optionally-mapped
 * value (`Some` if there is current mapping, `None` if not).
 *
 * - If the key/value pair already exists within the map, the key/value pair is
 *   removed.
 * - If the remapping function returns `Some(v)`, the mapping is updated with
 *   the new value `v`.
 * - If the remapping function returns `None`, the mapping is removed (or
 *   remains absent if initially absent).
 *
 * @tsplus static ImmutableMap.Aspects update
 * @tsplus pipeable ImmutableMap update
 */
function update(key, f) {
  return self => {
    const previousValue = tsplus_module_1.fromNullable(self.internalMap.get(key));
    const nextValue = f(previousValue);

    if (tsplus_module_2.isSome(previousValue)) {
      return tsplus_module_3.remove(key)(self);
    }

    if (tsplus_module_2.isSome(nextValue)) {
      return tsplus_module_4.set(key, nextValue.value)(self);
    }

    return self;
  };
}
//# sourceMappingURL=update.js.map