"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._Nil = exports._A = exports.Nil = exports.ListTypeId = exports.List = exports.Cons = void 0;
exports.cons = cons;
exports.equals = equals;
exports.equalsWith = void 0;
exports.isCons = isCons;
exports.isList = isList;
exports.length = exports.isNil = void 0;
exports.nil = nil;
exports.unify = unify;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a, _b;

const isNil = isNil_1;
exports.isNil = isNil;
const length = length_1;
exports.length = length;
const equalsWith = equalsWith_1;
/*
 * This file is ported from
 *
 * Scala (https://www.scala-lang.org)
 *
 * Copyright EPFL and Lightbend, Inc.
 *
 * Licensed under Apache License 2.0
 * (http://www.apache.org/licenses/LICENSE-2.0).
 */

exports.equalsWith = equalsWith;
const ListTypeId = /*#__PURE__*/Symbol.for("@tsplus/collections/List");
exports.ListTypeId = ListTypeId;

const _A = /*#__PURE__*/Symbol.for("@tsplus/collections/List/_A");

exports._A = _A;
const List = {
  $: {}
};
/**
 * @tsplus type List/Cons
 */

exports.List = List;

class Cons {
  constructor(head, tail) {
    this.head = head;
    this.tail = tail;
    this._tag = "Cons";
    this[_a] = ListTypeId;
  }

  [(_a = ListTypeId, Symbol.iterator)]() {
    let done = false; // eslint-disable-next-line @typescript-eslint/no-this-alias

    let these = this;
    return {
      next() {
        if (done) {
          return this.return();
        }

        if (these._tag === "Nil") {
          done = true;
          return this.return();
        }

        const value = these.head;
        these = these.tail;
        return {
          done,
          value
        };
      },

      return(value) {
        if (!done) {
          done = true;
        }

        return {
          done: true,
          value
        };
      }

    };
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.hashIterator(this[Symbol.iterator]());
  }

  [tsplus_module_2.Equals.sym](that) {
    return that instanceof Cons && equalsWith_1(that, tsplus_module_2.equals)(this);
  }

}
/**
 * @tsplus type List/Nil
 */


exports.Cons = Cons;

class Nil {
  constructor() {
    this._tag = "Nil";
    this[_b] = ListTypeId;
  }

  [(_b = ListTypeId, Symbol.iterator)]() {
    return {
      next() {
        return {
          done: true,
          value: undefined
        };
      }

    };
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.hashIterator(this[Symbol.iterator]());
  }

  [tsplus_module_2.Equals.sym](that) {
    return that instanceof Nil;
  }

}

exports.Nil = Nil;

const _Nil = /*#__PURE__*/new Nil();
/**
 * @tsplus unify List
 * @tsplus unify List/Nil
 * @tsplus unify List/Cons
 */


exports._Nil = _Nil;

function unify(self) {
  return self;
}
/**
 * @tsplus static List.Ops nil
 */


function nil() {
  return _Nil;
}
/**
 * @tsplus static List.Ops cons
 */


function cons(head, tail) {
  return new Cons(head, tail);
}
/**
 * @tsplus fluent List isNil
 */


function isNil_1(self) {
  return self._tag === "Nil";
}
/**
 * @tsplus fluent List isCons
 */


function isCons(self) {
  return self._tag === "Cons";
}
/**
 * Returns the number of elements contained in a `List`
 *
 * @tsplus getter List length
 */


function length_1(self) {
  let these = self;
  let len = 0;

  while (!isNil_1(these)) {
    len += 1;
    these = these.tail;
  }

  return len;
}
/**
 * @tsplus static List.Aspects equalsWith
 * @tsplus pipeable List equalsWith
 */


function equalsWith_1(that, f) {
  return self => {
    if (self === that) {
      return true;
    } else if (length_1(self) !== length_1(that)) {
      return false;
    } else {
      const i0 = self[Symbol.iterator]();
      const i1 = that[Symbol.iterator]();
      let a;
      let b;

      while (!(a = i0.next()).done && !(b = i1.next()).done) {
        if (!f(a.value, b.value)) {
          return false;
        }
      }

      return true;
    }
  };
}

function equals(that) {
  return self => equalsWith_1(that, tsplus_module_2.equals)(self);
}

function isList(u) {
  return typeof u === "object" && u != null && ListTypeId in u;
}
//# sourceMappingURL=definition.js.map