"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.drop = drop;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Drops the first `n` elements.
 *
 * @tsplus static List.Aspects drop
 * @tsplus pipeable List drop
 */
function drop(n) {
  return self => {
    if (n <= 0) {
      return self;
    }

    if (n >= tsplus_module_1.length(self)) {
      return tsplus_module_1.nil();
    }

    let these = self;
    let i = 0;

    while (!tsplus_module_1.isNil(these) && i < n) {
      these = these.tail;
      i += 1;
    }

    return these;
  };
}
//# sourceMappingURL=drop.js.map