"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filter = filter;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/unsafeHead"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/unsafeTail"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function filter(p) {
  return self => filterCommon_(self, p, false);
}

function noneIn(l, p, isFlipped) {
  /* eslint-disable no-constant-condition */
  while (true) {
    if (tsplus_module_1.isNil(l)) {
      return tsplus_module_1.nil();
    } else {
      if (p(l.head) !== isFlipped) {
        return allIn(l, l.tail, p, isFlipped);
      } else {
        l = l.tail;
      }
    }
  }
}

function allIn(start, remaining, p, isFlipped) {
  /* eslint-disable no-constant-condition */
  while (true) {
    if (tsplus_module_1.isNil(remaining)) {
      return start;
    } else {
      if (p(remaining.head) !== isFlipped) {
        remaining = remaining.tail;
      } else {
        return partialFill(start, remaining, p, isFlipped);
      }
    }
  }
}

function partialFill(origStart, firstMiss, p, isFlipped) {
  const newHead = tsplus_module_1.cons(tsplus_module_2.unsafeHead(origStart), tsplus_module_1.nil());
  let toProcess = tsplus_module_3.unsafeTail(origStart);
  let currentLast = newHead;

  while (!(toProcess === firstMiss)) {
    const newElem = tsplus_module_1.cons(tsplus_module_2.unsafeHead(toProcess), tsplus_module_1.nil());
    currentLast.tail = newElem;
    currentLast = newElem;
    toProcess = toProcess.tail;
  }

  let next = firstMiss.tail;
  let nextToCopy = next;

  while (!tsplus_module_1.isNil(next)) {
    const head = tsplus_module_2.unsafeHead(next);

    if (p(head) !== isFlipped) {
      next = next.tail;
    } else {
      while (!(nextToCopy === next)) {
        const newElem = tsplus_module_1.cons(tsplus_module_2.unsafeHead(nextToCopy), tsplus_module_1.nil());
        currentLast.tail = newElem;
        currentLast = newElem;
        nextToCopy = nextToCopy.tail;
      }

      nextToCopy = next.tail;
      next = next.tail;
    }
  }

  if (!tsplus_module_1.isNil(nextToCopy)) {
    currentLast.tail = nextToCopy;
  }

  return newHead;
}

function filterCommon_(list, p, isFlipped) {
  return noneIn(list, p, isFlipped);
}
//# sourceMappingURL=filter.js.map