"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flatMap = flatMap;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static List.Aspects flatMap
 * @tsplus pipeable List flatMap
 */
function flatMap(f) {
  return self => {
    let rest = self;
    let h = undefined;
    let t = undefined;

    while (!tsplus_module_1.isNil(rest)) {
      let bs = f(rest.head);

      while (!tsplus_module_1.isNil(bs)) {
        const nx = tsplus_module_1.cons(bs.head, tsplus_module_1.nil());

        if (t === undefined) {
          h = nx;
        } else {
          t.tail = nx;
        }

        t = nx;
        bs = bs.tail;
      }

      rest = rest.tail;
    }

    if (h === undefined) return tsplus_module_1.nil();else return h;
  };
}
//# sourceMappingURL=flatMap.js.map