"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.from = void 0;
exports.make = make;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const from = from_1;
/**
 * Constructs a new `List` from an `Iterable`
 *
 * @tsplus static List.Ops from
 * @tsplus getter Collection toList
 */

exports.from = from;

function from_1(prefix) {
  const iter = prefix[Symbol.iterator]();
  let a;

  if (!(a = iter.next()).done) {
    const result = tsplus_module_1.cons(a.value, tsplus_module_1.nil());
    let curr = result;

    while (!(a = iter.next()).done) {
      const temp = tsplus_module_1.cons(a.value, tsplus_module_1.nil());
      curr.tail = temp;
      curr = temp;
    }

    return result;
  } else {
    return tsplus_module_1.nil();
  }
}
/**
 * Constructs a new `List` from an `Iterable`
 *
 * @tsplus static List.Ops __call
 * @tsplus static List.Ops make
 */


function make(...prefix) {
  return from_1(prefix);
}
//# sourceMappingURL=from.js.map