"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.map = map;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static List.Aspects map
 * @tsplus pipeable List map
 */
function map(f) {
  return self => {
    if (tsplus_module_1.isNil(self)) {
      return self;
    } else {
      const h = tsplus_module_1.cons(f(self.head), tsplus_module_1.nil());
      let t = h;
      let rest = self.tail;

      while (!tsplus_module_1.isNil(rest)) {
        const nx = tsplus_module_1.cons(f(rest.head), tsplus_module_1.nil());
        t.tail = nx;
        t = nx;
        rest = rest.tail;
      }

      return h;
    }
  };
}
//# sourceMappingURL=map.js.map