"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.partitionMap = partitionMap;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/from"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Partitions the elements of this List into two Lists using the specified
 * function.
 *
 * @tsplus static List.Aspects partitionMap
 * @tsplus pipeable List partitionMap
 */
function partitionMap(f) {
  return self => {
    const left = [];
    const right = [];

    for (const a of self) {
      const e = f(a);

      if (e._tag === "Left") {
        left.push(e.left);
      } else {
        right.push(e.right);
      }
    }

    return [tsplus_module_1.from(left), tsplus_module_1.from(right)];
  };
}
//# sourceMappingURL=partitionMap.js.map