import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Inserts an element at the beginning of a `List`, returning a new `List`
 * @tsplus static List.Aspects prepend
 * @tsplus pipeable List prepend
 * @tsplus location "@tsplus/stdlib/collections/List/prepend"
 */
export declare function prepend<A, B>(elem: B): (self: List<A>) => List.NonEmpty<A | B>;
/**
 * Inserts an element at the beginning of a `List`, returning a new `List`
 * @tsplus operator List +
 * @tsplus location "@tsplus/stdlib/collections/List/prepend"
 */
export declare function prependOperatorStrict<A>(elem: A, list: List<A>): List.NonEmpty<A>;
/**
 * Inserts an element at the beginning of a `List`, returning a new `List`
 * @tsplus operator List >
 * @tsplus location "@tsplus/stdlib/collections/List/prepend"
 */
export declare function prependOperator<A, B>(elem: A, list: List<B>): List<A | B>;
//# sourceMappingURL=prepend.d.ts.map