"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prependAll = prependAll;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static List.Aspects prependAll
 * @tsplus pipeable List prependAll
 */
function prependAll(prefix) {
  return self => {
    if (tsplus_module_1.isNil(self)) {
      return prefix;
    } else if (tsplus_module_1.isNil(prefix)) {
      return self;
    } else {
      const result = tsplus_module_1.cons(prefix.head, self);
      let curr = result;
      let that = prefix.tail;

      while (!tsplus_module_1.isNil(that)) {
        const temp = tsplus_module_1.cons(that.head, self);
        curr.tail = temp;
        curr = temp;
        that = that.tail;
      }

      return result;
    }
  };
}
//# sourceMappingURL=prependAll.js.map