"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sortWith = sortWith;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/ListBuffer"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/unsafeHead"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus static List.Aspects sortWith
 * @tsplus pipeable List sortWith
 */
function sortWith(ord) {
  return self => {
    const len = tsplus_module_1.length(self);
    const b = new tsplus_module_2.ListBuffer();

    if (len === 1) {
      b.append(tsplus_module_3.unsafeHead(self));
    } else if (len > 1) {
      const arr = new Array(len);
      copyToArrayWithIndex(self, arr);
      arr.sort(([i, x], [j, y]) => {
        const c = ord.compare(x, y);
        return c !== 0 ? c : i < j ? -1 : 1;
      });

      for (let i = 0; i < len; i++) {
        b.append(arr[i][1]);
      }
    }

    return b.toList;
  };
}

function copyToArrayWithIndex(list, arr) {
  let these = list;
  let i = 0;

  while (!tsplus_module_1.isNil(these)) {
    arr[i] = [i, these.head];
    these = these.tail;
    i++;
  }
}
//# sourceMappingURL=sortWith.js.map