"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fold = fold;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/from"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/empty"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/unsafeHead"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/definition"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/prepend"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/unsafeTail"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/List/reduce"));

var tsplus_module_8 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Folds over the events in this collection of events using the specified
 * functions.
 *
 * @tsplus static ParSeq.Aspects fold
 * @tsplus pipeable ParSeq fold
 */
function fold(emptyCase, singleCase, thenCase, bothCase) {
  return self => tsplus_module_3.unsafeHead(foldLoop(emptyCase, singleCase, thenCase, bothCase, tsplus_module_1.make(self), tsplus_module_2.empty()));
}

function foldLoop(emptyCase, singleCase, thenCase, bothCase, inp, out) {
  // eslint-disable-next-line no-constant-condition
  while (1) {
    if (tsplus_module_4.isNil(inp)) {
      return tsplus_module_7.reduce(tsplus_module_2.empty(), (acc, val) => {
        if (val._tag === "Right") {
          return tsplus_module_5.prepend(val.right)(acc);
        } else {
          if (val.left) {
            let parSeqs = acc;
            const left = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            const right = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            return tsplus_module_5.prepend(bothCase(left, right))(parSeqs);
          } else {
            let parSeqs = acc;
            const left = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            const right = tsplus_module_3.unsafeHead(parSeqs);
            parSeqs = tsplus_module_6.unsafeTail(parSeqs);
            return tsplus_module_5.prepend(thenCase(left, right))(parSeqs);
          }
        }
      })(out);
    } else {
      const head = inp.head;
      const parSeqs = inp.tail;

      switch (head._tag) {
        case "Empty":
          {
            inp = parSeqs;
            out = tsplus_module_5.prepend(tsplus_module_8.right(emptyCase))(out);
            break;
          }

        case "Single":
          {
            inp = parSeqs;
            out = tsplus_module_5.prepend(tsplus_module_8.right(singleCase(head.a)))(out);
            break;
          }

        case "Then":
          {
            inp = tsplus_module_5.prepend(head.left)(tsplus_module_5.prepend(head.right)(parSeqs));
            out = tsplus_module_5.prepend(tsplus_module_8.left(false))(out);
            break;
          }

        case "Both":
          {
            inp = tsplus_module_5.prepend(head.left)(tsplus_module_5.prepend(head.right)(parSeqs));
            out = tsplus_module_5.prepend(tsplus_module_8.left(true))(out);
            break;
          }
      }
    }
  }

  throw new Error("Bug");
}
//# sourceMappingURL=fold.js.map