import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { Equals } from "@tsplus/stdlib/structure/Equals";
import type { RedBlackTree } from "@tsplus/stdlib/collections/RedBlackTree/definition";
import { _K, _V, RedBlackTreeIterator, RedBlackTreeSym } from "@tsplus/stdlib/collections/RedBlackTree/definition";
import type { Node } from "@tsplus/stdlib/collections/RedBlackTree/node";
export declare class RedBlackTreeInternal<K, V> implements RedBlackTree<K, V> {
    readonly ord: Ord<K>;
    readonly root: Node<K, V> | undefined;
    readonly [RedBlackTreeSym]: RedBlackTreeSym;
    readonly [_K]: () => K;
    readonly [_V]: () => V;
    constructor(ord: Ord<K>, root: Node<K, V> | undefined);
    [Symbol.iterator](): RedBlackTreeIterator<K, V>;
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
}
//# sourceMappingURL=RedBlackTreeInternal.d.ts.map