"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RedBlackTreeInternal = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/RedBlackTree/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

class RedBlackTreeInternal {
  constructor(ord, root) {
    this.ord = ord;
    this.root = root;
    this[_a] = _definition.RedBlackTreeSym;
  }

  [(_a = _definition.RedBlackTreeSym, Symbol.iterator)]() {
    const stack = [];
    let n = this.root;

    while (n) {
      stack.push(n);
      n = n.left;
    }

    return new _definition.RedBlackTreeIterator(this, stack, "Forward");
  }

  [tsplus_module_1.Hash.sym]() {
    return tsplus_module_1.hashIterator(this[Symbol.iterator]());
  }

  [tsplus_module_2.Equals.sym](that) {
    return that instanceof RedBlackTreeInternal && (this.root?.count ?? 0) === (that.root?.count ?? 0) && tsplus_module_2.equals(this, that);
  }

}

exports.RedBlackTreeInternal = RedBlackTreeInternal;
//# sourceMappingURL=RedBlackTreeInternal.js.map