"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.backwards = backwards;

var _definition = /*#__PURE__*/require("@tsplus/stdlib/collections/RedBlackTree/definition");

/**
 * Traverse the tree backwards.
 *
 * @tsplus getter RedBlackTree backwards
 */
function backwards(self) {
  return {
    ord: self.ord,
    [Symbol.iterator]: () => {
      const stack = [];
      let n = self.root;

      while (n) {
        stack.push(n);
        n = n.right;
      }

      return new _definition.RedBlackTreeIterator(self, stack, "Backward");
    }
  };
}
//# sourceMappingURL=backwards.js.map