"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.find = find;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/ImmutableArray/from"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Finds the item with key if it exists.
 *
 * @tsplus static RedBlackTree.Aspects find
 * @tsplus pipeable RedBlackTree find
 */
function find(key) {
  return self => {
    const cmp = self.ord.compare;
    let n = self.root;
    const res = [];

    while (n) {
      const d = cmp(key, n.key);

      if (d === 0 && tsplus_module_1.equals(key, n.key)) {
        res.push(n.value);
      }

      if (d <= 0) {
        n = n.left;
      } else {
        n = n.right;
      }
    }

    return tsplus_module_2.from(res.reverse());
  };
}
//# sourceMappingURL=find.js.map