"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAt = getAt;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Returns the element at the specified index within the tree or `None` if the
 * specified index does not exist.
 *
 * @tsplus static RedBlackTree.Aspects getAt
 * @tsplus pipeable RedBlackTree getAt
 */
function getAt(index) {
  return self => {
    if (index < 0) {
      return tsplus_module_1.none;
    }

    let n = self.root;
    let node = undefined;

    while (n) {
      node = n;

      if (n.left) {
        if (index < n.left.count) {
          n = n.left;
          continue;
        }

        index -= n.left.count;
      }

      if (!index) {
        return tsplus_module_1.some([node.key, node.value]);
      }

      index -= 1;

      if (n.right) {
        if (index >= n.right.count) {
          break;
        }

        n = n.right;
      } else {
        break;
      }
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=getAt.js.map