export type Color = "Red" | "Black";
/**
 * @tsplus type RedBlackTree.Node
 * @tsplus companion RedBlackTree.Node.Ops
 */
export declare class Node<K, V> {
    color: Color;
    key: K;
    value: V;
    left: Node<K, V> | undefined;
    right: Node<K, V> | undefined;
    count: number;
    constructor(color: Color, key: K, value: V, left: Node<K, V> | undefined, right: Node<K, V> | undefined, count: number);
}
/**
 * @tsplus fluent RedBlackTree.Node clone
 * @tsplus location "@tsplus/stdlib/collections/RedBlackTree/node"
 */
export declare function clone<K, V>(node: Node<K, V>): Node<K, V>;
/**
 * @tsplus fluent RedBlackTree.Node swap
 * @tsplus location "@tsplus/stdlib/collections/RedBlackTree/node"
 */
export declare function swap<K, V>(n: Node<K, V>, v: Node<K, V>): void;
/**
 * @tsplus fluent RedBlackTree.Node repaint
 * @tsplus location "@tsplus/stdlib/collections/RedBlackTree/node"
 */
export declare function repaint<K, V>(node: Node<K, V>, color: Color): Node<K, V>;
/**
 * @tsplus fluent RedBlackTree.Node recount
 * @tsplus location "@tsplus/stdlib/collections/RedBlackTree/node"
 */
export declare function recount<K, V>(node: Node<K, V>): void;
//# sourceMappingURL=node.d.ts.map