"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceWithIndex = reduceWithIndex;

/**
 * Reduce a state over the map entries.
 *
 * @tsplus static RedBlackTree.Aspects reduceWithIndex
 * @tsplus pipeable RedBlackTree reduceWithIndex
 */
function reduceWithIndex(z, f) {
  return self => {
    let x = z;

    for (const [k, v] of self) {
      x = f(x, k, v);
    }

    return x;
  };
}
//# sourceMappingURL=reduceWithIndex.js.map