import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Stack } from "@tsplus/stdlib/data/Stack";
import type { Node } from "@tsplus/stdlib/collections/RedBlackTree/node";
/**
 * Visit nodes with key lower than max and greater then or equal to min.
 * @tsplus static RedBlackTree.Ops visitBetween
 * @tsplus location "@tsplus/stdlib/collections/RedBlackTree/visitBetween"
 */
export declare function visitBetween<K, V, A>(node: Node<K, V>, min: K, max: K, ord: Ord<K>, visit: (key: K, value: V) => Maybe<A>): Maybe<A>;
//# sourceMappingURL=visitBetween.d.ts.map