import { SortedMap } from "@tsplus/stdlib/collections/SortedMap/definition";
import { RedBlackTree } from "@tsplus/stdlib/collections/RedBlackTree/definition";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { Equals } from "@tsplus/stdlib/structure/Equals";
import { _K, _V, SortedMapSym } from "@tsplus/stdlib/collections/SortedMap/definition";
export declare class SortedMapInternal<K, V> implements SortedMap<K, V> {
    readonly tree: RedBlackTree<K, V>;
    readonly [SortedMapSym]: SortedMapSym;
    readonly [_K]: () => K;
    readonly [_V]: () => V;
    constructor(tree: RedBlackTree<K, V>);
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
    [Symbol.iterator](): Iterator<readonly [K, V]>;
}
/**
 * @tsplus macro remove
 */
export declare function concreteSortedMap<K, V>(_: SortedMap<K, V>): asserts _ is SortedMapInternal<K, V>;
//# sourceMappingURL=SortedMapInternal.d.ts.map