import { SortedSet } from "@tsplus/stdlib/collections/SortedSet/definition";
import { RedBlackTree } from "@tsplus/stdlib/collections/RedBlackTree/definition";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { Equals } from "@tsplus/stdlib/structure/Equals";
import { _A, SortedSetSym } from "@tsplus/stdlib/collections/SortedSet/definition";
export declare class SortedSetInternal<A> implements SortedSet<A> {
    readonly keyTree: RedBlackTree<A, unknown>;
    readonly [SortedSetSym]: SortedSetSym;
    readonly [_A]: () => A;
    constructor(keyTree: RedBlackTree<A, unknown>);
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
    [Symbol.iterator](): Iterator<A>;
}
/**
 * @tsplus macro remove
 */
export declare function concreteSortedSet<A>(_: SortedSet<A>): asserts _ is SortedSetInternal<A>;
//# sourceMappingURL=SortedSetInternal.d.ts.map