import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Equals } from "@tsplus/stdlib/structure/Equals";
export declare const SortedSetSym: unique symbol;
export type SortedSetSym = typeof SortedSetSym;
export declare const _A: unique symbol;
export type _A = typeof _A;
/**
 * @tsplus type SortedSet
 */
export interface SortedSet<A> extends Collection<A>, Equals {
    readonly [SortedSetSym]: SortedSetSym;
    readonly [_A]: () => A;
    [Symbol.iterator](): Iterator<A>;
}
/**
 * @tsplus type SortedSet.Ops
 */
export interface SortedSetOps {
    $: SortedSetAspects;
}
export declare const SortedSet: SortedSetOps;
/**
 * @tsplus type SortedSet.Aspects
 */
export interface SortedSetAspects {
}
/**
 * Type guard
 * @tsplus static SortedSet.Ops isSortedSet
 * @tsplus location "@tsplus/stdlib/collections/SortedSet/definition"
 */
export declare function isSortedSet<A>(u: Iterable<A>): u is SortedSet<A>;
export declare function isSortedSet(u: unknown): u is SortedSet<unknown>;
//# sourceMappingURL=definition.d.ts.map