import { Refinement } from "@tsplus/stdlib/data/Function";
import { SortedSet } from "@tsplus/stdlib/collections/SortedSet/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Partition the values of a set using the specified predicate.
 * @tsplus static SortedSet.Aspects partition
 * @tsplus pipeable SortedSet partition
 * @tsplus location "@tsplus/stdlib/collections/SortedSet/partition"
 */
export declare function partition<A, B extends A>(f: Refinement<A, B>): (self: SortedSet<A>) => readonly [SortedSet<A>, SortedSet<B>];
export declare function partition<A>(f: Predicate<A>): (self: SortedSet<A>) => readonly [SortedSet<A>, SortedSet<A>];
//# sourceMappingURL=partition.d.ts.map