"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTree = exports.TreeTypeId = exports.TreeAspects = exports.Tree = void 0;
exports.make = make;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Chunk/operations/empty"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const isTree = isTree_1;
exports.isTree = isTree;
const TreeTypeId = /*#__PURE__*/Symbol.for("@tsplus/collections/Tree");
/**
 * @tsplus type Tree
 * @tsplus companion Tree.Ops
 */

exports.TreeTypeId = TreeTypeId;

class Tree {
  constructor(value, forest) {
    this.value = value;
    this.forest = forest;
    this[_a] = TreeTypeId;
  }

  [(_a = TreeTypeId, tsplus_module_1.Equals.sym)](other) {
    return isTree_1(other) && tsplus_module_1.equals(this.value, other.value) && tsplus_module_2.corresponds_(this.forest, other.forest, (a, b) => tsplus_module_1.equals(a, b));
  }

  [tsplus_module_3.Hash.sym]() {
    return tsplus_module_3.optimize(tsplus_module_3.combine(tsplus_module_3.hashUnknown(this.value), this.forest[tsplus_module_3.Hash.sym]()));
  }

}
/**
 * @tsplus static Tree.Ops $
 */


exports.Tree = Tree;
const TreeAspects = {};
exports.TreeAspects = TreeAspects;
const empty = /*#__PURE__*/tsplus_module_4.empty();
/**
 * @tsplus static Tree.Ops __call
 */

function make(value, forest = empty) {
  return new Tree(value, forest);
}
/**
 * Type guard
 *
 * @tsplus static Tree.Ops isTree
 */


function isTree_1(t) {
  return typeof t === "object" && t instanceof Tree && TreeTypeId in t;
}
//# sourceMappingURL=definition.js.map