import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Hash } from "@tsplus/stdlib/structure/Hash";
export declare class LinkedListNode<T> {
    readonly value: T;
    removed: boolean;
    left: LinkedListNode<T> | undefined;
    right: LinkedListNode<T> | undefined;
    constructor(value: T);
}
/**
 * @tsplus type DoublyLinkedList
 */
export declare class DoublyLinkedList<T> implements Collection<T>, Equals {
    get head(): T | undefined;
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
    get isEmpty(): boolean;
    get tail(): T | undefined;
    length: number;
    private headN;
    private tailN;
    forEach(f: (_: T) => void): void;
    add(value: T): LinkedListNode<T>;
    empty(): void;
    pop(): T | undefined;
    remove(n: LinkedListNode<T>): void;
    shift(): T | undefined;
    [Symbol.iterator](): Iterator<T>;
}
//# sourceMappingURL=DoublyLinkedList.d.ts.map