import { Collection } from "@tsplus/stdlib/collections/Collection/definition";
import { Equals } from "@tsplus/stdlib/structure/Equals";
import { AtomicNumber } from "@tsplus/stdlib/data/AtomicNumber";
import { Hash } from "@tsplus/stdlib/structure/Hash";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { ImmutableArray } from "@tsplus/stdlib/collections/ImmutableArray/definition";
export declare const MutableHashMapSym: unique symbol;
export type MutableHashMapSym = typeof MutableHashMapSym;
export declare const _K: unique symbol;
export type _K = typeof _K;
export declare const _V: unique symbol;
export type _V = typeof _V;
/**
 * A mutable `HashMap`.
 *
 * @tsplus type MutableHashMap
 * @tsplus companion MutableHashMap.Ops
 */
export declare class MutableHashMap<K, V> implements Collection<readonly [K, V]>, Equals {
    readonly [MutableHashMapSym]: MutableHashMapSym;
    readonly [_K]: () => K;
    readonly [_V]: () => V;
    private backingMap;
    private length;
    get size(): number;
    [Hash.sym](): number;
    [Equals.sym](that: unknown): boolean;
    get(k: K): Maybe<V>;
    remove(k: K): MutableHashMap<K, V>;
    set(k: K, v: V): MutableHashMap<K, V>;
    update(k: K, f: (v: V) => V): MutableHashMap<K, V>;
    [Symbol.iterator](): Iterator<readonly [K, V]>;
}
/**
 * @tsplus static MutableHashMap.Ops $
 * @tsplus location "@tsplus/stdlib/collections/mutable/MutableHashMap/definition"
 */
export declare const MutableHashMapAspects: MutableHashMapAspects;
/**
 * @tsplus type MutableHashMap.Aspects
 */
export interface MutableHashMapAspects {
}
//# sourceMappingURL=definition.d.ts.map