import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { MutableHashMap } from "@tsplus/stdlib/collections/mutable/MutableHashMap/definition";
/**
 * Alter the value stored for `key` in the `MutableHashMap` using the specified
 * function `f`, which uses the internal hash function.
 *
 * `f` will be invoked with the current value for `k` if it exists, or `None`
 *  if no such value exists.
 *
 * `modify` will always either update or insert a value into the map.
 * @tsplus static MutableHashMap.Aspects modify
 * @tsplus pipeable MutableHashMap modify
 * @tsplus location "@tsplus/stdlib/collections/mutable/MutableHashMap/modify"
 */
export declare function modify<K, V>(key: K, f: (value: Maybe<V>) => Maybe<V>): (self: MutableHashMap<K, V>) => MutableHashMap<K, V>;
//# sourceMappingURL=modify.d.ts.map