"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modify = modify;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Alter the value stored for `key` in the `MutableHashMap` using the specified
 * function `f`, which uses the internal hash function.
 *
 * `f` will be invoked with the current value for `k` if it exists, or `None`
 *  if no such value exists.
 *
 * `modify` will always either update or insert a value into the map.
 *
 * @tsplus static MutableHashMap.Aspects modify
 * @tsplus pipeable MutableHashMap modify
 */
function modify(key, f) {
  return self => {
    const result = f(self.get(key));

    if (tsplus_module_1.isSome(result)) {
      self.set(key, result.value);
    } else {
      self.remove(key);
    }

    return self;
  };
}
//# sourceMappingURL=modify.js.map