"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MutableHashSet = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableHashMap/empty"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/mutable/MutableHashMap/has"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/collections/Collection/functions"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * @tsplus type MutableHashSet
 * @tsplus companion MutableHashSet.Ops
 */
class MutableHashSet {
  constructor() {
    this.backingMap = tsplus_module_1.empty();
  }

  [tsplus_module_2.Hash.sym]() {
    return tsplus_module_2.hashRandomCached(this);
  }

  [tsplus_module_3.Equals.sym](that) {
    return this === that;
  }

  get size() {
    return this.backingMap.size;
  }

  isEmpty() {
    return this.size === 0;
  }

  contains(value) {
    return tsplus_module_4.has(value)(this.backingMap);
  }

  add(value) {
    this.backingMap.set(value, true);
    return tsplus_module_4.has(value)(this.backingMap);
  }

  remove(value) {
    this.backingMap.remove(value);
    return !tsplus_module_4.has(value)(this.backingMap);
  }

  [Symbol.iterator]() {
    return tsplus_module_5.map(([a]) => a)(this.backingMap)[Symbol.iterator]();
  }

}

exports.MutableHashSet = MutableHashSet;
//# sourceMappingURL=definition.js.map