import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Copy } from "@tsplus/stdlib/structure/Copy";
/**
 * @tsplus type Case.Ops
 */
export interface CaseOps {
    of: <A extends Case>() => Case.Constructor<A>;
    tagged: <A extends Case & {
        _tag: string;
    }>(tag: A["_tag"]) => Case.Constructor<A, "_tag">;
}
export declare const Case: CaseOps;
/**
 * @tsplus type Case
 */
export interface Case extends Equals, Copy {
}
export declare namespace Case {
    interface Constructor<A extends Case, T extends keyof A = never> {
        (args: Omit<A, T | keyof (Equals & Copy)>): A;
    }
}
//# sourceMappingURL=Case.d.ts.map