"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Case = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Copy"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Case = {
  of: () => // @ts-expect-error
  args => {
    const obj = {
      [tsplus_module_1.Hash.sym]: hashImpl,
      [tsplus_module_2.Equals.sym]: equalsImpl,
      [tsplus_module_3.Copy.sym]: copyImpl
    };

    for (const k of Object.keys(args)) {
      if (typeof args[k] !== "undefined") {
        obj[k] = args[k];
      }
    }

    return obj;
  },
  tagged: tag => // @ts-expect-error
  args => {
    const obj = {
      [tsplus_module_1.Hash.sym]: hashImpl,
      [tsplus_module_2.Equals.sym]: equalsImpl,
      [tsplus_module_3.Copy.sym]: copyImpl,
      _tag: tag
    };

    for (const k of Object.keys(args)) {
      if (typeof args[k] !== "undefined") {
        obj[k] = args[k];
      }
    }

    return obj;
  }
};
exports.Case = Case;

function copyImpl(that) {
  const obj = {
    [tsplus_module_1.Hash.sym]: hashImpl,
    [tsplus_module_2.Equals.sym]: equalsImpl,
    [tsplus_module_3.Copy.sym]: copyImpl
  };

  for (const k of Object.keys(this)) {
    if (typeof this[k] !== "undefined") {
      obj[k] = this[k];
    }
  }

  for (const k of Object.keys(that)) {
    if (typeof that[k] !== "undefined") {
      obj[k] = that[k];
    } else {
      delete obj[k];
    }
  } // @ts-expect-error


  return obj;
}

function equalsImpl(that) {
  const keysA = Object.keys(this);
  const keysB = Object.keys(that);

  if (keysA.length !== keysB.length) {
    return false;
  }

  for (const key of keysA) {
    if (!tsplus_module_2.equals(this[key], that[key])) {
      return false;
    }
  }

  return true;
}

function hashImpl() {
  return tsplus_module_1.hashPlainObject(this);
}
//# sourceMappingURL=Case.js.map