"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UpdateRightOrPatch = exports.UpdateLeftOrPatch = exports.SetRightOrPatch = exports.SetLeftOrPatch = exports.OrPatchValueSym = exports.OrPatchValue2Sym = exports.OrPatchSym = exports.OrPatchPatchSym = exports.OrPatchPatch2Sym = exports.OrPatch = exports.EmptyOrPatch = exports.BaseOrPatch = exports.AndThenOrPatch = void 0;
exports.orPatchInstruction = orPatchInstruction;
exports.unifyOrPatch = unifyOrPatch;

var _a;

const OrPatchSym = /*#__PURE__*/Symbol.for("@Differ.Or.Patch");
exports.OrPatchSym = OrPatchSym;
const OrPatchValueSym = /*#__PURE__*/Symbol.for("@Differ.Or.Patch.Value");
exports.OrPatchValueSym = OrPatchValueSym;
const OrPatchValue2Sym = /*#__PURE__*/Symbol.for("@Differ.Or.Patch.Value2");
exports.OrPatchValue2Sym = OrPatchValue2Sym;
const OrPatchPatchSym = /*#__PURE__*/Symbol.for("@Differ.Or.Patch.Patch");
exports.OrPatchPatchSym = OrPatchPatchSym;
const OrPatchPatch2Sym = /*#__PURE__*/Symbol.for("@Differ.Or.Patch.Patch2");
/**
 * @tsplus static Differ.Ops Or
 */

exports.OrPatchPatch2Sym = OrPatchPatch2Sym;
const OrPatch = {
  $: {}
};
/**
 * @tsplus unify Differ.Or.Patch
 */

exports.OrPatch = OrPatch;

function unifyOrPatch(self) {
  return self;
}

class BaseOrPatch {
  constructor() {
    this[_a] = OrPatchSym;
  }

}

exports.BaseOrPatch = BaseOrPatch;
_a = OrPatchSym;

class AndThenOrPatch extends BaseOrPatch {
  constructor(first, second) {
    super();
    this.first = first;
    this.second = second;
    this._tag = "AndThen";
  }

}

exports.AndThenOrPatch = AndThenOrPatch;

class EmptyOrPatch extends BaseOrPatch {
  constructor() {
    super(...arguments);
    this._tag = "Empty";
  }

}

exports.EmptyOrPatch = EmptyOrPatch;

class SetLeftOrPatch extends BaseOrPatch {
  constructor(value) {
    super();
    this.value = value;
    this._tag = "SetLeft";
  }

}

exports.SetLeftOrPatch = SetLeftOrPatch;

class SetRightOrPatch extends BaseOrPatch {
  constructor(value) {
    super();
    this.value = value;
    this._tag = "SetRight";
  }

}

exports.SetRightOrPatch = SetRightOrPatch;

class UpdateLeftOrPatch extends BaseOrPatch {
  constructor(patch) {
    super();
    this.patch = patch;
    this._tag = "UpdateLeft";
  }

}

exports.UpdateLeftOrPatch = UpdateLeftOrPatch;

class UpdateRightOrPatch extends BaseOrPatch {
  constructor(patch) {
    super();
    this.patch = patch;
    this._tag = "UpdateRight";
  }

}
/**
 * @tsplus macro identity
 */


exports.UpdateRightOrPatch = UpdateRightOrPatch;

function orPatchInstruction(self) {
  // @ts-expect-error
  return self;
}
//# sourceMappingURL=definition.js.map