import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Differ } from "@tsplus/stdlib/data/Differ/definition";
import { List } from "@tsplus/stdlib/collections/List/definition";
/**
 * Applies an or patch to a value to produce a new value which represents
 * the original value updated with the changes described by this patch.
 * @tsplus static Differ.Or.Patch.Aspects apply
 * @tsplus pipeable Differ.Or.Patch apply
 * @tsplus location "@tsplus/stdlib/data/Differ/OrPatch/operations/apply"
 */
export declare function apply<Value, Value2, Patch, Patch2>(oldValue: Either<Value, Value2>, left: Differ<Value, Patch>, right: Differ<Value2, Patch2>): (self: Differ.Or.Patch<Value, Value2, Patch, Patch2>) => Either<Value, Value2>;
//# sourceMappingURL=apply.d.ts.map