"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.diff = diff;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Differ/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

var _definition2 = /*#__PURE__*/require("@tsplus/stdlib/data/Differ/OrPatch/definition");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs an `OrPatch` from a new and old value and a differ for the
 * values.
 *
 * @tsplus static Differ.Or.Patch.Ops diff
 */
function diff(oldValue, newValue, left, right) {
  switch (oldValue._tag) {
    case "Left":
      {
        switch (newValue._tag) {
          case "Left":
            {
              const valuePatch = left.diff(oldValue.left, newValue.left);

              if (tsplus_module_2.equals(valuePatch, left.empty)) {
                return new _definition2.EmptyOrPatch();
              }

              return new _definition2.UpdateLeftOrPatch(valuePatch);
            }

          case "Right":
            {
              return new _definition2.SetRightOrPatch(newValue.right);
            }
        }
      }

    case "Right":
      {
        switch (newValue._tag) {
          case "Left":
            {
              return new _definition2.SetLeftOrPatch(newValue.left);
            }

          case "Right":
            {
              const valuePatch = right.diff(oldValue.right, newValue.right);

              if (tsplus_module_2.equals(valuePatch, right.empty)) {
                return new _definition2.EmptyOrPatch();
              }

              return new _definition2.UpdateRightOrPatch(valuePatch);
            }
        }
      }
  }
}
//# sourceMappingURL=diff.js.map