import { Differ } from "@tsplus/stdlib/data/Differ/definition";
/**
 * Constructs a differ that just diffs two values by returning a function that
 * sets the value to the new value. This differ does not support combining
 * multiple updates to the value compositionally and should only be used when
 * there is no compositional way to update them.
 * @tsplus static Differ.Ops update
 * @tsplus location "@tsplus/stdlib/data/Differ/operations/update"
 */
export declare function update<A>(): Differ<A, (a: A) => A>;
//# sourceMappingURL=update.d.ts.map