"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DurationSym = exports.DurationInternal = exports.Duration = void 0;
exports.add = add;
exports.days = days;
exports.equals = equals;
exports.greaterThen = greaterThen;
exports.greaterThenOrEqual = greaterThenOrEqual;
exports.hours = hours;
exports.isDuration = void 0;
exports.lowerThen = lowerThen;
exports.lowerThenOrEqual = lowerThenOrEqual;
exports.millis = millis;
exports.minutes = minutes;
exports.seconds = seconds;
exports.subtract = subtract;
exports.times = times;
exports.timesInverted = timesInverted;
exports.weeks = weeks;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _a;

const isDuration = isDuration_1;
exports.isDuration = isDuration;
const DurationSym = /*#__PURE__*/Symbol.for("@tsplus/stdlib/data/Duration");
exports.DurationSym = DurationSym;

class DurationInternal {
  constructor(millis) {
    this.millis = millis;
    this[_a] = DurationSym;
  }

  [(_a = DurationSym, tsplus_module_1.Hash.sym)]() {
    return tsplus_module_1.hashNumber(this.millis);
  }

  [tsplus_module_2.Equals.sym](other) {
    return isDuration_1(other) && this.millis === other.millis;
  }

}
/**
 * @tsplus static Duration.Ops isDuration
 */


exports.DurationInternal = DurationInternal;

function isDuration_1(u) {
  return typeof u === "object" && u != null && DurationSym in u;
}

const Duration = {
  $: {},
  Zero: /*#__PURE__*/new DurationInternal(0),
  Infinity: /*#__PURE__*/new DurationInternal(Number.MAX_SAFE_INTEGER)
};
/**
 * @tsplus getter number millis
 * @tsplus static Duration.Ops millis
 */

exports.Duration = Duration;

function millis(self) {
  return new DurationInternal(self);
}
/**
 * @tsplus getter number seconds
 * @tsplus static Duration.Ops seconds
 */


function seconds(self) {
  return new DurationInternal(self * 1000);
}
/**
 * @tsplus getter number minutes
 * @tsplus static Duration.Ops minutes
 */


function minutes(self) {
  return new DurationInternal(self * 60000);
}
/**
 * @tsplus getter number hours
 * @tsplus static Duration.Ops hours
 */


function hours(self) {
  return new DurationInternal(self * 3600000);
}
/**
 * @tsplus getter number days
 * @tsplus static Duration.Ops days
 */


function days(self) {
  return new DurationInternal(self * 86400000);
}
/**
 * @tsplus getter number weeks
 * @tsplus static Duration.Ops weeks
 */


function weeks(self) {
  return new DurationInternal(self * 604800000);
}
/**
 * @tsplus pipeable-operator Duration *
 * @tsplus static Duration.Aspects times
 * @tsplus pipeable Duration times
 */


function times(times) {
  return self => new DurationInternal(self.millis * times);
}
/**
 * @tsplus operator Duration *
 */


function timesInverted(times, self) {
  return new DurationInternal(self.millis * times);
}
/**
 * @tsplus pipeable-operator Duration +
 * @tsplus static Duration.Aspects add
 * @tsplus pipeable Duration add
 */


function add(that) {
  return self => new DurationInternal(self.millis + that.millis);
}
/**
 * @tsplus pipeable-operator Duration -
 * @tsplus static Duration.Aspects subtract
 * @tsplus pipeable Duration subtract
 */


function subtract(that) {
  return self => new DurationInternal(self.millis - that.millis);
}
/**
 * @tsplus pipeable-operator Duration <
 * @tsplus static Duration.Aspects lowerThen
 * @tsplus pipeable Duration lowerThen
 */


function lowerThen(that) {
  return self => self.millis < that.millis;
}
/**
 * @tsplus pipeable-operator Duration <=
 * @tsplus static Duration.Aspects lowerThenOrEqual
 * @tsplus pipeable Duration lowerThenOrEqual
 */


function lowerThenOrEqual(that) {
  return self => self.millis <= that.millis;
}
/**
 * @tsplus pipeable-operator Duration >
 * @tsplus static Duration.Aspects greaterThen
 * @tsplus pipeable Duration greaterThen
 */


function greaterThen(that) {
  return self => self.millis > that.millis;
}
/**
 * @tsplus pipeable-operator Duration >=
 * @tsplus static Duration.Aspects greaterThenOrEqual
 * @tsplus pipeable Duration greaterThenOrEqual
 */


function greaterThenOrEqual(that) {
  return self => self.millis >= that.millis;
}
/**
 * @tsplus pipeable-operator Duration ==
 * @tsplus static Duration.Aspects equals
 * @tsplus pipeable Duration equals
 */


function equals(that) {
  return self => self.millis === that.millis;
}
//# sourceMappingURL=Duration.js.map