"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compactMaybe = compactMaybe;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Compact an `Either<E, Maybe<A>>`  to an `Either<E, A>` given an
 * `AssociativeIdentity<E>`.
 *
 * @tsplus static Either.Aspects compactMaybe
 * @tsplus pipeable Either compactMaybe
 */
function compactMaybe(M) {
  return self => tsplus_module_1.isLeft(self) ? self : self.right._tag === "None" ? tsplus_module_1.left(M.identity) : tsplus_module_1.right(self.right.value);
}
//# sourceMappingURL=compactMaybe.js.map