import { Refinement } from "@tsplus/stdlib/data/Function";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Apply the specified predicate to `A` and construct `E` in case that the
 * specified predicate returns `false`.
 * @tsplus static Either.Aspects filterOrElse
 * @tsplus pipeable Either filterOrElse
 * @tsplus location "@tsplus/stdlib/data/Either/filterOrElse"
 */
export declare function filterOrElse<E, A, B extends A>(f: Refinement<A, B>, onFalse: (a: A) => E): <E2>(self: Either<E2, A>) => Either<E | E2, B>;
export declare function filterOrElse<E, A>(f: Predicate<A>, onFalse: (a: A) => E): <E2>(self: Either<E2, A>) => Either<E | E2, A>;
//# sourceMappingURL=filterOrElse.d.ts.map