import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Extends this computation with another computation that depends on the
 * result of this computation by running the first computation, using its
 * result to generate a second computation, and running that computation.
 * @tsplus static Either.Aspects flatMap
 * @tsplus pipeable Either flatMap
 * @tsplus location "@tsplus/stdlib/data/Either/flatMap"
 */
export declare function flatMap<A, B, E2>(f: (a: A) => Either<E2, B>): <E>(self: import("./definition").Either<E, A>) => import("./definition").Either<E2 | E, B>;
//# sourceMappingURL=flatMap.d.ts.map