import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Takes two functions and an `Either` value, if the value is a `Left` the
 * inner value is applied to the first function, if the value is a `Right` the
 * inner value is applied to the second function.
 * @tsplus static Either.Aspects fold
 * @tsplus pipeable Either fold
 * @tsplus location "@tsplus/stdlib/data/Either/fold"
 */
export declare function fold<E, A, B, C>(onLeft: (e: E) => B, onRight: (a: A) => C): (self: Either<E, A>) => B | C;
//# sourceMappingURL=fold.d.ts.map