import { Refinement } from "@tsplus/stdlib/data/Function";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Predicate } from "@tsplus/stdlib/data/Predicate";
/**
 * Construct `Either<E, A>` by applying a predicate to `A` and constructing
 * `E` if the predicate is `false`.
 * @tsplus static Either.Ops fromPredicate
 * @tsplus location "@tsplus/stdlib/data/Either/fromPredicate"
 */
export declare function fromPredicate<E, A, B extends A>(a: A, f: Refinement<A, B>, onFalse: (a: A) => E): Either<E, B>;
export declare function fromPredicate<E, A>(a: A, f: Predicate<A>, onFalse: (a: A) => E): Either<E, A>;
//# sourceMappingURL=fromPredicate.d.ts.map