"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  unsafeCoerce: true,
  absurd: true,
  constant: true,
  constFalse: true,
  constNull: true,
  constTrue: true,
  constUndefined: true,
  constVoid: true,
  flip: true,
  identity: true,
  literal: true,
  hole: true
};
exports.absurd = absurd;
exports.constFalse = constFalse;
exports.constNull = constNull;
exports.constTrue = constTrue;
exports.constUndefined = constUndefined;
exports.constVoid = constVoid;
exports.constant = constant;
exports.flip = flip;
exports.hole = hole;
exports.identity = identity;
exports.literal = literal;
exports.unsafeCoerce = unsafeCoerce;

var _pipe = /*#__PURE__*/require("@tsplus/stdlib/data/Function/pipe");

Object.keys(_pipe).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _pipe[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _pipe[key];
    }
  });
});

/**
 * Performs unsafe coercion of types
 *
 * @tsplus macro identity
 */
function unsafeCoerce(a) {
  return a;
}
/**
 * Will raise if called
 */


function absurd(_) {
  throw new Error("Called `absurd` function which should be uncallable");
}
/**
 * A constant function that always return A
 */


function constant(a) {
  return () => a;
}
/**
 * A thunk that returns always `false`
 */


function constFalse() {
  return false;
}
/**
 * A thunk that returns always `null`
 */


function constNull() {
  return null;
}
/**
 * A thunk that returns always `true`
 */


function constTrue() {
  return true;
}
/**
 * A thunk that returns always `undefined`
 */


function constUndefined() {
  return;
}
/**
 * A thunk that returns always `void`
 */


function constVoid() {
  return;
}
/**
 * Flips the order of the arguments of a function of two arguments.
 */


function flip(f) {
  return (b, a) => f(a, b);
}
/**
 * Identity function
 *
 * @tsplus macro identity
 */


function identity(a) {
  return a;
}
/**
 * Force string to be literal
 *
 * @tsplus macro identity
 */


function literal(k) {
  return k;
}
/**
 * Type Hole, to be used while implementing functions where you need a placeholder
 */


function hole() {
  throw new Error("Hole should never be called");
}
//# sourceMappingURL=Function.js.map