"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LazyValue = void 0;

class LazyValue {
  constructor(__lazy) {
    this.__lazy = __lazy;
  }

  get value() {
    const computed = this.__lazy();

    Object.defineProperty(this, "value", {
      value: computed
    });
    return computed;
  }

}

exports.LazyValue = LazyValue;

LazyValue.make = f => new LazyValue(f);
//# sourceMappingURL=LazyValue.js.map