import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * @tsplus type Match/Ops
 */
export interface MatchOps {
    $: MatchAspects;
}
export declare const Match: MatchOps;
/**
 * @tsplus type Match/Aspects
 */
export interface MatchAspects {
}
/**
 * @tsplus static Match/Aspects pattern
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const pattern: <N extends string>(n: N) => {
    <X extends {
        [k in N]: string;
    }, K extends {
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>(_: K): (m: X) => ReturnType<K[keyof K]>;
    <X extends {
        [k in N]: string;
    }, K extends Partial<{
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>, H>(_: K & {
        [k in X[N]]?: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }, __: (_: Exclude<X, {
        _tag: keyof K;
    }>, __: Exclude<X, {
        _tag: keyof K;
    }>) => H): (m: X) => {
        [k in keyof K]: ReturnType<NonNullable<K[k]>>;
    }[keyof K] | H;
};
/**
 * @tsplus static Match/Aspects tag
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const matchTag: {
    <X extends {
        _tag: string;
    }, K extends { [k in X["_tag"]]: (_: Extract<X, {
        _tag: k;
    }>, __: Extract<X, {
        _tag: k;
    }>) => any; }>(_: K): (m: X) => ReturnType<K[keyof K]>;
    <X_1 extends {
        _tag: string;
    }, K_1 extends Partial<{ [k_1 in X_1["_tag"]]: (_: Extract<X_1, {
        _tag: k_1;
    }>, __: Extract<X_1, {
        _tag: k_1;
    }>) => any; }>, H>(_: K_1 & { [k_2 in X_1["_tag"]]?: ((_: Extract<X_1, {
        _tag: k_2;
    }>, __: Extract<X_1, {
        _tag: k_2;
    }>) => any) | undefined; }, __: (_: Exclude<X_1, {
        _tag: keyof K_1;
    }>, __: Exclude<X_1, {
        _tag: keyof K_1;
    }>) => H): (m: X_1) => H | { [k_3 in keyof K_1]: ReturnType<NonNullable<K_1[k_3]>>; }[keyof K_1];
};
/**
 * @tsplus static Match/Ops pattern
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const pattern_: <N extends string>(n: N) => {
    <X extends {
        [k in N]: string;
    }, K extends {
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>(m: X, _: K): ReturnType<K[keyof K]>;
    <X extends {
        [k in N]: string;
    }, K extends Partial<{
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>, H>(m: X, _: K & {
        [k in X[N]]?: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }, __: (_: Exclude<X, {
        _tag: keyof K;
    }>, __: Exclude<X, {
        _tag: keyof K;
    }>) => H): {
        [k in keyof K]: ReturnType<NonNullable<K[k]>>;
    }[keyof K] | H;
};
/**
 * @tsplus static Match/Ops tag
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const matchTag_: {
    <X extends {
        _tag: string;
    }, K extends { [k in X["_tag"]]: (_: Extract<X, {
        _tag: k;
    }>, __: Extract<X, {
        _tag: k;
    }>) => any; }>(m: X, _: K): ReturnType<K[keyof K]>;
    <X_1 extends {
        _tag: string;
    }, K_1 extends Partial<{ [k_1 in X_1["_tag"]]: (_: Extract<X_1, {
        _tag: k_1;
    }>, __: Extract<X_1, {
        _tag: k_1;
    }>) => any; }>, H>(m: X_1, _: K_1 & { [k_2 in X_1["_tag"]]?: ((_: Extract<X_1, {
        _tag: k_2;
    }>, __: Extract<X_1, {
        _tag: k_2;
    }>) => any) | undefined; }, __: (_: Exclude<X_1, {
        _tag: keyof K_1;
    }>, __: Exclude<X_1, {
        _tag: keyof K_1;
    }>) => H): H | { [k_3 in keyof K_1]: ReturnType<NonNullable<K_1[k_3]>>; }[keyof K_1];
};
/**
 * @tsplus static Match/Aspects patternFor
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const patternFor: <N extends string>(n: N) => <X extends {
    [k in N]: string;
}>() => {
    <K extends {
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>(_: K): (m: X) => ReturnType<K[keyof K]>;
    <K extends Partial<{
        [k in X[N]]: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }>, H>(_: K & {
        [k in X[N]]?: (_: Extract<X, {
            [_tag in N]: k;
        }>, __: Extract<X, {
            [_tag in N]: k;
        }>) => any;
    }, __: (_: Exclude<X, {
        _tag: keyof K;
    }>, __: Exclude<X, {
        _tag: keyof K;
    }>) => H): (m: X) => {
        [k in keyof K]: ReturnType<NonNullable<K[k]>>;
    }[keyof K] | H;
};
/**
 * @tsplus static Match/Ops tagFor
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare const matchTagFor: <X extends {
    _tag: string;
}>() => {
    <K extends { [k in X["_tag"]]: (_: Extract<X, {
        _tag: k;
    }>, __: Extract<X, {
        _tag: k;
    }>) => any; }>(_: K): (m: X) => ReturnType<K[keyof K]>;
    <K_1 extends Partial<{ [k_1 in X["_tag"]]: (_: Extract<X, {
        _tag: k_1;
    }>, __: Extract<X, {
        _tag: k_1;
    }>) => any; }>, H>(_: K_1 & { [k_2 in X["_tag"]]?: ((_: Extract<X, {
        _tag: k_2;
    }>, __: Extract<X, {
        _tag: k_2;
    }>) => any) | undefined; }, __: (_: Exclude<X, {
        _tag: keyof K_1;
    }>, __: Exclude<X, {
        _tag: keyof K_1;
    }>) => H): (m: X) => H | { [k_3 in keyof K_1]: ReturnType<NonNullable<K_1[k_3]>>; }[keyof K_1];
};
/**
 * @tsplus static Match/Ops isAdtElement
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare function isAdtElement_<A extends {
    _tag: string;
}, K extends A["_tag"]>(tag: K, adt: A): adt is Extract<A, {
    _tag: K;
}>;
/**
 * @tsplus static Match/Aspects isAdtElement
 */
export declare const isAdtElement: <A extends {
    _tag: string;
}>(adt: A) => <K extends A["_tag"]>(tag: K) => boolean;
/**
 * @tsplus static Match/Ops isGenericAdtElement
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare function isGenericAdtElement<T extends string>(_t: T): <A extends {
    [k in T]: string;
}, K extends A[T]>(tag: K) => (adt: A) => adt is Extract<A, {
    [k in T]: K;
}>;
/**
 * @tsplus static Match/Ops onAdtElement
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare function onAdtElement<A extends {
    _tag: string;
}, K extends A["_tag"], B>(tag: K, f: (_: Extract<A, {
    _tag: K;
}>) => B): (adt: A) => Maybe<B>;
/**
 * @tsplus static Match/Ops onGenericAdtElement
 * @tsplus location "@tsplus/stdlib/data/Match"
 */
export declare function onGenericAdtElement<T extends string>(_t: T): <A extends { [k in T]: string; }, K extends A[T], B>(tag: K, f: (_: Extract<A, { [k_1 in T]: K; }>) => B) => (adt: A) => import("./Maybe").Maybe<B>;
//# sourceMappingURL=Match.d.ts.map