"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isAdtElement = exports.Match = void 0;
exports.isAdtElement_ = isAdtElement_;
exports.isGenericAdtElement = isGenericAdtElement;
exports.matchTag_ = exports.matchTagFor = exports.matchTag = void 0;
exports.onAdtElement = onAdtElement;
exports.onGenericAdtElement = onGenericAdtElement;
exports.pattern_ = exports.patternFor = exports.pattern = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Match = {
  $: {}
};
/**
 * @tsplus static Match/Aspects pattern
 */

exports.Match = Match;

const pattern_1 = n => (_, d) => m => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

const pattern = pattern_1;
/**
 * @tsplus static Match/Aspects tag
 */

exports.pattern = pattern;
const matchTag = /*#__PURE__*/pattern_1("_tag");
/**
 * @tsplus static Match/Ops pattern
 */

exports.matchTag = matchTag;

const pattern_2 = n => (m, _, d) => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

const pattern_ = pattern_2;
/**
 * @tsplus static Match/Ops tag
 */

exports.pattern_ = pattern_;
const matchTag_ = /*#__PURE__*/pattern_2("_tag");
/**
 * @tsplus static Match/Aspects patternFor
 */

exports.matchTag_ = matchTag_;

const patternFor_1 = n => () => (_, d) => m => {
  return _[m[n]] ? _[m[n]](m, m) : d(m, m);
};

const patternFor = patternFor_1;
/**
 * @tsplus static Match/Ops tagFor
 */

exports.patternFor = patternFor;
const matchTagFor = /*#__PURE__*/patternFor_1("_tag");
/**
 * @tsplus static Match/Ops isAdtElement
 */

exports.matchTagFor = matchTagFor;

function isAdtElement_(tag, adt) {
  return adt["_tag"] === tag;
}
/**
 * @tsplus static Match/Aspects isAdtElement
 */


const isAdtElement = adt => tag => isAdtElement_(tag, adt);
/**
 * @tsplus static Match/Ops isGenericAdtElement
 */


exports.isAdtElement = isAdtElement;

function isGenericAdtElement(_t) {
  return tag => adt => adt[_t] === tag;
}
/**
 * @tsplus static Match/Ops onAdtElement
 */


function onAdtElement(tag, f) {
  return adt => {
    if (adt["_tag"] === tag) {
      return tsplus_module_1.some(f(adt));
    }

    return tsplus_module_1.none;
  };
}
/**
 * @tsplus static Match/Ops onGenericAdtElement
 */


function onGenericAdtElement(_t) {
  return (tag, f) => adt => {
    if (adt[_t] === tag) {
      return tsplus_module_1.some(f(adt));
    }

    return tsplus_module_1.none;
  };
}
//# sourceMappingURL=Match.js.map