import { HKT } from "@tsplus/stdlib/prelude/HKT";
/**
 * @tsplus type Maybe
 */
export type Maybe<A> = None | Some<A>;
export interface MaybeF extends HKT {
    readonly type: Maybe<this["A"]>;
}
export declare namespace Maybe {
    type HKT = MaybeF;
}
/**
 * @tsplus type Maybe.Ops
 */
export interface MaybeOps {
    $: MaybeAspects;
}
export declare const Maybe: MaybeOps;
/**
 * @tsplus type Maybe.Aspects
 */
export interface MaybeAspects {
}
/**
 * Definitions
 *
 * @tsplus type Maybe.None
 */
export interface None {
    readonly _tag: "None";
}
/**
 * @tsplus type Maybe.Some
 */
export interface Some<A> {
    readonly _tag: "Some";
    readonly value: A;
}
/**
 * @tsplus unify Maybe
 * @tsplus unify Maybe.Some
 * @tsplus unify Maybe.None
 */
export declare function unifyMaybe<X extends Maybe<any>>(self: X): Maybe<X extends Some<infer A> ? A : never>;
export type ArrayOfMaybies<Ts extends Maybe<any>[]> = {
    [k in keyof Ts]: Ts[k] extends Maybe<infer A> ? A : never;
}[number];
/**
 * Constructs `None`.
 * @tsplus static Maybe.Ops none
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare const none: Maybe<never>;
/**
 * Constructs `None`.
 * @tsplus static Maybe.Ops empty
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function empty<A = never>(): Maybe<A>;
/**
 * Constructs `Some<A>`.
 * @tsplus static Maybe.Ops some
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function some<A>(a: A): Maybe<A>;
/**
 * Returns `true` if the maybe is `None`, `false` otherwise.
 * @tsplus fluent Maybe isNone
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function isNone<A>(fa: Maybe<A>): fa is None;
/**
 * Returns `true` if the maybe is an instance of `Some`, `false` otherwise.
 * @tsplus fluent Maybe isSome
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function isSome<A>(fa: Maybe<A>): fa is Some<A>;
/**
 * @tsplus static Maybe.Ops isMaybe
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function isMaybe(u: unknown): u is Maybe<unknown>;
/**
 * @tsplus operator Maybe ==
 * @tsplus location "@tsplus/stdlib/data/Maybe/definition"
 */
export declare function equals<A, B>(a: Maybe<A>, b: Maybe<B>): boolean;
//# sourceMappingURL=definition.d.ts.map