"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Maybe = void 0;
exports.empty = empty;
exports.equals = equals;
exports.isMaybe = isMaybe;
exports.isNone = isNone;
exports.isSome = isSome;
exports.none = void 0;
exports.some = some;
exports.unifyMaybe = unifyMaybe;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Equals"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Maybe = {
  $: {}
};
/**
 * @tsplus unify Maybe
 * @tsplus unify Maybe.Some
 * @tsplus unify Maybe.None
 */

exports.Maybe = Maybe;

function unifyMaybe(self) {
  return self;
}
/**
 * Constructs `None`.
 *
 * @tsplus static Maybe.Ops none
 */


const none_1 = {
  _tag: "None"
};
const none = none_1;
/**
 * Constructs `None`.
 *
 * @tsplus static Maybe.Ops empty
 */

exports.none = none;

function empty() {
  return none_1;
}
/**
 * Constructs `Some<A>`.
 *
 * @tsplus static Maybe.Ops some
 */


function some(a) {
  return {
    _tag: "Some",
    value: a
  };
}
/**
 * Returns `true` if the maybe is `None`, `false` otherwise.
 *
 * @tsplus fluent Maybe isNone
 */


function isNone(fa) {
  return fa._tag === "None";
}
/**
 * Returns `true` if the maybe is an instance of `Some`, `false` otherwise.
 *
 * @tsplus fluent Maybe isSome
 */


function isSome(fa) {
  return fa._tag === "Some";
}
/**
 * @tsplus static Maybe.Ops isMaybe
 */


function isMaybe(u) {
  return typeof u === "object" && u != null && "_tag" in u && (u["_tag"] === "Some" || u["_tag"] === "None");
}
/**
 * @tsplus operator Maybe ==
 */


function equals(a, b) {
  return tsplus_module_1.equals(a, b);
}
//# sourceMappingURL=definition.js.map