import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * Takes a default value, a function, and an `Maybe` value, if the `Maybe`
 * value is `None` the default value is returned, otherwise the function is
 * applied to the value inside the `Some` and the result is returned.
 * @tsplus static Maybe.Aspects fold
 * @tsplus pipeable Maybe fold
 * @tsplus location "@tsplus/stdlib/data/Maybe/fold"
 */
export declare function fold<A, B, C>(onNone: LazyArg<B>, onSome: (a: A) => C): (self: Maybe<A>) => B | C;
//# sourceMappingURL=fold.d.ts.map