"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAssociative = getAssociative;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Associative/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Associative for `Maybe<A>`
 *
 * @tsplus static Maybe.Ops getAssociative
 */
function getAssociative(S) {
  switch (S) {
    case "First":
      {
        return tsplus_module_2.Associative((x, y) => tsplus_module_1.isNone(x) ? y : x);
      }

    case "Last":
      {
        return tsplus_module_2.Associative((x, y) => tsplus_module_1.isNone(y) ? x : y);
      }
  }

  return tsplus_module_2.Associative((x, y) => tsplus_module_1.isSome(x) && tsplus_module_1.isSome(y) ? tsplus_module_1.some(S.combine(x.value, y.value)) : tsplus_module_1.none);
}
//# sourceMappingURL=getAssociative.js.map