import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { LazyArg } from "@tsplus/stdlib/data/Function";
/**
 * Extracts the value out of the structure, if it exists. Otherwise returns the
 * given default value.
 * @tsplus fluent Maybe getOrElse
 * @tsplus location "@tsplus/stdlib/data/Maybe/getOrElse"
 */
export declare function getOrElse_<A, B>(self: Maybe<A>, onNone: LazyArg<B>): A | B;
/**
 * @tsplus static Maybe.Aspects getOrElse
 * @tsplus pipeable Maybe getOrElse
 * @tsplus location "@tsplus/stdlib/data/Maybe/getOrElse"
 */
export declare const getOrElse: <B>(onNone: import("../Function").LazyArg<B>) => <A>(self: import("./definition").Maybe<A>) => A | B;
//# sourceMappingURL=getOrElse.d.ts.map