import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import { Refinement } from "@tsplus/stdlib/data/Function";
/**
 * Returns a `Refinement` (i.e. a custom type guard) from a `Maybe` returning
 * function.
 *
 * This function ensures that a custom type guard definition is type-safe.
 * @tsplus static Maybe.Ops getRefinement
 * @tsplus location "@tsplus/stdlib/data/Maybe/getRefinement"
 */
export declare function getRefinement<A, B extends A>(getMaybe: (a: A) => Maybe<B>): Refinement<A, B>;
//# sourceMappingURL=getRefinement.d.ts.map