import type { ArrayInt } from "@tsplus/stdlib/io/Random/Distribution/_internal/ArrayInt";
import type { Distribution } from "@tsplus/stdlib/io/Random/Distribution/definition";
import type { RandomGenerator } from "@tsplus/stdlib/io/Random/Generator/RandomGenerator";
/**
 * Uniformly generate random ArrayInt values between `from` (inclusive) and `to`
 * (inclusive).
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @tsplus static Random.Distribution.Ops uniformArrayIntDistribution
 * @tsplus location "@tsplus/stdlib/io/Random/Distribution/operations/uniformArrayIntDistribution"
 */
export declare function uniformArrayIntDistribution(from: ArrayInt, to: ArrayInt): Distribution<ArrayInt>;
/**
 * Uniformly generate random ArrayInt values between `from` (inclusive) and `to`
 * (inclusive).
 *
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @param rng - Instance of RandomGenerator to extract random values from
 */
export declare function uniformArrayIntDistribution(from: ArrayInt, to: ArrayInt, rng: RandomGenerator): ArrayInt;
//# sourceMappingURL=uniformArrayIntDistribution.d.ts.map