import type { Distribution } from "@tsplus/stdlib/io/Random/Distribution/definition";
import type { RandomGenerator } from "@tsplus/stdlib/io/Random/Generator/RandomGenerator";
/**
 * Uniformly generate random bigint values between `from` (inclusive) and `to`
 * (inclusive).
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @tsplus static Random.Distribution.Ops uniformBigIntDistribution
 * @tsplus location "@tsplus/stdlib/io/Random/Distribution/operations/uniformBigIntDistribution"
 */
export declare function uniformBigIntDistribution(from: bigint, to: bigint): Distribution<bigint>;
/**
 * Uniformly generate random bigint values between `from` (inclusive) and `to`
 * (inclusive).
 *
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @param rng - Instance of RandomGenerator to extract random values from
 */
export declare function uniformBigIntDistribution(from: bigint, to: bigint, rng: RandomGenerator): bigint;
//# sourceMappingURL=uniformBigIntDistribution.d.ts.map