import type { Distribution } from "@tsplus/stdlib/io/Random/Distribution/definition";
import type { RandomGenerator } from "@tsplus/stdlib/io/Random/Generator/RandomGenerator";
/**
 * Uniformly generate random integer values between `from` (inclusive) and `to`
 * (inclusive).
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @tsplus static Random.Distribution.Ops uniformIntDistribution
 * @tsplus location "@tsplus/stdlib/io/Random/Distribution/operations/uniformIntDistribution"
 */
export declare function uniformIntDistribution(from: number, to: number): Distribution<number>;
/**
 * Uniformly generate random integer values between `from` (inclusive) and `to`
 * (inclusive).
 *
 * @param from - Lower bound of the range (inclusive)
 * @param to - Upper bound of the range (inclusive)
 * @param rng - Instance of RandomGenerator to extract random values from
 */
export declare function uniformIntDistribution(from: number, to: number, rng: RandomGenerator): number;
//# sourceMappingURL=uniformIntDistribution.d.ts.map