"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uniformIntDistribution = uniformIntDistribution;

var _ArrayInt = /*#__PURE__*/require("@tsplus/stdlib/io/Random/Distribution/_internal/ArrayInt");

var _uniformArrayIntDistributionInternal = /*#__PURE__*/require("@tsplus/stdlib/io/Random/Distribution/_internal/uniformArrayIntDistributionInternal");

var _uniformIntDistributionInternal = /*#__PURE__*/require("@tsplus/stdlib/io/Random/Distribution/_internal/uniformIntDistributionInternal");

const sharedA = {
  sign: 1,
  data: [0, 0]
};
const sharedB = {
  sign: 1,
  data: [0, 0]
};
const sharedC = {
  sign: 1,
  data: [0, 0]
};
const sharedData = [0, 0];

function uniformLargeIntInternal(from, to, rangeSize, rng) {
  const rangeSizeArrayIntValue = rangeSize <= Number.MAX_SAFE_INTEGER ? (0, _ArrayInt.fromNumberToArrayInt64)(sharedC, rangeSize) // no possible overflow given rangeSize is in a safe range
  : (0, _ArrayInt.substractArrayInt64)(sharedC, (0, _ArrayInt.fromNumberToArrayInt64)(sharedA, to), (0, _ArrayInt.fromNumberToArrayInt64)(sharedB, from)); // rangeSize might be incorrect, we compute a safer range
  // Adding 1 to the range

  if (rangeSizeArrayIntValue.data[1] === 0xffffffff) {
    // rangeSizeArrayIntValue.length === 2 by construct
    // rangeSize >= 0x00000001_00000000 and rangeSize <= 0x003fffff_fffffffe
    // with Number.MAX_SAFE_INTEGER - Number.MIN_SAFE_INTEGER = 0x003fffff_fffffffe
    rangeSizeArrayIntValue.data[0] += 1;
    rangeSizeArrayIntValue.data[1] = 0;
  } else {
    rangeSizeArrayIntValue.data[1] += 1;
  }

  (0, _uniformArrayIntDistributionInternal.uniformArrayIntDistributionInternal)(sharedData, rangeSizeArrayIntValue.data, rng);
  return sharedData[0] * 0x100000000 + sharedData[1] + from;
}

function uniformIntInternal(from, to, rng) {
  const rangeSize = to - from;

  if (rangeSize <= 0xffffffff) {
    // Calling uniformIntDistributionInternal can be considered safe
    // up-to 2**32 values. Above this range it may miss values.
    let g = (0, _uniformIntDistributionInternal.uniformIntDistributionInternal)(rangeSize + 1, rng);
    g += from;
    return g;
  }

  return uniformLargeIntInternal(from, to, rangeSize, rng);
}

function uniformIntDistribution(from, to, rng) {
  if (rng != null) {
    return uniformIntInternal(from, to, rng);
  }

  return rng => uniformIntInternal(from, to, rng);
}
//# sourceMappingURL=uniformIntDistribution.js.map