import { HKT } from "@tsplus/stdlib/prelude/HKT";
import type { CovariantComposition } from "@tsplus/stdlib/prelude/Covariant";
/**
 * @tsplus type Contravariant
 */
export interface Contravariant<F extends HKT> extends HKT.Typeclass<F> {
    readonly Law: {
        readonly Contravariant: "Contravariant";
    };
    readonly contramap: <A, B>(f: (b: B) => A) => <R, E>(fa: HKT.Kind<F, R, E, A>) => HKT.Kind<F, R, E, B>;
}
/**
 * @tsplus type Contravariant/Ops
 */
export interface ContravariantOps {
}
export declare const Contravariant: ContravariantOps;
/**
 * @tsplus static Contravariant/Ops getComposition
 * @tsplus location "@tsplus/stdlib/prelude/Contravariant"
 */
export declare function getContravariantComposition<F extends HKT, G extends HKT>(F: Contravariant<F>, G: Contravariant<G>): CovariantComposition<F, G>;
//# sourceMappingURL=Contravariant.d.ts.map