import { HKT } from "@tsplus/stdlib/prelude/HKT";
/**
 * @tsplus type Covariant
 */
export interface Covariant<F extends HKT> extends HKT.Typeclass<F> {
    readonly Law: {
        readonly Covariant: "Covariant";
    };
    readonly map: <A, B>(f: (a: A) => B) => <R, E>(fa: HKT.Kind<F, R, E, A>) => HKT.Kind<F, R, E, B>;
}
/**
 * @tsplus type Covariant/Ops
 */
export interface CovariantOps {
}
export declare const Covariant: CovariantOps;
export interface CovariantComposition<F extends HKT, G extends HKT> {
    readonly Law: {
        readonly Covariant: "Covariant";
    };
    readonly map: <A, B>(f: (a: A) => B) => <FR, FE, GR, GE>(fa: HKT.Kind<F, FR, FE, HKT.Kind<G, GR, GE, A>>) => HKT.Kind<F, FR, FE, HKT.Kind<G, GR, GE, B>>;
}
/**
 * @tsplus static Covariant/Ops getComposition
 * @tsplus location "@tsplus/stdlib/prelude/Covariant"
 */
export declare function getCovariantComposition<F extends HKT, G extends HKT>(F: Covariant<F>, G: Covariant<G>): CovariantComposition<F, G>;
//# sourceMappingURL=Covariant.d.ts.map