"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tupleF = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/DSL/apF"));

var _curried = /*#__PURE__*/require("@tsplus/stdlib/prelude/DSL/_internal/curried");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const tupleConstructors = {};

function getTupleConstructor(len) {
  // eslint-disable-next-line no-prototype-builtins
  if (!tupleConstructors.hasOwnProperty(len)) {
    tupleConstructors[len] = (0, _curried.curried)((...t) => t, len - 1, []);
  }

  return tupleConstructors[len];
}
/**
 * @tsplus static DSL tupleF
 */


const tupleF = F => (...args) => {
  const ap = tsplus_module_1.apF(F);
  const len = args.length;
  const f = getTupleConstructor(len);
  let fas = F.map(f)(args[0]);

  for (let i = 1; i < len; i++) {
    fas = ap(args[i])(fas);
  }

  return fas;
};

exports.tupleF = tupleF;
//# sourceMappingURL=tupleF.js.map