import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
/**
 * Constructs an `Equivalence<B>` given an `Equivalence<A>` and a function `f`
 * to transform a `B` value into an `A` value. The instance will convert each
 * `B` value into an `A` and the compare the `A` values for equality.
 * @tsplus fluent Equivalence contramap
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/contramap"
 */
export declare function contramap_<A, B>(self: Equivalence<A>, f: (b: B) => A): Equivalence<B>;
/**
 * Constructs an `Equivalence<B>` given an `Equivalence<A>` and a function `f`
 * to transform a `B` value into an `A` value. The instance will convert each
 * `B` value into an `A` and the compare the `A` values for equality.
 * @tsplus static Equivalence/Aspects contramap
 * @tsplus pipeable Equivalence contramap
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/contramap"
 */
export declare const contramap: <A, B>(f: (b: B) => A) => (self: import("./definition").Equivalence<A>) => import("./definition").Equivalence<B>;
//# sourceMappingURL=contramap.d.ts.map