import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
import { LazyArg } from "@tsplus/stdlib/data/Function";
import { Either } from "@tsplus/stdlib/data/Either/definition";
/**
 * Constructs an `Equivalence<Either<A, B>>` given an `Equivalence<A>` and an
 * `Equivalence<B>`. The instance will compare the `Either<A, B>` values and if
 * both are `Right` or `Left` compare them for equality.
 * @tsplus fluent Equivalence orElseEither
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/orElseEither"
 */
export declare function orElseEither_<A, B>(self: Equivalence<A>, that: LazyArg<Equivalence<B>>): Equivalence<Either<A, B>>;
/**
 * Constructs an `Equivalence<Either<A, B>>` given an `Equivalence<A>` and an
 * `Equivalence<B>`. The instance will compare the `Either<A, B>` values and if
 * both are `Right` or `Left` compare them for equality.
 * @tsplus static Equivalence/Aspects orElseEither
 * @tsplus pipeable Equivalence orElseEither
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/orElseEither"
 */
export declare const orElseEither: <B>(that: import("../../data/Function").LazyArg<import("./definition").Equivalence<B>>) => <A>(self: import("./definition").Equivalence<A>) => import("./definition").Equivalence<import("../../data/Either").Either<A, B>>;
//# sourceMappingURL=orElseEither.d.ts.map