"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.orElseEither = void 0;
exports.orElseEither_ = orElseEither_;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Equivalence/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs an `Equivalence<Either<A, B>>` given an `Equivalence<A>` and an
 * `Equivalence<B>`. The instance will compare the `Either<A, B>` values and if
 * both are `Right` or `Left` compare them for equality.
 *
 * @tsplus fluent Equivalence orElseEither
 */
function orElseEither_(self, that) {
  return tsplus_module_1.Equivalence((ex, ey) => ex._tag === "Left" && ey._tag === "Left" ? self.equals(ex.left, ey.left) : ex._tag === "Right" && ey._tag === "Right" ? that().equals(ex.right, ey.right) : false);
}
/**
 * Constructs an `Equivalence<Either<A, B>>` given an `Equivalence<A>` and an
 * `Equivalence<B>`. The instance will compare the `Either<A, B>` values and if
 * both are `Right` or `Left` compare them for equality.
 *
 * @tsplus static Equivalence/Aspects orElseEither
 */


const orElseEither = that => self => orElseEither_(self, that);

exports.orElseEither = orElseEither;
//# sourceMappingURL=orElseEither.js.map