import { Equivalence } from "@tsplus/stdlib/prelude/Equivalence/definition";
/**
 * Constructs an `Equivalence<Tuple<[A, B]>>` given an `Equivalence<A>` and
 * `Equivalence<B>` by comparing the `A` values for equality and then comparing
 * the `B` values for equality.
 * @tsplus fluent Equivalence zip
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/zip"
 */
export declare function zip_<A, B>(self: Equivalence<A>, that: Equivalence<B>): Equivalence<readonly [A, B]>;
/**
 * Constructs an `Equivalence<Tuple<[A, B]>>` given an `Equivalence<A>` and
 * `Equivalence<B>` by comparing the `A` values for equality and then comparing
 * the `B` values for equality.
 * @tsplus static Equivalence/Aspects zip
 * @tsplus pipeable Equivalence zip
 * @tsplus location "@tsplus/stdlib/prelude/Equivalence/zip"
 */
export declare const zip: <B>(that: import("./definition").Equivalence<B>) => <A>(self: import("./definition").Equivalence<A>) => import("./definition").Equivalence<readonly [A, B]>;
//# sourceMappingURL=zip.d.ts.map