"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zip = void 0;
exports.zip_ = zip_;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Equivalence/definition"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Constructs an `Equivalence<Tuple<[A, B]>>` given an `Equivalence<A>` and
 * `Equivalence<B>` by comparing the `A` values for equality and then comparing
 * the `B` values for equality.
 *
 * @tsplus fluent Equivalence zip
 */
function zip_(self, that) {
  return tsplus_module_1.Equivalence(([x0, x1], [y0, y1]) => self.equals(x0, y0) && that.equals(x1, y1));
}
/**
 * Constructs an `Equivalence<Tuple<[A, B]>>` given an `Equivalence<A>` and
 * `Equivalence<B>` by comparing the `A` values for equality and then comparing
 * the `B` values for equality.
 *
 * @tsplus static Equivalence/Aspects zip
 */


const zip = that => self => zip_(self, that);

exports.zip = zip;
//# sourceMappingURL=zip.js.map