import { AssociativeIdentity } from "@tsplus/stdlib/prelude/AssociativeIdentity/definition";
import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
/**
 * Returns an `AssociativeIdentity` such that:
 * - `combine(ord2)(ord1)` will order first by `ord1`, and then by `ord2`
 * - `identity` is an `Ord` that always considers compared elements equal
 * @tsplus static Ord/Ops getAssociativeIdentity
 * @tsplus location "@tsplus/stdlib/prelude/Ord/getAssociativeIdentity"
 */
export declare function getAssociativeIdentity<A = never>(): AssociativeIdentity<Ord<A>>;
//# sourceMappingURL=getAssociativeIdentity.d.ts.map