import { Ord } from "@tsplus/stdlib/prelude/Ord/definition";
export type NonEmptyArrayOrd = Array<Ord<any>> & {
    readonly 0: Ord<any>;
};
export type TupleOrd<T extends NonEmptyArrayOrd> = Readonly<{
    [K in keyof T]: [T[K]] extends [Ord<infer A>] ? A : never;
}>;
/**
 * Derives an Ord instance for a tuple
 * @tsplus static Ord/Ops tuple
 * @tsplus location "@tsplus/stdlib/prelude/Ord/tuple"
 */
export declare function tuple<T extends NonEmptyArrayOrd>(...ords: T & {
    readonly 0: Ord<any>;
}): Ord<TupleOrd<T>>;
//# sourceMappingURL=tuple.d.ts.map