import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { Covariant } from "@tsplus/stdlib/prelude/Covariant";
import type { Recursive } from "@tsplus/stdlib/prelude/Recursive/definition";
/**
 * Use a `Covariant<F>` and a `Recursive.Fn` function to perform a *depth-first* reduction
 * of the `Recursive<F>` structure.  The supplied function will receive the current term
 * with all of its recursive elements replaced by the computed value of its children,
 * i.e. a _catamorphism_
 * @tsplus static Recursive/Aspects fold
 * @tsplus pipeable Recursive fold
 * @tsplus location "@tsplus/stdlib/prelude/Recursive/fold"
 */
export declare function fold<F extends HKT, Z, E = unknown, R = unknown>(F: Covariant<F>, f: Recursive.Fn<F, Z, E, R>): (self: Recursive<F, E, R>) => Z;
//# sourceMappingURL=fold.d.ts.map