import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { Covariant } from "@tsplus/stdlib/prelude/Covariant";
import { Annotated } from "@tsplus/stdlib/prelude/Recursive/Annotated";
import type { Recursive } from "@tsplus/stdlib/prelude/Recursive/definition";
/**
 * Use a `Covariant<F>` and a `Annotated.Fn` function to perform a *depth-first* reduction
 * of the `Recursive<F>` structure. The supplied function will receive the current term
 * with all of its recursive elements replaced with *both* the computed value of the
 * sub-structure *and* the value of the computation for all of _its_ children.
 * i.e. _histomorphism_
 * @tsplus static Recursive/Aspects foldAnnotated
 * @tsplus pipeable Recursive foldAnnotated
 * @tsplus location "@tsplus/stdlib/prelude/Recursive/foldAnnotated"
 */
export declare function foldAnnotated<F extends HKT, Z>(F: Covariant<F>, f: Annotated.Fn<F, Z>): (self: Recursive<F>) => Z;
//# sourceMappingURL=foldAnnotated.d.ts.map