"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldAnnotated = foldAnnotated;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/Recursive/Annotated"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Use a `Covariant<F>` and a `Annotated.Fn` function to perform a *depth-first* reduction
 * of the `Recursive<F>` structure. The supplied function will receive the current term
 * with all of its recursive elements replaced with *both* the computed value of the
 * sub-structure *and* the value of the computation for all of _its_ children.
 * i.e. _histomorphism_
 *
 * @tsplus static Recursive/Aspects foldAnnotated
 * @tsplus pipeable Recursive foldAnnotated
 */
function foldAnnotated(F, f) {
  return self => foldAnnotated_(self, F, f);
}

function foldAnnotated_(self, F, f) {
  function annotate(recursive) {
    const calc = F.map(annotate)(recursive.caseValue);
    return tsplus_module_1.makeAnnotated(calc, f(calc));
  }

  return annotate(self).annotations;
}
//# sourceMappingURL=foldAnnotated.js.map