import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { Foldable } from "@tsplus/stdlib/prelude/Foldable";
import type { Recursive } from "@tsplus/stdlib/prelude/Recursive/definition";
/**
 * Use a `Folder<F>`, an initial value `Z` and a `Recursive.FoldDownFn<F, Z>`
 * function to perform a breadth-first reduction of a `Recursive<F>` to a summary value `Z`.
 * @tsplus static Recursive/Aspects foldDown
 * @tsplus pipeable Recursive foldDown
 * @tsplus location "@tsplus/stdlib/prelude/Recursive/foldDown"
 */
export declare function foldDown<F extends HKT, Z>(F: Foldable<F>, z: Z, f: Recursive.FoldDownFn<F, Z>): (self: Recursive<F>) => Z;
//# sourceMappingURL=foldDown.d.ts.map