"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.foldDown = void 0;
const foldDown = foldDown_1;
/**
 * Use a `Folder<F>`, an initial value `Z` and a `Recursive.FoldDownFn<F, Z>`
 * function to perform a breadth-first reduction of a `Recursive<F>` to a summary value `Z`.
 *
 * @tsplus static Recursive/Aspects foldDown
 * @tsplus pipeable Recursive foldDown
 */

exports.foldDown = foldDown;

function foldDown_1(F, z, f) {
  return self => {
    const next = f(z, self);

    const iter = (z0, r) => foldDown_1(F, z0, f)(r);

    return F.reduce(next, iter)(self.caseValue);
  };
}
//# sourceMappingURL=foldDown.js.map