import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { ForEach } from "@tsplus/stdlib/prelude/ForEach";
import { Covariant } from "@tsplus/stdlib/prelude/Covariant";
import { IdentityBoth } from "@tsplus/stdlib/prelude/IdentityBoth";
import { Monad } from "@tsplus/stdlib/prelude/Monad";
import type { Recursive } from "@tsplus/stdlib/prelude/Recursive/definition";
/**
 * Monadic fold over a datstructure `R` with an algebra `(r: Recursive<Z>) => M<Z>`
 * eventually returning an `M<Z>`
 * @tsplus static Recursive/Aspects foldM
 * @tsplus pipeable Recursive foldM
 * @tsplus location "@tsplus/stdlib/prelude/Recursive/foldM"
 */
export declare function foldM<F extends HKT, M extends HKT, Z, E = unknown, R = unknown>(F: ForEach<F> & Covariant<F>, M: IdentityBoth<M> & Monad<M>, f: Recursive.FnM<F, M, Z, E, R>): (self: Recursive<F, E, R>) => import("../HKT").HKT.Kind<M, R, E, Z>;
//# sourceMappingURL=foldM.d.ts.map