import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { Either } from "@tsplus/stdlib/data/Either/definition";
import { Covariant } from "@tsplus/stdlib/prelude/Covariant";
import { Any } from "@tsplus/stdlib/prelude/Any";
import { Monad } from "@tsplus/stdlib/prelude/Monad";
import { Applicative } from "@tsplus/stdlib/prelude/Applicative";
/**
 * @tsplus type Select
 */
export interface Select<F extends HKT> extends HKT.Typeclass<F> {
    readonly select: <R2, E2, A, B>(fab: HKT.Kind<F, R2, E2, (a: A) => B>) => <R, E, B2>(fa: HKT.Kind<F, R, E, Either<A, B2>>) => HKT.Kind<F, R2 & R, E2 | E, B | B2>;
}
/**
 * @tsplus type Selective
 */
export type Selective<F extends HKT> = Select<F> & Covariant<F> & Any<F>;
/**
 * @tsplus type SelectiveMonad
 */
export type SelectiveMonad<F extends HKT> = Selective<F> & Monad<F>;
/**
 * @tsplus type Select/Ops
 */
export interface SelectOps {
}
export declare const Select: SelectOps;
/**
 * @tsplus static Select/Ops monad
 * @tsplus location "@tsplus/stdlib/prelude/Selective"
 */
export declare function monadF<F extends HKT>(F: Monad<F>): SelectiveMonad<F>;
/**
 * @tsplus static Select/Ops applicative
 * @tsplus location "@tsplus/stdlib/prelude/Selective"
 */
export declare function applicativeF<F extends HKT>(F: Applicative<F>): Selective<F>;
/**
 * @tsplus static Select/Ops branchF
 * @tsplus location "@tsplus/stdlib/prelude/Selective"
 */
export declare function branchF<F extends HKT>(F: Selective<F>): <R2, E2, A, D1, R3, E3, B, D2>(left: import("./HKT").HKT.Kind<F, R2, E2, (a: A) => D1>, right: import("./HKT").HKT.Kind<F, R3, E3, (a: B) => D2>) => <R, E>(fe: import("./HKT").HKT.Kind<F, R, E, import("../data/Either").Either<A, B>>) => import("./HKT").HKT.Kind<F, R & R2 & R3, E2 | E3 | E, D1 | D2>;
/**
 * @tsplus static Select/Ops ifF
 * @tsplus location "@tsplus/stdlib/prelude/Selective"
 */
export declare function ifF<F extends HKT>(F: Selective<F>): <R2, E2, A, R3, E3, B>(then_: import("./HKT").HKT.Kind<F, R2, E2, A>, else_: import("./HKT").HKT.Kind<F, R3, E3, B>) => <S, R, E>(if_: import("./HKT").HKT.Kind<F, R, E, boolean>) => import("./HKT").HKT.Kind<F, R & R2 & R3, E2 | E3 | E, A | B>;
/**
 * @tsplus static Select/Ops whenF
 * @tsplus location "@tsplus/stdlib/prelude/Selective"
 */
export declare function whenF<F extends HKT>(F: Selective<F>): <R2, E2>(act: import("./HKT").HKT.Kind<F, R2, E2, void>) => <R, E>(if_: import("./HKT").HKT.Kind<F, R, E, boolean>) => import("./HKT").HKT.Kind<F, R & R2, E2 | E, void>;
//# sourceMappingURL=Selective.d.ts.map