"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;
exports.applicativeF = applicativeF;
exports.ifF = exports.branchF = void 0;
exports.monadF = monadF;
exports.whenF = whenF;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/DSL/succeedF"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/DSL/flatMapF"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/prelude/HKT"));

var tsplus_module_4 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/fold"));

var tsplus_module_5 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

var tsplus_module_6 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/definition"));

var tsplus_module_7 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Either/map"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const branchF = branchF_1;
exports.branchF = branchF;
const ifF = ifF_1;
exports.ifF = ifF;
const Select = {};
/**
 * @tsplus static Select/Ops monad
 */

exports.Select = Select;

function monadF(F) {
  const succeedF = tsplus_module_1.succeedF(F);
  const flatMapF_ = tsplus_module_2.flatMapF_(F);
  return { ...F,
    select: fab => fa => flatMapF_(fa, either => tsplus_module_4.fold(a => F.map(g => g(a))(fab), b => succeedF(b))(either))
  };
}
/**
 * @tsplus static Select/Ops applicative
 */


function applicativeF(F) {
  return { ...F,
    select: fab => fa => {
      const both = F.both(fab)(fa);
      return F.map(([ea, f]) => tsplus_module_4.fold(f, tsplus_module_5.identity)(ea))(both);
    }
  };
}
/**
 * @tsplus static Select/Ops branchF
 */


function branchF_1(F) {
  return (left, right) => fe => {
    const mapped = F.map(either => tsplus_module_7.map(tsplus_module_6.left)(either))(fe);
    const selected = F.select(F.map(fac => a => tsplus_module_6.right(fac(a)))(left))(mapped);
    return F.select(right)(selected);
  };
}
/**
 * @tsplus static Select/Ops ifF
 */


function ifF_1(F) {
  return (then_, else_) => if_ => {
    const mapped = F.map(b => b ? tsplus_module_6.left(undefined) : tsplus_module_6.right(undefined))(if_);
    return branchF_1(F)(F.map(a => () => a)(then_), F.map(b => () => b)(else_))(mapped);
  };
}
/**
 * @tsplus static Select/Ops whenF
 */


function whenF(F) {
  const succeedF = tsplus_module_1.succeedF(F);
  return act => if_ => ifF_1(F)(act, succeedF(undefined))(if_);
}
//# sourceMappingURL=Selective.js.map