import { HKT } from "@tsplus/stdlib/prelude/HKT";
import { Applicative } from "@tsplus/stdlib/prelude/Applicative";
import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
/**
 * @tsplus type Witherable
 */
export interface Witherable<F extends HKT> extends HKT.Typeclass<F> {
    readonly Law: {
        readonly Witherable: "Witherable";
    };
    readonly compactF: Wither<F>;
}
/**
 * @tsplus type Wither
 */
export interface Wither<F extends HKT> {
    readonly Law: {
        readonly Wither: "Wither";
    };
    <G extends HKT>(F: Applicative<G>): <GR, GE, A, B>(f: (a: A) => HKT.Kind<G, GR, GE, Maybe<B>>) => <FR, FE>(ta: HKT.Kind<F, FR, FE, A>) => HKT.Kind<G, GR, GE, HKT.Kind<F, FR, FE, B>>;
}
/**
 * @tsplus type Witherable/Ops
 */
export interface WitherableOps {
}
export declare const Witherable: WitherableOps;
/**
 * @tsplus static Witherable/Ops implementCompactF
 * @tsplus location "@tsplus/stdlib/prelude/Witherable"
 */
export declare function implementCompactF<F extends HKT>(): (i: <FR, FE, A, B, G extends HKT>(_: {
    A: A;
    B: B;
    G: G;
    FR: FR;
    FE: FE;
}) => (G: Applicative<G>) => (f: (a: A) => HKT.Kind<G, FR, FE, Maybe<B>>) => (ta: HKT.Kind<F, FR, FE, A>) => HKT.Kind<G, FR, FE, HKT.Kind<F, FR, FE, B>>) => Wither<F>;
//# sourceMappingURL=Witherable.d.ts.map