import { Maybe } from "@tsplus/stdlib/data/Maybe/definition";
import type { Tag } from "@tsplus/stdlib/service/Tag";
/**
 * @tsplus type Env.Ops
 */
export interface EnvOps {
    readonly sym: unique symbol;
    readonly empty: Env<never>;
    <S, H extends S>(tag: Tag<S>, service: H): Env<S>;
    new (unsafeMap: Env<unknown>["unsafeMap"]): Env<never>;
}
export declare const Env: EnvOps;
export type Tags<R> = R extends infer S ? Tag<S> : never;
/**
 * @tsplus type Env
 */
export interface Env<R> {
    readonly [Env.sym]: (_: never) => R;
    readonly unsafeMap: Map<Tag<unknown>, unknown>;
    add<R, S, H extends S = S>(this: Env<R>, tag: Tag<S>, service: H): Env<R | S>;
    get<R, T extends Tags<R>>(this: Env<R>, tag: T): T extends Tag<infer S> ? S : never;
    unsafeGet<R, S>(this: Env<R>, tag: Tag<S>): S;
    getMaybe<R, S>(this: Env<R>, tag: Tag<S>): Maybe<S>;
    merge<R, R1>(this: Env<R>, that: Env<R1>): Env<R | R1>;
    prune<R, S extends Tags<R>[]>(this: Env<R>, ...tags: S): Env<{
        [k in keyof S]: Tag.TagType<S[k]>;
    }[number]>;
}
//# sourceMappingURL=Env.d.ts.map