"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Env = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/exceptions"));

var tsplus_module_2 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Maybe/definition"));

var tsplus_module_3 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/data/Function"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function methodAdd(tag, service) {
  const map = new Map(this.unsafeMap); // @ts-expect-error

  map.set(tag, service);
  return new Env(map);
}

function methodGet(tag) {
  // @ts-expect-error
  if (!this.unsafeMap.has(tag)) {
    throw new tsplus_module_1.NoSuchElement();
  } // @ts-expect-error


  return this.unsafeMap.get(tag);
}

function methodGetMaybe(tag) {
  // @ts-expect-error
  return this.unsafeMap.has(tag) ? tsplus_module_2.some(this.unsafeMap.get(tag)) : tsplus_module_2.none;
}

function methodMerge(that) {
  const map = new Map(this.unsafeMap);

  for (const [tag, s] of that.unsafeMap) {
    map.set(tag, s);
  }

  return new Env(map);
}

function pruneMethod(...tags) {
  const tagSet = new Set(tags);
  const newEnv = new Map();

  for (const [tag, s] of this.unsafeMap.entries()) {
    // @ts-expect-error
    if (tagSet.has(tag)) {
      newEnv.set(tag, s);
    }
  }

  return new Env(newEnv);
}

const sym = /*#__PURE__*/Symbol("@tsplus/stdlib/Env/Env");
const Env = /*#__PURE__*/Object.assign(function self(a, b) {
  if (this != null && this.constructor === self) {
    return createEnv(a);
  }

  return Env.empty.add(a, b);
}, {
  sym,
  empty: /*#__PURE__*/createEnv( /*#__PURE__*/new Map())
});
exports.Env = Env;

function createEnv(unsafeMap) {
  return {
    [sym]: tsplus_module_3.identity,
    add: methodAdd,
    get: methodGet,
    unsafeGet: methodGet,
    getMaybe: methodGetMaybe,
    merge: methodMerge,
    prune: pruneMethod,
    unsafeMap
  };
}
//# sourceMappingURL=Env.js.map