import { Equals } from "@tsplus/stdlib/structure/Equals";
import { Service } from "@tsplus/stdlib/service/Service";
/**
 * @tsplus type Tag.Ops
 */
export interface TagOps {
    readonly sym: unique symbol;
    readonly is: (u: unknown) => u is Tag<unknown>;
    <S>(): Tag<S>;
}
export declare const Tag: TagOps;
/**
 * @tsplus type Tag
 */
export interface Tag<in out S> extends Equals {
    readonly [Tag.sym]: (_: S) => S;
    toEnv(value: S): Service.Env<S>;
}
export declare namespace Tag {
    type TagType<T extends Tag<any>> = T extends Tag<infer A> ? A : never;
}
//# sourceMappingURL=Tag.d.ts.map