import { Hash } from "@tsplus/stdlib/structure/Hash";
/**
 * @tsplus type Equals.Ops
 */
export interface EqualsOps {
    readonly sym: unique symbol;
}
export declare const Equals: EqualsOps;
/**
 * @tsplus type Equals
 */
export interface Equals extends Hash {
    [Equals.sym](this: this, other: unknown): boolean;
}
/**
 * @tsplus static Equals.Ops isEquals
 * @tsplus location "@tsplus/stdlib/structure/Equals"
 */
export declare function isEquals(u: unknown): u is Equals;
/**
 * @tsplus static Equals.Ops sameValueZeroEqual
 * @tsplus location "@tsplus/stdlib/structure/Equals"
 */
export declare function sameValueZeroEqual(a: any, b: any): boolean;
/**
 * @tsplus static Equals.Ops equals
 * @tsplus fluent Equals equals
 * @tsplus operator Equals ==
 * @tsplus location "@tsplus/stdlib/structure/Equals"
 */
export declare function equals<A>(a: A, b: A): boolean;
export declare function equals<A, B>(a: A, b: B): boolean;
//# sourceMappingURL=Equals.d.ts.map