"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sameValueZeroEqual = exports.isEquals = exports.equals = exports.Equals = void 0;

var tsplus_module_1 = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@tsplus/stdlib/structure/Hash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const isEquals = isEquals_1;
exports.isEquals = isEquals;
const sameValueZeroEqual = sameValueZeroEqual_1;
exports.sameValueZeroEqual = sameValueZeroEqual;
const equals = equals_1;
exports.equals = equals;
const Equals = {
  sym: /*#__PURE__*/Symbol.for("tsplus/Equals")
};
/**
 * @tsplus static Equals.Ops isEquals
 */

exports.Equals = Equals;

function isEquals_1(u) {
  return tsplus_module_1.isHash(u) && Equals.sym in u;
}
/**
 * @tsplus static Equals.Ops sameValueZeroEqual
 */


function sameValueZeroEqual_1(a, b) {
  return a === b || a !== a && b !== b;
}

const protoMap = /*#__PURE__*/new Map([[Array.prototype, (a, b) => a.length === b.length && a.every((v, i) => equals_1(v, b[i]))], [Set.prototype, (a, b) => {
  if (a.size !== b.size) {
    return false;
  }

  for (const va of a.values()) {
    let found = false;

    for (const vb of b.values()) {
      if (equals_1(va, vb)) {
        found = true;
        break;
      }
    }

    if (!found) {
      return false;
    }
  }

  return true;
}], [Object.prototype, (a, b) => {
  if ("_tag" in a) {
    if ("_tag" in b) {
      if (a["_tag"] !== b["_tag"]) {
        return false;
      }
    } else {
      return false;
    }
  }

  const keysA = Object.keys(a).sort();
  const keysB = Object.keys(b).sort();

  if (keysA.length !== keysB.length) {
    return false;
  }

  if (!equals_1(keysA, keysB)) {
    return false;
  }

  for (const ka of keysA) {
    const va = a[ka];
    const vb = b[ka];

    if (!equals_1(va, vb)) {
      return false;
    }
  }

  return true;
}], [Map.prototype, (a, b) => {
  if (a.size !== b.size) {
    return false;
  }

  for (const [ka, va] of a.entries()) {
    let found = false;

    for (const [kb, vb] of b.entries()) {
      if (equals_1(ka, kb) && equals_1(va, vb)) {
        found = true;
        break;
      }
    }

    if (!found) {
      return false;
    }
  }

  return true;
}]]);

function equals_1(a, b) {
  if (a === b) {
    return true;
  }

  if (isEquals_1(a)) {
    if (!isEquals_1(b)) {
      return false;
    }

    if (!sameValueZeroEqual_1(tsplus_module_1.hashUnknown(a), tsplus_module_1.hashUnknown(b))) {
      return false;
    }

    return a[Equals.sym](b);
  }

  if (typeof a === "object" && typeof b === "object") {
    const protoA = Object.getPrototypeOf(a);
    const protoB = Object.getPrototypeOf(b);

    if (protoA === protoB) {
      const compare = protoMap.get(protoA);

      if (compare) {
        return compare(a, b);
      }
    }
  }

  return sameValueZeroEqual_1(a, b);
}
//# sourceMappingURL=Equals.js.map