/**
 * @tsplus type Hash.Ops
 */
export interface HashOps {
    readonly sym: unique symbol;
}
export declare const Hash: HashOps;
/**
 * @tsplus type Hash
 */
export interface Hash {
    [Hash.sym](this: this): number;
}
/**
 * @tsplus static Hash.Ops isHash
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function isHash(u: unknown): u is Hash;
/**
 * @tsplus static Hash.Ops optimize
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function optimize(n: number): number;
/**
 * @tsplus static Hash.Ops unknown
 * @tsplus getter Hash hash
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashUnknown<A>(arg: A): number;
/**
 * @tsplus static Hash.Ops array
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashArray(arr: readonly unknown[]): number;
/**
 * @tsplus static Hash.Ops map
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashMap(arr: Map<unknown, unknown>): number;
/**
 * @tsplus static Hash.Ops set
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashSet(arr: Set<unknown>): number;
/**
 * @tsplus static Hash.Ops args
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashArgs(...args: unknown[]): number;
/**
 * @tsplus static Hash.Ops combine
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function combine(a: number, b: number): number;
/**
 * @tsplus static Hash.Ops object
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashObject(value: object): number;
/**
 * @tsplus static Hash.Ops miscRef
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashMiscRef(o: Object): number;
/**
 * @tsplus static Hash.Ops iterator
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashIterator(it: Iterator<any>): number;
/**
 * @tsplus static Hash.Ops plainObject
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashPlainObject(o: object): number;
/**
 * @tsplus static Hash.Ops number
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashNumber(n: number): number;
/**
 * @tsplus static Hash.Ops string
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashString(str: string): number;
/**
 * @tsplus static Hash.Ops random
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashRandom(): number;
/**
 * @tsplus static Hash.Ops randomCached
 * @tsplus location "@tsplus/stdlib/structure/Hash"
 */
export declare function hashRandomCached(o: object): number;
//# sourceMappingURL=Hash.d.ts.map