"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isDefined = isDefined;
exports.isIterable = isIterable;
exports.isPlainObject = isPlainObject;
exports.isPromiseLike = isPromiseLike;
exports.isReactElement = isReactElement;

function isDefined(value) {
  return value !== void 0;
}

function isIterable(value) {
  return Symbol.iterator in value;
}

function isPlainObject(value) {
  return value.constructor === Object || value.constructor == null;
}

function isPromiseLike(value) {
  return !!value && typeof value.then === "function";
}

function isReactElement(value) {
  return !!(value && value.$$typeof);
}
//# sourceMappingURL=Guards.js.map